<?php

$balancesObj = new balances();

class balances {

    public Iplus $mDb;
    public array $mConfig;
    public string $dateTime;
    public string $lang_code;
    public Users $userObj;
    public Treasures $treasuresObj;

    public function __construct() {
        global $Config;

        $this->mDb = new Iplus();
        $this->treasuresObj = new Treasures();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->lang_code = LANGUAGE; // Default to 'en' if LANGUAGE is not defined
        $this->userObj = new Users();
    }

    function getPullBalanceRequests($aStart, $aLimit, $sort, $type, $searchTitle, $searchUser_id) {

        $sql = "SELECT t.* , u.user_name ,u.user_level  FROM balance_withdrawal_requests t";
        $sql .= " LEFT JOIN `users` u ON u.id = t.user_id ";

        $sql .= " WHERE t.id > 0    ";

        $sql .= $searchTitle ? ' AND (t.title like "%' . $searchTitle . '%" ||  t.id like "%' . $searchTitle . '%" ) ' : '';

        $sql .= $searchUser_id ? " AND  t.user_id =  '{$searchUser_id}'    " : '';

        $sql .= " ORDER BY t.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        // echo $sql; die();
        $res = $this->mDb->getAll($sql);

        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
                $res[$i]['pay_method'] = $this->getPay_method($res[$i]['payment_method_id']);
                $res[$i]['treasures_balances'] = $this->treasuresObj->getTreasures_balancesByType('balance_withdrawal_request', $res[$i]['id']);
                $res[$i]['treasures_balances'] = $res[$i]['treasures_balances'] ? $res[$i]['treasures_balances'] : array();
            }
        }
        return $res;
    }

    function getPay_method($payment_method_id) {
        $sql = "SELECT * FROM pay_methods   ";
        $sql .= " WHERE id = '{$payment_method_id}'  ";
        // echo $sql; die();
        return $this->mDb->getRow($sql);
    }

    function getSearchPullBalanceRequestsCount($sort, $type, $searchTitle, $searchUser_id) {
        $sql = "SELECT COUNT(DISTINCT t.`id`) as 'result_count' FROM balance_withdrawal_requests t ";

        $sql .= " WHERE t.`id` > 0";

        $sql .= $searchTitle ? ' AND ( t.title like "%' . $searchTitle . '%"  ||  t.id like "%' . $searchTitle . '%" ) ' : '';
        $sql .= $searchUser_id ? " AND  t.user_id =  '{$searchUser_id}'    " : '';

        //echo $sql; die();

        return $this->mDb->getOne($sql);
    }

    function getPullBalanceRequestsCount() {
        $sql = "SELECT COUNT(DISTINCT `id`) as 'count' FROM `balance_withdrawal_requests`";
        return $this->mDb->getOne($sql);
    }

    function addEditPullBalanceRequest($temp) {

        if ($temp['id'] === null || $temp['id'] === '') {
            // add

            $sql = "INSERT INTO `balance_withdrawal_requests` SET ";
            foreach ($this->mDb->getCols('balance_withdrawal_requests', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'lang_parameter') ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$this->dateTime}'";
            //  echo "$sql";die();
            $res = $this->mDb->query($sql);

            if ($res) {
                $id = $this->mDb->getLastInsertId();
                $balance['user_id'] = $temp['user_id'];
                $balance['for_id'] = $id;
                $balance['value'] = $temp['amount'];
                $balance['treasure_id'] = '0';
                $balance['transaction'] = 'balance_withdrawal_request_pending';
                $this->userObj->addBalance($balance);
            }
            return $res;
        }
        // else {
        // 	$sql = "UPDATE `balances` SET ";
        // 	foreach ($this->mDb->getCols('balances', $temp)  as $k => $v) {
        // 		$sql .= ($k == 'lang_Details' || $k == 'id' || $k == 'lang_parameter') ? "" : "`{$k}`='{$v}',";
        // 	}
        // 	$sql = substr($sql, 0, -1);
        // 	$sql .= " WHERE `id` = '{$temp['id']}'";
        // 	$res = $this->mDb->query($sql);
        // 	if ($res) {
        // 		//delete lang_details
        // 		$sql = "DELETE FROM `pullBalanceRequest_langs` ";
        // 		$sql .= " WHERE pullBalanceRequest_id='{$temp['id']}'  ";
        // 		$res2 = $this->mDb->query($sql);
        // 		//enter lang_details
        // 		foreach ($temp['lang_Details'] as $k => $v) {
        // 			$sql = " INSERT INTO `pullBalanceRequest_langs` SET  lang_code = '{$v['lang_code']}' , title = '{$v['details']['title']}'   ,pullBalanceRequest_id='{$temp['id']}' ";
        // 			// echo "$sql";die();
        // 			$res2 = $this->mDb->query($sql);
        // 		}
        // 		# code...
        // 	}
        // 	return $res;
        // }
    }

    function getOnePullBalanceRequest($id) {
        $sql = "SELECT * FROM `balance_withdrawal_requests`";
        $sql .= " WHERE `id` = '{$id}' ";
        $res = $this->mDb->getRow($sql);
        // echo "<pre>";print_r($res);die();
        return $res;
    }

    function deletePullBalanceRequest($ids) {
        $sql = "DELETE FROM `balance_withdrawal_requests` ";
        $sql .= " WHERE `id` = 0";
        foreach ($ids as $id) {
            $this->userObj->deleteBalanceByParams('balance_withdrawal_request_pending', $id);
            $sql .= " || `id` = '{$id}' ";
        }

        return $this->mDb->query($sql);
    }

    public function deleteBalances($ids) {
        $sql = "DELETE FROM `user_balances` ";
        $sql .= " WHERE `id` = 0";
        foreach ($ids as $id) {
            $sql .= " || `id` = '{$id}' ";
        }

        return $this->mDb->query($sql);
    }

    public function getBalances($aStart, $aLimit, $sort, $type, $searchDateFrom, $searchDateTo, $searchUser_id) {

        $sql = "SELECT t.*  , u.user_name  , u.user_level  FROM user_balances t";

        $sql .= " LEFT JOIN `users` u ON u.id = t.user_id ";
        $sql .= " WHERE t.id > 0    ";
        $sql .= $searchUser_id ? " AND  t.user_id =  '{$searchUser_id}'    " : '';

        $sql .= $searchDateFrom ? " AND t.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND t.`date_added`  <= '{$searchDateTo}' " : "";
        $sql .= " ORDER BY t.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        $res = $this->mDb->getAll($sql);
        if ($res) {
            // for ($i = 0; $i < count($res); $i++) {
            // 	if (
            // 		$res[$i]['transaction'] == 'order_commission_pay' ||
            // 		$res[$i]['transaction'] == 'order_merchant_supply_pay' ||
            // 		$res[$i]['transaction'] == 'order_commission_pending' ||
            // 		$res[$i]['transaction'] == 'order_merchant_supply_pending' ||
            // 		$res[$i]['transaction'] == 'order_commission_refund_dept' ||
            // 		$res[$i]['transaction'] == 'order_merchant_refund_dept'
            // 	) {
            // 		$res[$i]['order_products'] = $this->getOrderProducts($res[$i]['for_id']);
            // 	}
            // }
        }

        //  echo $sql; die();
        return $res;
    }

    // public function getOrderProducts($order_id)
    // {
    // 	$sql = "SELECT `op`.*, `pl`.name , ps.name as product_store_name FROM `order_products` op ";
    // 	$sql .= " LEFT JOIN `products` p ON p.id = op.product_id";
    // 	$sql .= " LEFT JOIN `product_langs` pl ON pl.product_id = p.id";
    // 	$sql .= " LEFT JOIN `product_stores` ps ON ps.id = op.product_store_id";
    // 	$sql .= " WHERE op.order_id = '{$order_id}' group by op.id   ";
    // 	//   echo "<pre>";print_r($sql);die();
    // 	$res = $this->mDb->getAll($sql);
    // 	return $res;
    // }
    public function getSearchBalancesCount($searchDateFrom, $searchDateTo, $searchUser_id) {
        $sql = "SELECT COUNT(DISTINCT t.`id`) as 'result_count' FROM user_balances t ";
        $sql .= " WHERE t.`id` > 0";
        $sql .= $searchUser_id ? " AND  t.user_id =  '{$searchUser_id}'    " : '';
        $sql .= $searchDateFrom ? " AND t.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND t.`date_added`  <= '{$searchDateTo}' " : "";
        // echo $sql;
        // die();

        return $this->mDb->getOne($sql);
    }

    // /////////////////////////      Payment_method         // //////////////////////     
    function addEditPayment_method($temp) {

        if ($temp['id'] === null || $temp['id'] === '') {
            // add

            $sql = "INSERT INTO `pay_methods` SET ";
            foreach ($this->mDb->getCols('pay_methods', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'lang_parameter') ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$this->dateTime}'";
            // echo "$sql";die();
            $res = $this->mDb->query($sql);

            return $res;
        }
        // else{
        // 	$sql = "UPDATE `balances` SET "; 
        // 	foreach ($this->mDb->getCols('balances', $temp)  as $k => $v) {
        // 		  $sql .= ($k == 'lang_Details' || $k == 'id' || $k == 'lang_parameter'  ) ? "" : "`{$k}`='{$v}',";
        // 	}
        // 	$sql = substr($sql, 0, -1);
        // 	$sql .= " WHERE `id` = '{$temp['id']}'"; 
        // 	$res = $this -> mDb -> query($sql); 
        //  	if ($res) {
        //  	    //delete lang_details
        //  		 $sql = "DELETE FROM `pullBalanceRequest_langs` ";
        //          $sql.= " WHERE pullBalanceRequest_id='{$temp['id']}'  ";
        // 	     $res2 = $this -> mDb -> query($sql); 
        // 		//enter lang_details
        // 		foreach ($temp['lang_Details'] as $k => $v) {
        // 	 	  $sql = " INSERT INTO `pullBalanceRequest_langs` SET  lang_code = '{$v['lang_code']}' , title = '{$v['details']['title']}'   ,pullBalanceRequest_id='{$temp['id']}' " ;
        // 	 	  // echo "$sql";die();
        // 	 	  $res2 = $this -> mDb -> query($sql); 
        // 		}
        // 		# code...
        // 	}
        // 	return $res; 
        // }
    }

    function getPayment_methods($searchMethodName, $searchUser_id) {

        $sql = "SELECT * FROM pay_methods   ";

        $sql .= " WHERE id > 0  ";

        $sql .= $searchMethodName ? ' AND (name like "%' . $searchMethodName . '%" ) ' : '';

        $sql .= $searchUser_id ? " AND  user_id = '{$searchUser_id}' " : '';

        // echo $sql; die();
        return $this->mDb->getAll($sql);
    }

    //////////////////////////////////// ///////////////////////////////////////



    public function changePullBalanceRequestStatus($ids, $status, $treasure_id) {
        $sql = "UPDATE `balance_withdrawal_requests` SET `status` = '{$status}' ";
        $sql .= " WHERE `id` < 0  ";
        foreach ($ids as $id) {
            $data = $this->getOnePullBalanceRequest($id);
            if ($status == 'done') {
                $this->UpdatePullBalanceRequestProcess($data, $treasure_id);
            }
        }
        $sql .= " || `id` = '{$id}' ";
        //   echo "$sql";die();
        return $this->mDb->query($sql);
    }

    public function UpdatePullBalanceRequestProcess($temp, $treasure_id) {
        // echo "<pre>"; print_r($temp); die();
        if ($temp['status'] != 'done') {
            // last data
            $balance['user_id'] = $temp['user_id'];
            $balance['for_id'] = $temp['id'];
            $balance['value'] = $temp['amount'];
            $balance['transaction'] = 'balance_withdrawal_request_pending';
            $res = $this->userObj->updateBalance($balance, 'balance_withdrawal_request_dept', 'dept');

            $treasures_balances['type'] = 'remove';
            $treasures_balances['note'] = 'طلب سحب رصيد رقم : ' . $temp['id'];
            $treasures_balances['for_id'] = $temp['id'];
            $treasures_balances['for_type'] = 'balance_withdrawal_request';
            $treasures_balances['balance'] = $temp['amount'];
            $treasures_balances['admin_id'] = '41';
            $this->treasuresObj->addTreasures_balances($treasure_id, $treasures_balances);
        }
    }

    public function getBalancesAccountStatements($aStart, $aLimit, $sort, $type, $searchUser_id, $searchDateFrom, $searchDateTo, $searchInvoiceNumber, $searchTransaction, $searchTreasure_id, $searchAccount_type) {

        if ($searchAccount_type == 'clients') {
            $sql = "SELECT t.* , u.user_name AS 'addedBy' , tr.name  as treasure_name ,i.pay_type , t.for_id as invoice_id , i.count_invoice_type   , v.count_voucher_type FROM user_balances t ";
            $sql .= " LEFT JOIN `treasures` tr ON tr.id = t.treasure_id ";
            $sql .= " LEFT JOIN `invoices` i ON i.id = t.for_id ";
            $sql .= " LEFT JOIN `vouchers` v ON v.id = t.for_id ";

            $sql .= " LEFT JOIN `users` u ON i.id = i.admin_id ";

            $sql .= " WHERE ( t.`transaction_type` = 'pay' || t.`transaction_type` = 'dept' )  ";
            $sql .= $searchInvoiceNumber ? " AND ( t.`for_id` =   '{$searchInvoiceNumber}'   ) " : "";

            $sql .= $searchTransaction == 'sale-invoice-later' ? " AND ( t.`transaction` =   'sale_invoice_dept'   AND  i.`pay_type` =   'later'     ) " : "";
            $sql .= $searchTransaction == 'sale-invoice-cash' ? " AND ( t.`transaction` =   'sale_invoice_dept'   AND  i.`pay_type` =   'cash'     ) " : "";
            $sql .= $searchTransaction == 'sale-return-invoice' ? " AND ( t.`transaction` =   'sale_return_invoice_pay'   ) " : "";

            $sql .= $searchTransaction == 'receipt-invoice-later' ? " AND ( t.`transaction` =   'receipt_invoice_pay'   AND  i.`pay_type` =   'later'     ) " : "";
            $sql .= $searchTransaction == 'receipt-invoice-cash' ? " AND ( t.`transaction` =   'receipt_invoice_pay'   AND  i.`pay_type` =   'cash'     ) " : "";
            $sql .= $searchTransaction == 'receipt-return-invoice' ? " AND ( t.`transaction` =   'receipt_return_invoice_dept'   ) " : "";

            $sql .= $searchTransaction == 'get-voucher' ? " AND ( t.`transaction` =   'get_voucher_pay'   ) " : "";
            $sql .= $searchTransaction == 'cashing-voucher' ? " AND ( t.`transaction` =  'cashing_voucher_dept'   ) " : "";
        } else if ($searchAccount_type == 'merchants') {
            $sql = "SELECT t.* , tr.name  as treasure_name , v.count_voucher_type  FROM user_balances t ";
            $sql .= " LEFT JOIN `treasures` tr ON tr.id = t.treasure_id ";
            $sql .= " LEFT JOIN `vouchers` v ON v.id = t.for_id ";
            $sql .= " WHERE ( t.`transaction_type` = 'pay' || t.`transaction_type` = 'dept' )  ";
            $sql .= $searchTransaction == 'order_delivered' ? " AND   (t.`transaction` = 'order_merchant_supply_pay' )" : '';
            $sql .= $searchTransaction == 'order_refund' ? " AND   (t.`transaction` = 'order_merchant_refund_dept' )" : '';

            $sql .= $searchTransaction == 'balance_withdrawal_request_pay' ? " AND   (t.`transaction` = 'balance_withdrawal_request_pay' )" : '';
            $sql .= $searchTransaction == 'get-voucher' ? " AND ( t.`transaction` =   'get_voucher_pay'   ) " : "";
            $sql .= $searchTransaction == 'cashing-voucher' ? " AND ( t.`transaction` =  'cashing_voucher_dept'   ) " : "";
        } else if ($searchAccount_type == 'affiliators') {
            $sql = "SELECT t.*  , tr.name  as treasure_name  , v.count_voucher_type FROM user_balances t ";
            $sql .= " LEFT JOIN `treasures` tr ON tr.id = t.treasure_id ";
            $sql .= " LEFT JOIN `vouchers` v ON v.id = t.for_id ";

            $sql .= " WHERE ( t.`transaction_type` = 'pay' || t.`transaction_type` = 'dept' )  ";
            $sql .= $searchTransaction == 'order_delivered' ? " AND   (t.`transaction` = 'order_commission_pay'  )" : '';
            $sql .= $searchTransaction == 'order_refund' ? " AND   (t.`transaction` = 'order_commission_refund_dept' )" : '';

            $sql .= $searchTransaction == 'balance_withdrawal_request_pay' ? " AND   (t.`transaction` = 'balance_withdrawal_request_pay' )" : '';
            $sql .= $searchTransaction == 'get-voucher' ? " AND ( t.`transaction` =   'get_voucher_pay'   ) " : "";
            $sql .= $searchTransaction == 'cashing-voucher' ? " AND ( t.`transaction` =  'cashing_voucher_dept'   ) " : "";
        }



        $sql .= $searchUser_id ? " AND ( t.`user_id` =   '{$searchUser_id}' ) " : "";
        $sql .= $searchTreasure_id ? " AND ( t.`treasure_id` =   '{$searchTreasure_id}'   ) " : "";

        $sql .= $searchDateFrom ? " AND t.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND t.`date_added`  <= '{$searchDateTo}' " : "";
        $sql .= " ORDER BY t.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        $res = $this->mDb->getAll($sql);
        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
                $res[$i]['balance_value'] = $this->userObj->get_balanceBySomeData($res[$i]['user_id'], $res[$i]['id']);
            }
        }
        // echo $sql;
        // die();
        return $res;
    }

    public function getBalancesAccountStatementsCount($searchUser_id, $searchDateFrom, $searchDateTo, $searchInvoiceNumber, $searchTransaction, $searchTreasure_id, $searchAccount_type) {

        if ($searchAccount_type == 'clients') {
            $sql = "SELECT count(t.id) FROM user_balances t ";
            $sql .= " LEFT JOIN `invoices` i ON i.id = t.for_id ";

            $sql .= " WHERE ( t.`transaction_type` = 'pay' || t.`transaction_type` = 'dept' )  ";
            $sql .= $searchInvoiceNumber ? " AND ( t.`for_id` =   '{$searchInvoiceNumber}'   ) " : "";

            $sql .= $searchTransaction == 'sale-invoice-later' ? " AND ( t.`transaction` =   'sale_invoice_dept'   AND  i.`pay_type` =   'later'     ) " : "";
            $sql .= $searchTransaction == 'sale-invoice-cash' ? " AND ( t.`transaction` =   'sale_invoice_dept'   AND  i.`pay_type` =   'cash'     ) " : "";
            $sql .= $searchTransaction == 'sale-return-invoice' ? " AND ( t.`transaction` =   'sale_return_invoice_pay'   ) " : "";

            $sql .= $searchTransaction == 'receipt-invoice-later' ? " AND ( t.`transaction` =   'receipt_invoice_pay'   AND  i.`pay_type` =   'later'     ) " : "";
            $sql .= $searchTransaction == 'receipt-invoice-cash' ? " AND ( t.`transaction` =   'receipt_invoice_pay'   AND  i.`pay_type` =   'cash'     ) " : "";
            $sql .= $searchTransaction == 'receipt-return-invoice' ? " AND ( t.`transaction` =   'receipt_return_invoice_dept'   ) " : "";

            $sql .= $searchTransaction == 'get-voucher' ? " AND ( t.`transaction` =   'get_voucher_pay'   ) " : "";
            $sql .= $searchTransaction == 'cashing-voucher' ? " AND ( t.`transaction` =  'cashing_voucher_dept'   ) " : "";
        } else if ($searchAccount_type == 'merchants') {
            $sql = "SELECT count(t.id) FROM user_balances t ";

            $sql .= " WHERE ( t.`transaction_type` = 'pay' || t.`transaction_type` = 'dept' )  ";
            $sql .= $searchTransaction == 'order_delivered' ? " AND   (t.`transaction` = 'order_merchant_supply_pay' )" : '';
            $sql .= $searchTransaction == 'order_refund' ? " AND   (t.`transaction` = 'order_merchant_refund_dept' )" : '';
            $sql .= $searchTransaction == 'balance_withdrawal_request_pay' ? " AND   (t.`transaction` = 'balance_withdrawal_request_pay' )" : '';
            $sql .= $searchTransaction == 'get-voucher' ? " AND ( t.`transaction` =   'get_voucher_pay'   ) " : "";
            $sql .= $searchTransaction == 'cashing-voucher' ? " AND ( t.`transaction` =  'cashing_voucher_dept'   ) " : "";
        } else if ($searchAccount_type == 'affiliators') {
            $sql = "SELECT count(t.id) FROM user_balances t ";

            $sql .= " WHERE ( t.`transaction_type` = 'pay' || t.`transaction_type` = 'dept' )  ";
            $sql .= $searchTransaction == 'order_delivered' ? " AND   (t.`transaction` = 'order_commission_pay'  )" : '';
            $sql .= $searchTransaction == 'order_refund' ? " AND   (t.`transaction` = 'order_commission_refund_dept' )" : '';
            $sql .= $searchTransaction == 'balance_withdrawal_request_pay' ? " AND   (t.`transaction` = 'balance_withdrawal_request_pay' )" : '';
            $sql .= $searchTransaction == 'get-voucher' ? " AND ( t.`transaction` =   'get_voucher_pay'   ) " : "";
            $sql .= $searchTransaction == 'cashing-voucher' ? " AND ( t.`transaction` =  'cashing_voucher_dept'   ) " : "";
        }


        $sql .= $searchUser_id ? " AND ( t.`user_id` =   '{$searchUser_id}' )  " : "";
        $sql .= $searchTreasure_id ? " AND ( t.`treasure_id` =   '{$searchTreasure_id}'   ) " : "";

        $sql .= $searchDateFrom ? " AND t.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND t.`date_added`  <= '{$searchDateTo}' " : "";
        //    echo $sql; die();

        return $this->mDb->getOne($sql);
    }

    public function getBalancesPricesAccount(
            $aStart, $aLimit, $sort, $type, $searchUser_id, $searchDateFrom, $searchDateTo, $searchInvoiceNumber, $searchTransaction, $searchTreasure_id, $searchAccount_type, $searchClient_price_type, $searchClient_store_id, $search_balances_zero
    ) {

        $sql = "SELECT t.* , u.user_name, u.last_name  , u.mobile ,u.user_level ,u.id as user_id ,u.email ,u.address ,u.brief  ,u.price_type , u.set_from ";
        $sql .= " ,COALESCE(SUM(CASE WHEN t.transaction_type ='pay' THEN t.value ELSE 0 END), 0) AS balance_value_pay";
        $sql .= " ,COALESCE(SUM(CASE WHEN t.transaction_type ='dept' THEN t.value ELSE 0 END), 0) AS balance_value_dept";
        $sql .= " ,(COALESCE(SUM(CASE WHEN t.transaction_type ='pay' THEN t.value ELSE 0 END), 0) - COALESCE(SUM(CASE WHEN t.transaction_type ='dept' THEN t.value ELSE 0 END), 0)) AS balance_value_total ";

        $sql .= " FROM users u ";
        $sql .= " LEFT JOIN `user_balances` t ON u.id = t.user_id ";

        $sql .= " WHERE  ( u.`user_level` =   '3000'
		 || u.`user_level` =   '1000' 
		|| u.`user_level` =   '2000' )    ";

        $sql .= $searchAccount_type == 'clients' ? " AND ( u.`user_level` =   '3000' ) " : "";
        $sql .= $searchAccount_type == 'affiliators' ? " AND ( u.`user_level` =   '1000' ) " : "";
        $sql .= $searchAccount_type == 'merchants' ? " AND ( u.`user_level` =   '2000' ) " : "";

        $sql .= $searchUser_id ? " AND ( t.`user_id` =   '{$searchUser_id}' ) " : "";
        $sql .= $searchDateFrom ? " AND t.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND t.`date_added`  <= '{$searchDateTo}' " : "";

        $sql .= $searchAccount_type == 'clients' && $searchClient_price_type ? " AND u.`price_type`  = '{$searchClient_price_type}'  " : '';
        $sql .= $searchAccount_type == 'clients' && ($searchClient_store_id === '0' || $searchClient_store_id) ? " AND u.`client_store_id`  = '{$searchClient_store_id}'  " : '';
        $sql .= "Group by u.id ";
        $sql .= $search_balances_zero == 'hide_zero' ? " HAVING balance_value_total != 0 " : "";
        $sql .= " ORDER BY t.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
//        echo $sql . "<hr>";
        $res = $this->mDb->getAll($sql);
        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
//				$res[$i]['balance_value_pay'] = $this->userObj->get_balanceByTransaction_typeAndUser_id('pay', $res[$i]['user_id']);
//				$res[$i]['balance_value_dept'] = $this->userObj->get_balanceByTransaction_typeAndUser_id('dept', $res[$i]['user_id']);
//				$res[$i]['balance_value_total'] = 	$res[$i]['balance_value_pay'] - $res[$i]['balance_value_dept'];
                // if ($searchAccount_type === "clients") {
                $data_client = $this->userObj->getPrice_typeGroupName($res[$i]['price_type']);

                $res[$i]['price_type_name'] = $data_client['price_type_name'];
                $res[$i]['client_open_cart_name'] = $data_client['client_open_cart_name'];
                // }
            }
        }

        // echo $sql;
        // die();
        return $res;
    }

    public function getBalancesPricesAccountCount(
            $searchUser_id, $searchDateFrom, $searchDateTo, $searchInvoiceNumber, $searchTransaction, $searchTreasure_id, $searchAccount_type, $searchClient_price_type, $searchClient_store_id, $search_balances_zero
    ) {
        $sql = "SELECT count(t.user_id) ";
        $sql .= $search_balances_zero == 'hide_zero' ? " ,(COALESCE(SUM(CASE WHEN t.transaction_type ='pay' THEN t.value ELSE 0 END), 0) - COALESCE(SUM(CASE WHEN t.transaction_type ='dept' THEN t.value ELSE 0 END), 0)) AS balance_value_total " : "";
        $sql .= " FROM users u  ";
        $sql .= " LEFT JOIN `user_balances` t ON u.id = t.user_id ";

        $sql .= " WHERE ( u.`user_level` =   '3000'
		|| u.`user_level` =   '1000' 
	   || u.`user_level` =   '2000' )  ";

        $sql .= $searchAccount_type == 'clients' ? " AND ( u.`user_level` =   '3000' ) " : "";
        $sql .= $searchAccount_type == 'affiliators' ? " AND ( u.`user_level` =   '1000' ) " : "";
        $sql .= $searchAccount_type == 'merchants' ? " AND ( u.`user_level` =   '2000' ) " : "";
        $sql .= $searchUser_id ? " AND ( t.`user_id` =   '{$searchUser_id}' )  " : "";

        $sql .= $searchAccount_type == 'clients' && $searchClient_price_type ? " AND u.`price_type`  = '{$searchClient_price_type}'  " : '';
        $sql .= $searchAccount_type == 'clients' && ($searchClient_store_id === '0' || $searchClient_store_id) ? " AND u.`client_store_id`  = '{$searchClient_store_id}'  " : '';
        $sql .= $searchDateFrom ? " AND t.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND t.`date_added`  <= '{$searchDateTo}' " : "";
        $sql .= "Group by u.id   ";
        $sql .= $search_balances_zero == 'hide_zero' ? " HAVING balance_value_total != 0 " : "";
//        echo $sql . "<hr>";
        $res = $this->mDb->getAll($sql);
        return count($res);
    }
}
