<?php

$dealersPlansObj = new dealersPlans();

class dealersPlans {

    var $mDb;
    var $mConfig;

    function __construct() {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
    }

    function getColumnName() {
        return $this->mDb->getColumnName("master_dealers_plans");
    }

    function getSomeDealersPlans($aStart, $aLimit, $sort, $type, $searchName) {
        $sql = "SELECT l.id, l.name, l.date_added, u.user_name AS 'added_by' FROM `master_dealers_plans` l";
        $sql .= " LEFT JOIN `users` u ON u.id = l.admin_id ";
        $sql.= " WHERE l.id > 0  ";

        $sql.= $searchName ? ' AND l.name like "%' . $searchName . '%"' : '';

        $sql .= " ORDER BY l.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

        // echo $sql; die();

        return $this->mDb->getAll($sql);
    }

    function getSearchDealersPlansCount($sort, $type, $searchName) {
        $sql = "SELECT COUNT(DISTINCT `id`) as 'result_count' FROM `master_dealers_plans`";
        $sql.= " WHERE `id` > 0 ";

        $sql.= $searchName ? ' AND `name` like "%' . $searchName . '%"' : '';

        $sql .= " ORDER BY {$sort} {$type}";

        //echo $sql; die();

        return $this->mDb->getOne($sql);
    }

    function getDealersPlansCount() {
        $sql = "SELECT COUNT(DISTINCT `id`) as 'count' FROM `master_dealers_plans`";
        return $this->mDb->getOne($sql);
    }

    function addEditDealersPlan($temp) {

        // print_r($temp); die();

        if ($temp['id'] === null || $temp['id'] === '') {
            // add
            unset($temp['id']);

            $dateTime = date('Y-m-d H:i:s');

            $sql = "INSERT INTO `master_dealers_plans` SET ";
            foreach ($this->mDb->getCols('master_dealers_plans', $temp) as $k => $v) {
                $v = $v ? $v : "0";
                $sql .= "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$dateTime}'";
            $res = $this->mDb->query($sql);
            return $res;
        } else {
            // edit
            $sql = "UPDATE `master_dealers_plans` SET ";
            foreach ($this->mDb->getCols('master_dealers_plans', $temp) as $k => $v) {
                $v = $v ? $v : "0";
                $sql .= "`{$k}`='{$v}',";
            }
            $sql = substr($sql, 0, -1);
            $sql .= " WHERE `id` = '{$temp['id']}'";
            // echo "	$sql ";die();
            $res = $this->mDb->query($sql);
            return $res;
        }
    }

    public function cheackIfExitByField($value, $field, $id) {
        $sql = "SELECT  id FROM `master_dealers_plans`   ";
        $sql .= " WHERE {$field} = '{$value}'  ";
        $sql .= $id ? " AND id != '{$id}' " : '';
        //  echo $sql; die();
        return $this->mDb->getOne($sql);
    }

    function getOneDealersPlan($id) {
        $sql = "SELECT * FROM `master_dealers_plans`";
        $sql .= " WHERE `id` = '$id' ";
        $res = $this->mDb->getRow($sql);
        $return = array();
        foreach ($res as $key => $value) {
            if ($key && $key != 'id' && $key != 'admin_id' && $key != 'date_added') {
                $arr = explode("_", $key);
                $arrpop = $arr;
                array_pop($arrpop);
                $arrpop = implode("_", $arrpop);
                $i = array_search(reset($arr), array_column($return, 'mode'));
                if ($i > -1 && end($arr) !== 'show') {

                    $i3 = array_search($arrpop, array_column($return[$i]['options'], 'mode'));
                    if ($i3 > -1) {
                        $return[$i]['options'][$i3][$key] = $value;
                    } else {
                        $options = array();
                        $options['mode'] = $arrpop;
                        $options[$key] = $value;
                        array_push($return[$i]['options'], $options);
                    }
                } else {
                    if (end($arr) == 'show') {
                        $i2 = array_search(reset($arr), array_column($return, 'mode'));
                        if ($i2 > -1) {
                            $return[$i2][$key] = $value;
                        } else {
                            array_push($return, ["mode" => reset($arr), $key => $value, "options" => array()]);
                        }
                    } else {
                        array_push($return, ["mode" => reset($arr), $key => $value, "options" => array()]);
                    }
                }
            }
        }
        return $return;
    }

    function deleteDealersPlan($ids) {
        $sql = "DELETE FROM `master_dealers_plans` ";
        $sql.= " WHERE `id` = 0";
        foreach ($ids as $id) {
            $sql .= " || `id` = '{$id}' ";
        }

        $res = $this->mDb->query($sql);
        return $res;
    }

}
