<?php

$formShapesObj = new form_shapes();

class form_shapes {

    public Iplus $mDb;
    public array $mConfig;
    public string $dateTime;
    public string $lang_code;

    public function __construct() {
        global $Config;

        $this->mDb = new Iplus();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->lang_code =   LANGUAGE  ; 
    }

    function getFormShapesByParams(
            $aStart, $aLimit, $sort, $type, $searchName, $parent_id, $service_type, $serviceStatus
    ) {




        // echo "$parent_id";die();
        $sql = "SELECT fs.* ,  u.user_name AS 'addedBy'  , fsl.label FROM form_shapes fs ";
        $sql .= " LEFT JOIN `users` u ON u.id = fs.admin_id ";
        $sql .= " LEFT JOIN `form_shape_langs` fsl ON fs.id = fsl.form_shape_id ";

        $sql .= " WHERE fs.id > 0 AND fsl.lang_code = '{$this->lang_code}'  and fs.is_deleted = '0'  ";
        $sql .= $searchName ? ' AND (fsl.label like "%' . $searchName . '%" ) ' : '';
//        $sql .= " AND fs.active = '1' ";

        $sql .= " Group by fs.id ORDER BY fs.{$sort} {$type} ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        //   echo $sql; die();

        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {

            $res[$i]['ser_name'] = $this->getAllServicesNameOfForm_shapeById($res[$i]['id']);
        }
        return $res;
    }

    function getSearchFormShapesCount(
            $sort, $type, $searchName, $parent_id, $service_type, $serviceStatus
    ) {


        $sql = "SELECT COUNT(DISTINCT fs.id) as 'result_count' FROM form_shapes fs ";
        $sql .= " LEFT JOIN `form_shape_langs` fsl ON fs.id = fsl.form_shape_id ";

        $sql .= " WHERE fs.id > 0 AND fsl.lang_code = '{$this->lang_code}' and fs.is_deleted = '0'  ";

        $sql .= $searchName ? ' AND (fsl.label like "%' . $searchName . '%" ) ' : '';
        $sql .= ($serviceStatus === '0' || $serviceStatus) ? " AND fs.active = '{$serviceStatus}' " : ' ';

        // echo $sql; die();

        return $this->mDb->getOne($sql);
    }

    function addEditFormShape($temp) {

        $temp['active'] = $temp['active'] ? '1' : '0';
        $temp['quick_access_page'] = $temp['quick_access_page'] ? '1' : '0';
        $temp['sort'] = $temp['sort'] ? $temp['sort'] : '0';
        $temp['is_deleted'] = $temp['is_deleted'] == true || $temp['is_deleted'] == '1' ? $temp['is_deleted'] : '0';

        if ($temp['id'] === null || $temp['id'] === '') {
            // add

            $sql = "INSERT INTO `form_shapes` SET ";
            foreach ($this->mDb->getCols('form_shapes', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'lang_parameter') ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$this->dateTime}'";
            //   echo "$sql";die();
            $res = $this->mDb->query($sql);
            if ($res) {
                $id = $this->mDb->getLastInsertId();
                //enter lang_details
                foreach ($temp['lang_Details'] as $k => $v) {
                    $sql = " INSERT INTO `form_shape_langs` SET  lang_code = '{$v['lang_code']}' , label = '{$v['details']['label']}'  ,form_shape_id  = '{$id}' ";
                    //   echo "$sql";die();
                    $this->mDb->query($sql);
                }
                $this->addEditOptions($id, $temp['lang_Details']);

                $this->deleteForm_shape_services($id);
                $this->addForm_shape_services($temp['form_shape_services'], $id);
            }
            return $res;
        } else {
            $sql = "UPDATE `form_shapes` SET ";
            foreach ($this->mDb->getCols('form_shapes', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'id' || $k == 'lang_parameter') ? "" : "`{$k}`='{$v}',";
            }
            $sql = substr($sql, 0, -1);
            $sql .= " WHERE `id` = '{$temp['id']}'";
            $res = $this->mDb->query($sql);
            if ($res) {

                //delete lang_details
                $sql = "DELETE FROM `form_shape_langs` ";
                $sql .= " WHERE form_shape_id='{$temp['id']}'  ";
                $this->mDb->query($sql);

                //enter lang_details
                foreach ($temp['lang_Details'] as $k => $v) {
                    $sql = " INSERT INTO `form_shape_langs` SET  lang_code = '{$v['lang_code']}' , label = '{$v['details']['label']}'  ,form_shape_id  = '{$temp['id']}' ";
                    // echo "$sql";die();
                    $this->mDb->query($sql);
                    //	$this->addEditOptions($v['lang_code'], $v['details']['options']);
                }
                # code...

                $this->addEditOptions($temp['id'], $temp['lang_Details']);

                $this->deleteForm_shape_services($temp['id']);
                $this->addForm_shape_services($temp['form_shape_services'], $temp['id']);
            }

            return $res;
        }
    }

    public function deleteForm_shape_services($form_shape_id) {
        $sql = "DELETE From `{$this->mPrefix}form_shape_services`   ";
        $sql .= "where form_shape_id ='{$form_shape_id}'   ";
        $this->mDb->query($sql);
    }

    public function addForm_shape_services($form_shape_services, $form_shape_id) {
        if (count($form_shape_services) > 0) {

            foreach ($form_shape_services as $k => $v) {
                if ($v) {
                    $sql = "INSERT INTO `{$this->mPrefix}form_shape_services` SET ";
                    $sql .= " form_shape_id ='{$form_shape_id}' ,  service_id ='{$v['id']}'  ";
                    // echo $sql;
                    $this->mDb->query($sql);
                }
            }
        }
    }

    function getFormShapeOptions($form_shape_id) {
        $sql = "SELECT * FROM `form_shape_options`";
        $sql .= " WHERE `form_shape_id` = '{$form_shape_id}' and is_deleted = '0' order by sort asc ";
        $res = $this->mDb->getAll($sql);
        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
                $sql = "SELECT lang_code ,label , form_shape_option_id as id FROM `form_shape_option_langs`";
                $sql .= " WHERE `form_shape_option_id` = '{$res[$i]['id']}' ";
                // echo $sql;
                $res[$i]['lang_parameter'] = $this->mDb->getAll($sql);
            }
        }
        // echo "<pre>";print_r($res);die();  
        return $res;
    }

    function getFormShapeOptionsType($form_shape_id) {

        $sql = "SELECT f.id  ,f.type  , fl.label FROM `form_shapes` f  ";

        $sql .= " LEFT JOIN `form_shape_langs` fl ON f.id = fl.form_shape_id  AND fl.lang_code = '{$this->lang_code}' ";
        $sql .= " where f.id='{$form_shape_id}' and f.is_deleted = '0' and f.active = '1' Group By f.id  ORDER BY f.sort ";
//       echo $sql."<hr>";
        $form_shape = $this->mDb->getRow($sql);

//	p($sql);


        $sql = "SELECT  fo.id as value , fol.label   FROM `form_shape_options` fo ";
        $sql .= " LEFT JOIN `form_shape_option_langs` fol ON fo.id = fol.form_shape_option_id AND fol.lang_code = '{$this->lang_code}' ";
        $sql .= " WHERE fo.form_shape_id = '{$form_shape['id']}' and fo.is_deleted = '0' ";
        $sql .= " order by fo.sort asc ";
//          echo $sql."<hr>";
        $form_shape['options'] = $this->mDb->getAll($sql);

        return $form_shape;

//	 $sql = "SELECT  fo.id as value , fol.label   FROM `form_shape_options` fo ";
//            $sql .= " LEFT JOIN `form_shape_option_langs` fol ON fo.id = fol.form_shape_option_id AND fol.lang_code = '{$this->lang_code}' ";
//            $sql .= " WHERE fo.form_shape_id = '{$form_shape_id}' and fo.is_deleted = '0' ";
//            $sql .= " order by fo.sort asc ";
////          echo $sql."<hr>";
//         return $this->mDb->getAll($sql);
    }

    function getOneFormShape($id) {
        $sql = "SELECT * FROM `form_shapes`";
        $sql .= " WHERE `id` = '{$id}' and is_deleted = '0'  ";
        $res = $this->mDb->getRow($sql);
        if ($res) {
            $sql = "SELECT lang_code ,label FROM `form_shape_langs`";
            $sql .= " WHERE `form_shape_id` = '{$id}' ";
            $res['lang_parameter'] = $this->mDb->getAll($sql);
            $res['options'] = $this->getFormShapeOptions($id);
            $res['form_shape_services'] = $this->getForm_shape_services($id);
        }
        // echo "<pre>";print_r($res);die();  
        return $res;
    }

    public function getForm_shape_services($id) {

        $sql = "SELECT fsl.ser_name , fsl.service_id as id  FROM `form_shape_services` a_s ";
        $sql .= " LEFT JOIN `service_langs` fsl ON a_s.service_id = fsl.service_id AND fsl.lang_code = '{$this->lang_code}' ";
        $sql .= " WHERE   a_s.form_shape_id  ='{$id}'     ";
        $res = $this->mDb->getAll($sql);
        //  echo $sql;
        //   die();
        return $res ? $res : array();
    }

    function deleteFormShape($ids) {

        $sql = "UPDATE form_shapes  set  is_deleted = '1' ";
        $sql .= " WHERE `id` = 0";
        foreach ($ids as $id) {
            $sql .= " || `id` = '{$id}' ";
        }
        // echo "$sql";die();

        return $this->mDb->query($sql);
    }

    public function addEditOptions($parent_id, $form_shape_options) {


//        p($form_shape_options);


        $options = array();
        //    p($form_shape_options);
        for ($language = 0; $language < count($form_shape_options); $language++) {
            for ($i = 0; $i < count($form_shape_options[0]['details']['options']); $i++) {



                $options[$i]['form_shape_id'] = $parent_id;
                if ($form_shape_options[$language]['details']['options'][$i]['id']) {
                    $options[$i]['id'] = $form_shape_options[$language]['details']['options'][$i]['id'];
                }
                $options[$i]['is_deleted'] = $form_shape_options[$language]['details']['options'][$i]['is_deleted'] == true || $form_shape_options[$language]['details']['options'][$i]['is_deleted'] == '1' ? '1' : '0';
                $options[$i]['sort'] = $form_shape_options[$language]['details']['options'][$i]['sort'];

                // $options[$i]['id'] = $options[$i]['id']? $options[$i]['id'] : '';

                $options[$i]['data'][$language]['lang_code'] = $form_shape_options[$language]['lang_code'];
                $options[$i]['data'][$language]['label'] = $form_shape_options[$language]['details']['options'][$i]['label'];
            }
        }
//      p($options);




        for ($i = 0; $i < count($options); $i++) {
            if ($options[$i]['id']) {
                $sql = "UPDATE `form_shape_options` SET  `is_deleted` = '{$options[$i]['is_deleted']}' ,`sort` = '{$options[$i]['sort']}'     where id  ='{$options[$i]['id']}'  ";
                $this->mDb->query($sql);
                $new_id2 = $options[$i]['id'];
            } else {
//                $sql1 = "SELECT  fol.id   FROM `form_shape_option_langs` fol  ";
//                $sql1 .= " LEFT JOIN `form_shape_options` fo ON fo.id = fol.form_shape_option_id ";
//                $sql1 .= " WHERE fol.label = '{$v['label']}' and fo.id  = '{$new_id2}' and  fol.lang_code = '{$v['lang_code']}' ";
//                $row = $this->mDb->getOne($sql1);
//                echo $sql1 . "<hr>" . $row . "<hr>";

                $sql = "INSERT INTO `form_shape_options` SET form_shape_id ='{$parent_id}' ,`is_deleted` = '{$options[$i]['is_deleted']}' ,`sort` = '{$options[$i]['sort']}' ";
//               echo $sql."<hr>";
                $this->mDb->query($sql);
                $new_id2 = $this->mDb->getLastInsertId();
            }

            $sql = "DELETE FROM `form_shape_option_langs` ";
            $sql .= " WHERE form_shape_option_id='{$options[$i]['id']}'  ";
            $this->mDb->query($sql);

            foreach ($options[$i]['data'] as $k => $v) {

//                if (!$row) {
                $sql = " INSERT INTO `form_shape_option_langs` SET  lang_code = '{$v['lang_code']}' , label = '{$v['label']}'  ,form_shape_option_id  = '{$new_id2}',date_added='{$this->dateTime}' ";
//                echo "$sql" . "<hr>";
                $this->mDb->query($sql);
//                }
                //	$this->addEditOptions($v['lang_code'], $v['details']['options']);
            }
        }



        // echo "<pre>";print_r($res);die();
    }

    /////////////////////////////////Form Shape///////////////////////////////////////

    function getIdsOfParentService($id) {
        $sql = "SELECT parent FROM `services`";
        $sql .= " WHERE `id` in ({$id}) ";
        $res = $this->mDb->getAll($sql);
        if ($res) {
            return fetchArrayValue_from_dataBase($res, 'parent');
        }
    }

    public function getFomsShapeByService_ids($service_ids) {

        $parents_Ids = $this->getIdsOfParentService($service_ids);
        if ($parents_Ids) {
            $service_ids .= ',' . $parents_Ids;
            // p($searchServiceId);
        }
        $sql = "SELECT f.id  ,f.type  , fl.label FROM `form_shapes` f  ";
        $sql .= " LEFT JOIN `form_shape_services` fss ON f.id = fss.form_shape_id    ";
        $sql .= " LEFT JOIN `form_shape_langs` fl ON f.id = fl.form_shape_id  AND fl.lang_code = '{$this->lang_code}' ";
        $sql .= " where fss.`service_id` in  ({$service_ids})  and f.is_deleted = '0' and f.active = '1' Group By f.id  ORDER BY f.sort ";
        $from_shape = $this->mDb->getAll($sql);

        //p($sql);

        for ($i = 0; $i < count($from_shape); $i++) {
            $sql = "SELECT  fo.id , fol.label   FROM `form_shape_options` fo ";
            $sql .= " LEFT JOIN `form_shape_option_langs` fol ON fo.id = fol.form_shape_option_id AND fol.lang_code = '{$this->lang_code}' ";
            $sql .= " WHERE fo.form_shape_id = '{$from_shape[$i]['id']}' and fo.is_deleted = '0' and fol.label !='' order by fo.sort  asc ";

            //			  echo $sql."<hr>";
            $from_shape[$i]['options'] = $this->mDb->getAll($sql);
        }

        return $from_shape;
    }

    public function getAllServicesNameOfForm_shapeById($form_shape_id, $limit = '') {

        $sql = "SELECT sl.ser_name FROM form_shape_services  fss ";
        $sql .= " LEFT JOIN `service_langs` sl ON sl.service_id = fss.service_id  AND  sl.lang_code = '{$this->lang_code}'  ";
        $sql .= " WHERE fss.`form_shape_id` = '{$form_shape_id}'   ";
        $sql .= $limit ? " Limit  1 " : " ";

        // echo  $sql ;die();

        $res = $this->mDb->getAll($sql);
        return fetchArrayValue_from_dataBase($res, 'ser_name');
    }

    public function getFormShapeForExcelSheet($product_id = '') {
        if ($product_id) {
            $sql = "SELECT service_id FROM product_services where product_id = '{$product_id}'";
            $product_service_ids = $this->mDb->getAll($sql);
            $product_service_ids_string = fetchArrayValue_from_dataBase($product_service_ids, 'service_id');
            // p($product_service_ids_string);
        }
        $parents_Ids = $this->getIdsOfParentService($product_service_ids_string);
        if ($parents_Ids) {
            $product_service_ids_string .= ',' . $parents_Ids;
            // p($searchServiceId);
        }


        // p($product_id);
        $sql = "SELECT fs.id ,  pfs.value , sl.ser_name , s.active as ser_active  , fs.active , fs.type , fsl.label FROM form_shapes  fs ";
        $sql .= " LEFT JOIN `form_shape_langs` fsl ON fs.id = fsl.form_shape_id  AND  fsl.lang_code = '{$this->lang_code}'  ";
        $sql .= " LEFT JOIN `form_shape_services` fss ON fs.id = fss.form_shape_id ";
        $sql .= " LEFT JOIN `services` s ON s.id = fss.service_id ";
        $sql .= " LEFT JOIN `service_langs` sl ON sl.service_id = fss.service_id  AND  sl.lang_code = '{$this->lang_code}'";
        $sql .= " LEFT JOIN `product_form_shapes` pfs ON fs.id = pfs.form_shape_id ";
        $sql .= " WHERE fs.`is_deleted` = '0'   ";
        $sql .= $product_id ? " AND pfs.product_id ='{$product_id}' AND fss.service_id  in ({$product_service_ids_string})  " : " ";
        $sql .= $parents_Ids ? "  AND fss.service_id  in ({$product_service_ids_string})  " : " ";
        $sql .= " GROUP by fs.id  ORDER BY sl.ser_name  ";
        // if ($product_id) {
//         	echo $sql."<hr>";
        // }
        $res = $this->mDb->getAll($sql);

        $return_array = array();

        for ($i = 0; $i < count($res); $i++) {

            if ($res[$i]['type'] == 'select' || $res[$i]['type'] == 'm_select') {
                $sql = "SELECT fso.id , fsol.label as label_option   FROM form_shape_options  fso ";
                $sql .= $product_id ? " LEFT JOIN `product_form_shapes` pfs ON pfs.value = fso.id " : " ";
                $sql .= " LEFT JOIN `form_shape_option_langs` fsol ON fso.id = fsol.form_shape_option_id AND  fsol.lang_code = '{$this->lang_code}' ";
                $sql .= " where fso.form_shape_id= '{$res[$i]['id']}' AND  fso.is_deleted ='0'    ";
                $sql .= $product_id ? " AND pfs.product_id ='{$product_id}' " : " ";
                $sql .= " GROUP by fso.id   order by fso.sort asc  ";

                $options = $this->mDb->getAll($sql);
                for ($o = 0; $o < count($options); $o++) {
                    $res[$i]['label_option'] = $options[$o]['label_option'];
                    $res[$i]['value'] = $options[$o]['id'];
                    $res[$i]['key'] = $res[$i]['id'] . $res[$i]['ser_name'] . $res[$i]['label_option'] . $res[$i]['value'] . $res[$i]['label'] . $res[$i]['type'];

                    if (!is_numeric(array_search($res[$i]['key'], array_column($return_array, 'key')))) {
                        array_push($return_array, $res[$i]);
                    }
                }
            } else {
                // echo array_search("key", $return_array); if (!is_numeric(array_search("key", $return_array))) {
                array_push($return_array, $res[$i]);
            }
        }
//         p($return_array);
        return $return_array;
    }
}
