<?php

$ordersObj = new Orders();

class Orders {

    public Iplus $mDb;
    public array $mConfig;
    public string $lang_code;
    public Offers $offersObj;
    public string $dateTime;
    public Products $productsObj;
    public Users $userObj;
    public Treasures $treasuresObj;

    public function __construct() {
        global $Config;

        $this->mDb = new Iplus();
        $this->productsObj = new Products();
        $this->userObj = new Users();
        $this->offersObj = new Offers();
        $this->treasuresObj = new Treasures();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->lang_code = LANGUAGE;
    }

    public function addEditOrder($temp) {

        if ($temp['id'] === null || $temp['id'] === '') {
            // add
            $sql = "INSERT INTO `orders` SET ";
            foreach ($this->mDb->getCols('orders', $temp) as $k => $v) {
                $sql .= ($k == 'city_name' || $k == 'country_name' || $k == 'product_items') ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$this->dateTime}'";
            //   echo "$sql"; 
            $res = $this->mDb->query($sql);
            if ($res) {
                $id = $this->mDb->getLastInsertId();

                $this->addOrderProduct($id, $temp['product_items']);

                $dataOrderProducts = $this->getOrderProductsForStatus($id);
                $this->completeDeliveryProcess($dataOrderProducts, $id, $temp);

                //enter lang_details
                # code...
            }
            return $res;
        } else {
            $status = $this->getOrderStatus($temp['id']);
            $paidStatus = $this->getPaidStatus($temp['id']);
            if ($status == 'canceled' || $paidStatus == 'paid') {
                return;
            }

            $sql = "UPDATE `orders` SET ";
            foreach ($this->mDb->getCols('orders', $temp) as $k => $v) {
                $sql .= ($k == 'id' || $k == 'city_name' || $k == 'country_name' || $k == 'product_items') ? "" : "`{$k}`='{$v}',";
            }
            $sql = substr($sql, 0, -1);
            $sql .= " WHERE `id` = '{$temp['id']}'";
            $res = $this->mDb->query($sql);
            if ($res) {

                $this->productsObj->removeFromProduct_storesByOrder_id($temp['id'], 'order');
                $this->deleteFromProducsByOrder_id($temp['id']);
                $this->userObj->deleteBalanceByParams('order_commission_pending', $temp['id']);
                $this->userObj->deleteBalanceByParams('order_merchant_supply_pending', $temp['id']);

                $this->addOrderProduct($temp['id'], $temp['product_items']);
                $dataOrderProducts = $this->getOrderProductsForStatus($temp['id']);
                $this->completeDeliveryProcess($dataOrderProducts, $temp['id'], $temp);
                # code...
            }

            return $res;
        }
    }

    public function getPaidStatus($id) {
        $sql = "SELECT is_paid   FROM `orders` where id ='{$id}' ";
        return $this->mDb->getOne($sql);
    }

    public function getOrderStatus($id) {
        $sql = "SELECT status   FROM `orders` where id ='{$id}' ";
        return $this->mDb->getOne($sql);
    }

    public function deleteFromProducsByOrder_id($order_id) {
        $sql = "DELETE FROM `order_products` ";
        $sql .= " WHERE `order_id` =  '{$order_id}'  ";
        return $this->mDb->query($sql);
    }

    public function completeDeliveryProcess($temp, $order_id, $order) {
        // echo "<pre>";
        // print_r($temp);
        // die();


        $balance_['user_id'] = $temp[0]['user_id'];
        $balance_['for_id'] = $order_id;
        $balance_['value'] = $order['total_commision'] - ($order['system_order_commission'] + $order['total_system_product_commissions']);
        $balance_['transaction'] = 'order_commission_pending';
        // p($balance);
        $this->userObj->addBalance($balance_);

        $merchant_price_array = array();
        for ($i = 0; $i < count($temp); $i++) {

            // calculate all affilate commision



            $product_stores['value'] = $temp[$i]['quantity'];
            $product_stores['product_id'] = $temp[$i]['product_id'];
            $product_stores['for_id'] = $order_id;
            $product_stores['for_type'] = 'order';
            $product_stores['name'] = $temp[$i]['product_store_name'];

            $product_stores['type'] = 'remove';
            $product_stores['store_id'] = '1';
            $product_stores['admin_id'] = '0';
            $this->productsObj->addEditProduct_stores($product_stores);

            // حساب توريد التواجر لكل تاجر ومنتجاته على حدا لادخالها في فلوس التاجر مرة واحدة
            if ($temp[$i]['merchant_id'] > 0) {
                $merchant_price_array[$temp[$i]['merchant_id']]['value'] = $merchant_price_array[$temp[$i]['merchant_id']]['value'] ? $merchant_price_array[$temp[$i]['merchant_id']]['value'] : 0;

                $merchant_price_array[$temp[$i]['merchant_id']]['user_id'] = $temp[$i]['merchant_id'];
                $merchant_price_array[$temp[$i]['merchant_id']]['value'] = $merchant_price_array[$temp[$i]['merchant_id']]['value'] + floatval($temp[$i]['quantity']) * floatval($temp[$i]['merchant_supply']);
            }
        }

        $merchant_price_array = array_values($merchant_price_array);

        for ($i = 0; $i < count($merchant_price_array); $i++) {
            $balance['value'] = $merchant_price_array[$i]['value'];
            $balance['user_id'] = $merchant_price_array[$i]['user_id'];
            $balance['for_id'] = $order_id;
            $balance['transaction'] = 'order_merchant_supply_pending';
            $this->userObj->addBalance($balance);
            # code...
        }

        // p('asdasd');
    }

    public function addOrderProduct($id, $product_items) {

        // echo '<pre>';
        // print_r($product_items);die();
        $sql = '';
        for ($i = 0; $i < count($product_items); $i++) {

            $sql .= "INSERT INTO `order_products` SET ";
            foreach ($this->mDb->getCols('order_products', $product_items[$i]) as $k => $v) {
                $sql .= ($k == 'service_id' || $k == 'product_name' || $k == 'store' || $k == 'product_barcode' || $k == 'product_code' || $k == 'commision_price_items' || $k == 'order_id') ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `order_id` = '{$id}' ; ";
        }
        //    echo $sql;die();
        $this->mDb->query($sql);
    }

    public function getOrders($aStart, $aLimit, $sort, $type, $searchId, $searchUserName, $searchDateFrom, $searchDateTo, $searchStatus, $searchAffiliator_id, $searchClient_id, $searchIs_paid) {

        $sql = "SELECT DISTINCT o.* , u.user_name AS 'added_by' , u2.user_name AS 'client_name' , u2.mobile AS 'client_mobile'  , pl.pla_name as city_name FROM `orders` o";
        $sql .= " LEFT JOIN `users` u ON u.id = o.user_id ";
        $sql .= " LEFT JOIN `users` u2 ON u2.id = o.client_id ";
        $sql .= " LEFT JOIN `place_langs` pl ON pl.place_id = o.city_id ";

        $sql .= " WHERE o.id > 0   ";

        $sql .= $searchId ? ' AND o.`id` like "%' . $searchId . '%"' : '';
        $sql .= $searchUserName ? ' AND (u.`user_name` like "%' . $searchUserName . '%" || u2.user_name like "%' . $searchUserName . '%" ||  u.`mobile` like "%' . $searchUserName . '%"  || u2.`mobile` like "%' . $searchUserName . '%"   )' : '';

        $sql .= $searchDateFrom ? " AND o.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND o.`date_added`  <= '{$searchDateTo}' " : "";

        $sql .= $searchStatus ? " AND o.`status` = '{$searchStatus}' " : "";
        $sql .= $searchAffiliator_id ? " AND o.`user_id` = '{$searchAffiliator_id}' " : "";
        $sql .= $searchClient_id ? " AND o.`client_id` = '{$searchClient_id}' " : "";

        // $sql .= $searchAffiliator_id  && $searchClient_id == 'merchant'  ? " AND o.`user_id` = '{$searchAffiliator_id}' " : "";
        // $sql .= $searchClient_id == 'clients' ? " Group BY u.client_mobile " : '';
        $sql .= $searchIs_paid ? " AND o.`is_paid` = '{$searchIs_paid}' " : "";
        $sql .= " ORDER BY o.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        //    echo "$sql";die();
        $res = $this->mDb->getAll($sql);

        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
                $res[$i]['count_product'] = $this->getCountProduct($res[$i]['id']);
                $res[$i]['ticket'] = $this->haveATicket($res[$i]['id']);

                // $res[$i]['total_commission_price'] = $this->getCommission_price($res[$i]['id']);

                $res[$i]['treasures_balances'] = $this->treasuresObj->getTreasures_balancesByType('order', $res[$i]['id']);
                $res[$i]['treasures_balances'] = $res[$i]['treasures_balances'] ? $res[$i]['treasures_balances'] : array();
            }
        }
        return $res;
    }

    public function haveATicket($order_id) {

        $sql = "SELECT  `status` , id   FROM `order_tickets` where  order_id ='{$order_id}' order by id desc limit 1 ";
        $res = $this->mDb->getAll($sql);
        if ($res) {
            return $res[0];
        }
    }

    // public function getCommission_price($order_id)
    // {
    //     $sql = "SELECT  discounts_overprice , discounts_overprice_price , commission_price ,  quantity       FROM `order_products` where  order_id ='{$order_id}' ";
    //     $orderData =  $this->mDb->getAll($sql);
    //     $affilate_commetions = 0;
    //     for ($i = 0; $i < count($orderData); $i++) {
    //         // calculate all affilate commision
    //         if ($orderData[$i]['discounts_overprice'] == 'discounts') {
    //             $affilate_commetions  =  floatval($affilate_commetions) +   floatval($orderData[$i]['quantity']) * (floatval($orderData[$i]['commission_price']) - floatval($orderData[$i]['discounts_overprice_price']));
    //         } else if ($orderData[$i]['discounts_overprice'] == 'overprice') {
    //             $affilate_commetions  = floatval($affilate_commetions) + floatval($orderData[$i]['quantity']) * (floatval($orderData[$i]['commission_price']) + floatval($orderData[$i]['discounts_overprice_price']));
    //         } else {
    //             $affilate_commetions = floatval($affilate_commetions) + floatval($orderData[$i]['quantity']) * floatval($orderData[$i]['commission_price']);
    //         }
    //     }
    //     return $affilate_commetions;
    // }
    public function getCountProduct($order_id) {

        $sql = "SELECT COUNT(DISTINCT `id`) as 'count' FROM `order_products` where  order_id ='{$order_id}' ";
        return $this->mDb->getOne($sql);
    }

    public function getSearchOrderCount($sort, $type, $searchId, $searchUserName, $searchDateFrom, $searchDateTo, $searchStatus, $searchAffiliator_id, $searchClient_id, $searchIs_paid) {

        $sql = "SELECT COUNT(DISTINCT  o.`id`) AS 'result_count' FROM `orders` o";
        $sql .= " LEFT JOIN `users` u ON u.id = o.user_id ";
        $sql .= " LEFT JOIN `users` u2 ON u2.id = o.client_id ";

        $sql .= " WHERE o.`id` > 0";

        $sql .= $searchId ? ' AND o.`id` like "%' . $searchId . '%"' : '';
        $sql .= $searchUserName ? ' AND (u.`user_name` like "%' . $searchUserName . '%" || u2.user_name like "%' . $searchUserName . '%" ||  u.`mobile` like "%' . $searchUserName . '%"  || u2.`mobile` like "%' . $searchUserName . '%"   )' : '';

        $sql .= $searchStatus ? " AND o.`status` = '{$searchStatus}' " : "";
        $sql .= $searchAffiliator_id ? " AND o.`user_id` = '{$searchAffiliator_id}' " : "";
        $sql .= $searchClient_id ? " AND o.`client_id` = '{$searchClient_id}' " : "";

        $sql .= $searchIs_paid ? " AND o.`is_paid` = '{$searchIs_paid}' " : "";

        $sql .= $searchDateFrom ? " AND o.`date_added`   >= '{$searchDateFrom}' " : "";
        $sql .= $searchDateTo ? " AND o.`date_added`  <= '{$searchDateTo}' " : "";

        // $sql .= $searchAffiliator_id  && $searchClient_id == 'merchant'  ? " AND o.`user_id` = '{$searchAffiliator_id}' " : "";
        // $sql .= $searchClient_id == 'clients' ? " Group BY o.client_mobile " : '';
        // $sql .= " ORDER BY o.{$sort} {$type}";
        // echo $sql;
        // die();

        return $this->mDb->getOne($sql);
    }

    public function getOrdersCount() {
        $sql = "SELECT COUNT(DISTINCT `id`) as 'count' FROM `orders`";
        return $this->mDb->getOne($sql);
    }

    public function getOneOrderDetails($temp) {
        $sql = "SELECT `o`.*, `u`.avatar  ,`u`.mobile  , `u`.user_name , pl.pla_name as city_name  , pl2.pla_name as country_name    , u2.user_name AS 'client_name' , u2.mobile AS 'client_mobile' FROM `orders` o ";
        $sql .= " LEFT JOIN `users` u2 ON u2.id = o.client_id ";
        $sql .= " LEFT JOIN `users` u ON u.id = o.user_id";
        $sql .= " LEFT JOIN `place_langs` pl ON pl.place_id = o.city_id ";
        $sql .= " LEFT JOIN `place_langs` pl2 ON pl2.place_id = o.country_id ";

        $sql .= " WHERE o.id = '{$temp['id']}'   ";

        $res = $this->mDb->getRow($sql);

        if ($res) {
            $res['order_products'] = $this->getOrderProducts($temp['id']);
        }
        // echo "<pre>";print_r($sql);die();
        return $res;
    }

    public function getOneOrder($temp) {
        $sql = "SELECT `o`.*    FROM `orders` o ";
        $sql .= " WHERE o.id = '{$temp}'   ";
        $res = $this->mDb->getRow($sql);
        if ($res) {
            $res['current_Affiliator'] = $this->userObj->getOneUser('', $res['user_id']);
            $res['current_Client'] = $this->userObj->getOneUser('', $res['client_id']);
            $res['product_items'] = $this->getOrderProducts($temp);
        }
        // echo "<pre>";print_r($sql);die();
        return $res;
    }

    public function getOrderProducts($order_id) {
        $sql = "SELECT `op`.*  , `pl`.name, `pl`.name as product_name , ps.name as product_store_name ,p.product_barcode ,p.product_code FROM `order_products` op ";
        $sql .= " LEFT JOIN `products` p ON p.id = op.product_id";
        $sql .= " LEFT JOIN `product_langs` pl ON pl.product_id = p.id";
        $sql .= " LEFT JOIN `product_stores` ps ON ps.id = op.product_store_id";

        $sql .= " WHERE op.order_id = '{$order_id}' group by op.id   ";
        //   echo "<pre>";print_r($sql);die();
        $res = $this->mDb->getAll($sql);
        if ($res) {
            for ($i = 0; $i < count($res); $i++) {

                $res[$i]['stores'] = $this->productsObj->getProductStores($res[$i]['product_id'], true, '1', 'add');
            }
        }
        return $res;
    }

    public function deleteOrder($ids) {

        $sql = "DELETE FROM `orders` ";
        $sql .= " WHERE `id` = 0";
        foreach ($ids as $id) {

            $dataOrderProducts = $this->getOrderProductsForStatus($id);
            // p($dataOrderProducts);
            for ($i = 0; $i < count($dataOrderProducts); $i++) {

                if ($dataOrderProducts[$i]['status'] == 'pending' || $dataOrderProducts[$i]['status'] == 'canceled') {
                    // $product_stores['admin_id'] = $admin_id;
                    $this->productsObj->removeFromProduct_storesByOrder_id($id, 'order');
                    $this->userObj->deleteBalanceByParams('order_commission_pending', $id);
                    $this->userObj->deleteBalanceByParams('order_merchant_supply_pending', $id);
                    $sql .= " || `id` = '{$id}' ";
                }
            }
            // refund From Store 
        }
        // echo "$sql";die();
        return $this->mDb->query($sql);
    }

    public function getOrderProductsForStatus($order_id) {
        $sql = "SELECT `op`.*  ,  `o`.user_id  , `o`.status   , `o`.is_paid , `o`.total_price , `o`.sup_total_price ,  ps.name as product_store_name   FROM `order_products` op ";
        $sql .= " LEFT JOIN `orders` o ON o.id = op.order_id";
        $sql .= " LEFT JOIN `product_stores` ps ON ps.id = op.product_store_id";

        $sql .= " WHERE op.order_id = '{$order_id}' group by op.id   ";
        $res = $this->mDb->getAll($sql);
        return $res;
    }

    public function changeOrderStatus($id, $status) {

        $dataOrderProducts = $this->getOrderProductsForStatus($id);
        // p($dataOrderProducts);
        if ($dataOrderProducts[0]['status'] != 'canceled' && $dataOrderProducts[0]['is_paid'] != 'paid') {

            if ($status == 'canceled') {
                // هنا يتم الغاء الطلب    
                $this->productsObj->removeFromProduct_storesByOrder_id($id, 'order');
                $this->userObj->deleteBalanceByParams('order_commission_pending', $id);
                $this->userObj->deleteBalanceByParams('order_merchant_supply_pending', $id);
            }
            $sql = "UPDATE `orders` SET `status` = '{$status}' ";
            $sql .= " WHERE `id` = '{$id}'   ";
            //  echo $sql ;die();
            return $this->mDb->query($sql);
        }
    }

    public function changeToPaid($order_id, $admin_id, $treasure_id) {

        $dataOrderProducts = $this->getOrderProductsForStatus($order_id);
        // p($dataOrderProducts);
        if ($dataOrderProducts[0]['is_paid'] != 'paid') {

            $sql = "UPDATE `orders` SET `is_paid` = 'paid' , `status` = 'delivered'  ";
            $sql .= " WHERE `id` = '{$order_id}'   ";
            // echo $sql ;die();
            $res = $this->mDb->query($sql);
            if ($res) {
                $this->UpdateDeliveryProcess($dataOrderProducts, $admin_id, $order_id, $treasure_id);
                return $res;
            }
        }
    }

    public function UpdateDeliveryProcess($dataOrderProducts, $admin_id, $order_id, $treasure_id) {
        // echo "<pre>";
        // print_r($temp);
        // die();
        // هنا يتم اضافة الفلوس للتاجر الخاصة بالطلب 
        // $balance['user_id'] = $temp[0]['merchant_id'];
        $balance['for_id'] = $order_id;
        $balance['transaction'] = 'order_merchant_supply_pending';
        $this->userObj->updateBalance($balance, 'order_merchant_supply_pay', 'pay');

        // $balance['user_id'] = $temp[0]['user_id'];
        $balance['for_id'] = $order_id;
        $balance['transaction'] = 'order_commission_pending';
        $this->userObj->updateBalance($balance, 'order_commission_pay', 'pay');

        //add product_price To System
        $treasures_balances['note'] = ' على الطلب رقم : ' . $order_id;
        $treasures_balances['type'] = 'add';
        $treasures_balances['for_id'] = $order_id;
        $treasures_balances['for_type'] = 'order';
        $treasures_balances['balance'] = $dataOrderProducts[0]['sup_total_price'];
        $treasures_balances['admin_id'] = $admin_id;

        $this->treasuresObj->addTreasures_balances($treasure_id, $treasures_balances);
    }
}
