<?php

$pagesObj = new pages();

class pages {

    public $mDb;
    public $mConfig;
    public $dateTime;
    public $lang_code;

    public function __construct() {
        global $Config;

        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->lang_code = LANGUAGE;
    }

    function getPages($aStart, $aLimit, $sort, $type, $searchTitle, $searchAffiliator_id) {

        $sql = "SELECT p.* ,pl.title,pl.description, u.user_name AS 'addedBy' , u2.user_name AS 'affiliator_name'  FROM pages p";
        $sql .= " LEFT JOIN `page_langs` pl ON p.id = pl.page_id ";

        $sql .= " LEFT JOIN `users` u2 ON u2.id = p.affiliator_id ";
        $sql .= " LEFT JOIN `users` u ON u.id = p.admin_id ";

        $sql.= " WHERE p.id > 0  AND pl.lang_code ='{$this->lang_code}'  ";
        $sql .= $searchAffiliator_id ? " AND p.`affiliator_id` ='{$searchAffiliator_id}' " : " ";
        $sql.= $searchTitle ? ' AND pl.title like "%' . $searchTitle . '%" ' : '';

        $sql .= " ORDER BY p.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

        // echo $sql; die();

        return $this->mDb->getAll($sql);
    }

    function getSearchPagesCount($sort, $type, $searchTitle, $searchAffiliator_id) {
        $sql = "SELECT COUNT(DISTINCT `id`) as 'result_count' FROM pages";
        $sql.= " WHERE `id` > 0";

        $sql.= $searchTitle ? ' AND `title` like "%' . $searchTitle . '%"' : '';
        $sql .= $searchAffiliator_id ? " AND  `affiliator_id` ='{$searchAffiliator_id}' " : " ";
        $sql .= " ORDER BY {$sort} {$type}";

        //echo $sql; die();

        return $this->mDb->getOne($sql);
    }

    function getPagesCount() {
        $sql = "SELECT COUNT(DISTINCT `id`) as 'count' FROM `pages`";
        return $this->mDb->getOne($sql);
    }

    function addEditPage($temp) {
        $temp['active'] = $temp['active'] ? '1' : '0';


        if ($temp['id'] === null || $temp['id'] === '') {
            // add

            $sql = "INSERT INTO `pages` SET ";
            foreach ($this->mDb->getCols('pages', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'lang_parameter' ) ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$this->dateTime}'";
            // echo "$sql";die();
            $res = $this->mDb->query($sql);
            if ($res) {
                $id = $this->mDb->getLastInsertId();
                //enter lang_details
                foreach ($temp['lang_Details'] as $k => $v) {
                    $sql = " INSERT INTO `page_langs` SET  lang_code = '{$v['lang_code']}'  , title = '{$v['details']['title']}' , description = '{$v['details']['description']}' , page_id='{$id}' ";
                    // echo "$sql";die();
                    $res2 = $this->mDb->query($sql);
                }

                # code...
            }
            return $res;
        } else {

            $sql = "UPDATE `pages` SET ";
            foreach ($this->mDb->getCols('pages', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'id' || $k == 'lang_parameter' ) ? "" : "`{$k}`='{$v}',";
            }
            $sql = substr($sql, 0, -1);
            $sql .= " WHERE `id` = '{$temp['id']}'";
            $res = $this->mDb->query($sql);
            if ($res) {

                //delete lang_details
                $sql = "DELETE FROM `page_langs` ";
                $sql.= " WHERE page_id='{$temp['id']}'  ";
                $res2 = $this->mDb->query($sql);

                //enter lang_details
                foreach ($temp['lang_Details'] as $k => $v) {
                    $sql = " INSERT INTO `page_langs` SET  lang_code = '{$v['lang_code']}' , title = '{$v['details']['title']}' , description = '{$v['details']['description']}' ,page_id='{$temp['id']}' ";
                    // echo "$sql";die();
                    $res2 = $this->mDb->query($sql);
                }

                # code...
            }

            return $res;
        }
    }

    function getOnePage($id) {
        $sql = "SELECT p.*  , u2.user_name AS 'affiliator_name' FROM `pages` p ";

        $sql .= " LEFT JOIN `users` u2 ON u2.id = p.affiliator_id ";
        $sql .= " WHERE p.`id` = '{$id}' ";
        $res = $this->mDb->getRow($sql);
        if ($res) {
            $sql = "SELECT lang_code ,title ,description FROM `page_langs`";
            $sql .= " WHERE `page_id` = '{$id}' ";
            $res['lang_parameter'] = $this->mDb->getAll($sql);
        }
        // echo "<pre>";print_r($res);die();
        return $res;
    }

    function deletePage($ids) {
        $sql = "DELETE p,pl FROM pages p ";
        $sql .= " LEFT JOIN `page_langs` pl ON pl.page_id = p.id ";
        $sql.= " WHERE p.mode='page' and p.`id` = 0";
        foreach ($ids as $id) {
            $sql .= " || p.`id` = '{$id}' ";
        }

        return $this->mDb->query($sql);
    }

}

?>