<?php

$shipmentsObj = new shipments();

class shipments
{
    public Iplus $mDb;
    public IplusTravelBag $mDb3;
    public array $mConfig;
    public string $dateTime;
    public string $lang_code;
    public Offers $offersObj;
    public Invoices $invoicesObj;

    public function __construct()
    {
        global $Config;

        $this->offersObj = new Offers();
        $this->mDb = new Iplus();
        $this->mDb3 = new IplusTravelBag();
        $this->invoicesObj = new Invoices();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->lang_code = defined('LANGUAGE') ? LANGUAGE : 'en'; // Default to 'en' if LANGUAGE is not defined
    }

    public function getShipmentsByParams(
        $aStart,
        $aLimit,
        $sort,
        $type,
        $searchName,
        $searchStatus
    ) {


        // echo "$place_id";die();
        $sql = "SELECT a.*  from shipments  a  WHERE a.id > 0   ";
        $sql .= $searchName ? ' AND ( a.id = "' . $searchName . '" )   ' : '';
        $sql .= $searchStatus   ? " AND a.shipment_status = '{$searchStatus}' " : " ";

        $sql .= " Group by a.id   ";
        $sql .= " ORDER BY a.{$sort} {$type} ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        // echo $sql;
        $res = $this->mDb->getAll($sql);
        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
                $res[$i]['products'] = $this->getShipmentProducts($res[$i]['id']);
                $res[$i]['edit_logs'] = $this->getShipmentEdit_logs($res[$i]['id']);
            }
        }



        return $res;
    }


    public function getSearchShipmentsCount(
        $sort,
        $type,
        $searchName,
        $searchStatus,
        $searchTraveTo,
        $searchDateFrom,
        $searchDateTo
    ) {

        $sql = "SELECT COUNT(DISTINCT a.id) as 'result_count' FROM shipments a ";

        $sql .= " WHERE a.id > 0  ";
        $sql .= $searchName ? ' AND ( a.id = "' . $searchName . '" )   ' : '';
        $sql .= $searchStatus   ? " AND a.shipment_status = '{$searchStatus}' " : " ";


        $sql .= $searchTraveTo ? ' AND (a.travel_to like "%' . $searchTraveTo . '%"   ) ' : '';
           $sql .= $searchDateFrom    ? " AND a.`travel_date`   >= '{$searchDateFrom}' " : "";
         $sql .= $searchDateTo    ? " AND a.`travel_date`  <= '{$searchDateTo}' " : "";



        // echo $sql;
        // die();

        return $this->mDb->getOne($sql);
    }



    public function   getShipmentEdit_logs($shipment_id)
    {
        $sql = "SELECT a.*  , u.user_name AS 'added_by' from shipments_edit_logs  a";
        $sql .= " LEFT JOIN `users` u ON u.id = a.admin_id ";
        $sql .= "   WHERE a.shipment_id ='{$shipment_id}'  order by id desc  ";
        $res = $this->mDb->getAll($sql);

        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
                $sql = "SELECT sp.* FROM `shipment_products_edit_logs` sp  ";
                $sql .= " WHERE sp.shipments_edit_logs_id = '{$res[$i]['id']}' ";
                $res[$i]['products'] = $this->mDb->getAll($sql);
            }
        }
        return $res;
    }

    public function   getShipmentProducts($shipment_id)
    {
        $sql = "SELECT sp.* FROM `shipment_products` sp  ";
        $sql .= " WHERE sp.shipment_id = '{$shipment_id}' ";

        return $this->mDb->getAll($sql);
    }
    public function   getLastStatus($shipment_id)
    {
        $sql = "SELECT shipment_status FROM `shipments` s  ";
        $sql .= " WHERE s.id = '{$shipment_id}' ";

        return $this->mDb->getOne($sql);
    }
    public function editShipment($shipmentDetails)
    {

        $lastStatus  = $this->getLastStatus($shipmentDetails['id']);
        if ($lastStatus != 'received') {



            $sql = "UPDATE `shipments` SET   `commission` = '{$shipmentDetails['commission']}'  ,  `shipment_status` = '{$shipmentDetails['shipment_status']}'  , receipt_notes = '{$shipmentDetails['receipt_notes']}' where id = '{$shipmentDetails['id']}'  ";
            $res =  $this->mDb->query($sql);

            for ($i = 0; $i < count($shipmentDetails['products']); $i++) {
                $sql = "UPDATE `shipment_products` SET  `quantity` = '{$shipmentDetails['products'][$i]['quantity']}'   where product_id = '{$shipmentDetails['products'][$i]['product_id']}' and  shipment_id = '{$shipmentDetails['products'][$i]['shipment_id']}'  ";
                $res =  $this->mDb->query($sql);
            }


            $this->addToEditLog($shipmentDetails);

            // echo $sql;
            // die();
            if ($res && $shipmentDetails['shipment_status']  == 'received') {

                $invoice_id  = $this->getInvoiceShipment_id($shipmentDetails['id']);
                // p($invoice_id);
                if ($invoice_id) {
                    $settlement_invoice['id'] = $invoice_id; //importnat
                }
                $settlement_invoice['note'] = ' شحنة رقم : ' . $shipmentDetails['id']; //importnat
                $settlement_invoice['merchant_id'] = '0';
                $settlement_invoice['invoice_type'] = 'settlement-invoice';
                $settlement_invoice['admin_id'] = $shipmentDetails['admin_id'];
                $settlement_invoice['count_invoice_type'] =  $this->getLastAddedCountSettlementInvoice();;
                $settlement_invoice['invoice_items'] =    $shipmentDetails['products'];

                $settlement_invoice['invoice_items'] = array();
                for ($i = 0; $i < count($shipmentDetails['products']); $i++) {
                    $settlement_invoice['invoice_items'][$i]['product_id'] = $shipmentDetails['products'][$i]['product_id'];
                    $settlement_invoice['invoice_items'][$i]['product_name'] = $shipmentDetails['products'][$i]['name'];
                    $settlement_invoice['invoice_items'][$i]['product_type_name'] = 'الافتراضي';
                    $settlement_invoice['invoice_items'][$i]['quantity'] = $shipmentDetails['products'][$i]['quantity'];
                    $settlement_invoice['invoice_items'][$i]['store_id'] = '1';
                    $settlement_invoice['invoice_items'][$i]['store_title'] = 'المخزن الافتراضي';
                    // $shipmentDetails['invoice_items'][$i]['unit_title'] = '';
                }

                $this->invoicesObj->addEditOther_invoice($settlement_invoice);

               $shipment_voucher_clause_id ='1';

                $voucher_id  = $this->getVoucherShipment_id($shipmentDetails['id'] ,$shipment_voucher_clause_id);
                // p($invoice_id);
                if ($invoice_id) {
                    $voucher['id'] = $voucher_id; //importnat
                }
                $voucher['count_voucher_type'] = $this->getLastAddedCountCashingVoucher();
                $voucher['user_id'] = '0';
                $voucher['price'] = $shipmentDetails['commission'];
                $voucher['account_type'] = 'none';
                $voucher['note'] = $shipmentDetails['receipt_notes'] . ' - الشحنة رقم : ' . $shipmentDetails['id'];
                $voucher['voucher_way'] = 'cash';
                $voucher['voucher_account_number'] = '0';
                $voucher['voucher_type'] = 'cashing-voucher';
                $voucher['voucher_clause_id'] = $shipment_voucher_clause_id;
                $voucher['treasure_id'] = '1';
                $voucher['admin_id'] = $shipmentDetails['admin_id'];


                $this->invoicesObj->addEditVoucher($voucher);
            }
            return  $res;
        }
    }


    public function   getLastAddedCountSettlementInvoice()
    {
        $sql = "SELECT count_invoice_type FROM `other_invoices`  ";
        $sql .= " WHERE invoice_type = 'settlement-invoice' order by id DESC  Limit  1  ";
        $res = $this->mDb->getAll($sql);
        if ($res) {
            return $res[0]['count_invoice_type'] + 1;
        } else {
            return 1;
        }
    }
    public function   getLastAddedCountCashingVoucher()
    {
        $sql = "SELECT count_voucher_type FROM `vouchers`  ";
        $sql .= " WHERE voucher_type = 'cashing-voucher'    order by id DESC  Limit  1  ";

        $res = $this->mDb->getAll($sql);
        if ($res) {
            return $res[0]['count_voucher_type'] + 1;
        } else {
            return 1;
        }
    }



    public function   getInvoiceShipment_id($shipment_id)
    {
        $sql = "SELECT id FROM `other_invoices`  ";
        $sql .= " WHERE note = '{$shipment_id}' ";

        return $this->mDb->getOne($sql);
    }


    public function   getVoucherShipment_id($shipment_id , $voucher_clause_id )
    {
        $sql = "SELECT id FROM `vouchers`  ";
        $sql .= " WHERE note = '{$shipment_id}' and voucher_clause_id ='{$voucher_clause_id}' ";

        return $this->mDb->getOne($sql);
    }



    public function addToEditLog($shipmentDetails)
    {

        $sql = "INSERT INTO `shipments_edit_logs` set shipment_id = '{$shipmentDetails['id']}' , `commission` = '{$shipmentDetails['commission']}'  ,  `shipment_status` = '{$shipmentDetails['shipment_status']}'  , receipt_notes = '{$shipmentDetails['receipt_notes']}'   ,`admin_id` ='{$shipmentDetails['admin_id']}'  , date_added = '{$this->dateTime}'    ";
        // p($sql);
        $res =  $this->mDb->query($sql);
        if ($res) {
            $id = $this->mDb->getLastInsertId();

            for ($i = 0; $i < count($shipmentDetails['products']); $i++) {
                $sql = "INSERT INTO shipment_products_edit_logs set   shipments_edit_logs_id ='{$id}' 
                    ,`quantity` ='{$shipmentDetails['products'][$i]['quantity']}'   
                    ,`product_id` ='{$shipmentDetails['products'][$i]['product_id']}' 

                    ,`image` ='{$shipmentDetails['products'][$i]['image']}' 
                    ,`product_barcode` ='{$shipmentDetails['products'][$i]['product_barcode']}' 
                    ,`name` ='{$shipmentDetails['products'][$i]['name']}' 
                    ,`sku` ='{$shipmentDetails['products'][$i]['sku']}' 

                    ,`manf_name` ='{$shipmentDetails['products'][$i]['manf_name']}' 
                    ,`type` ='{$shipmentDetails['products'][$i]['type']}' 
                    ,`price` ='{$shipmentDetails['products'][$i]['price']}' 
                    ,`weight` ='{$shipmentDetails['products'][$i]['weight']}' 
                    ,`price_without_tax` ='{$shipmentDetails['products'][$i]['price_without_tax']}' 
                    ,`price_with_tax` ='{$shipmentDetails['products'][$i]['price_with_tax']}' 
                    ,`saudi_price` ='{$shipmentDetails['products'][$i]['saudi_price']}' 
                    ,`sort` ='{$shipmentDetails['products'][$i]['sort']}' 
                    ,`active` ='{$shipmentDetails['products'][$i]['active']}' 
                    , date_added = '{$this->dateTime}' ";

                // echo $sql;
                // die();


                $this->mDb->query($sql);
            }
        }
    }




    public function  updateIDSSSSS()
    {

        // $sql = "SELECT product_id FROM `other_invoice_items`    ";
        // $sql .= " WHERE  invoice_id = 111   ";
        // //;
        // $res = $this->mDb->getAll($sql);
        // //   p($res);
        // for ($i=0; $i <count($res) ; $i++) { 
        //     $sql = "SELECT product_id FROM `products`    ";
        //     $sql .= " WHERE  id = '{$res[$i]['product_id']}'   ";
        //     $product_id = $this->mDb3->getOne($sql);

        //     if($product_id){
        //         $sql = "Update  `other_invoice_items` set product_id = '{$product_id}' where  product_id = {$res[$i]['product_id']}   ";
        //     //   p($sql);
        //         $this->mDb->query($sql);
        //     }

        // }
    }
}
