<?php

$statisticsObj = new Statistics();

class Statistics {

    public $mDb;
    public $masterDb;
    public $mConfig;
    public $dateTime;

    // استخدام __construct بدلاً من Statistics()
    public function __construct() {
        global $Config;
        $this->mDb = new iplus(); // تأكد من أن iplus تم تهيئته بشكل صحيح
        $this->masterDb = new iplusMaster();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
    }

    function getInvoicesStatstics($sql_t) {
        // sale-invoice   
        //comment
        $sql = "SELECT COUNT(DISTINCT `id`) FROM `invoices` WHERE `invoice_type`= 'sale-invoice' and `is_paid`='paid' ";
        $sql .= $sql_t;
        $result['sale-invoice-count-paid'] = $this->mDb->getOne($sql);

        $sql = "SELECT COUNT(DISTINCT `id`) FROM `invoices` WHERE `invoice_type`= 'sale-invoice' and `is_paid`='unPaid' ";
        $sql .= $sql_t;
        $result['sale-invoice-count-unPaid'] = $this->mDb->getOne($sql);

        $sql = "SELECT COUNT(DISTINCT `id`) FROM `invoices` WHERE `invoice_type`= 'sale-invoice'  and `is_paid`='installment' ";
        $sql .= $sql_t;
        $result['sale-invoice-count-installment'] = $this->mDb->getOne($sql);

        $sql = "SELECT SUM(`total_quantity`) FROM `invoices` WHERE `invoice_type`= 'sale-invoice'   ";
        $sql .= $sql_t;
        $result['sale-invoice-total-quantity'] = $this->mDb->getOne($sql);
        $result['sale-invoice-total-quantity'] = $result['sale-invoice-total-quantity'] ? $result['sale-invoice-total-quantity'] : 0;

        $sql = "SELECT SUM(`total_price`) FROM `invoices` WHERE `invoice_type`= 'sale-invoice'   ";
        $sql .= $sql_t;
        $result['sale-invoice-total-price'] = $this->mDb->getOne($sql);
        $result['sale-invoice-total-price'] = $result['sale-invoice-total-price'] ? $result['sale-invoice-total-price'] : 0;

        $result['sale-invoice-total-count'] = $result['sale-invoice-count-paid'] + $result['sale-invoice-count-unPaid'] + $result['sale-invoice-count-installment'];

        // receipt-invoice
        $sql = "SELECT COUNT(DISTINCT `id`) FROM `invoices` WHERE `invoice_type`= 'receipt-invoice' and `is_paid`='paid' ";
        $sql .= $sql_t;
        $result['receipt-invoice-count-paid'] = $this->mDb->getOne($sql);

        $sql = "SELECT COUNT(DISTINCT `id`) FROM `invoices` WHERE `invoice_type`= 'receipt-invoice' and `is_paid`='unPaid' ";
        $sql .= $sql_t;
        $result['receipt-invoice-count-unPaid'] = $this->mDb->getOne($sql);

        $sql = "SELECT COUNT(DISTINCT `id`) FROM `invoices` WHERE `invoice_type`= 'receipt-invoice'  and `is_paid`='installment' ";
        $sql .= $sql_t;
        $result['receipt-invoice-count-installment'] = $this->mDb->getOne($sql);

        $sql = "SELECT SUM(`total_quantity`) FROM `invoices` WHERE `invoice_type`= 'receipt-invoice'   ";
        $sql .= $sql_t;
        $result['receipt-invoice-total-quantity'] = $this->mDb->getOne($sql);
        $result['receipt-invoice-total-quantity'] = $result['receipt-invoice-total-quantity'] ? $result['receipt-invoice-total-quantity'] : 0;

        $sql = "SELECT SUM(`total_price`) FROM `invoices` WHERE `invoice_type`= 'receipt-invoice'   ";
        $sql .= $sql_t;
        $result['receipt-invoice-total-price'] = $this->mDb->getOne($sql);
        $result['receipt-invoice-total-price'] = $result['receipt-invoice-total-price'] ? $result['receipt-invoice-total-price'] : 0;

        $result['receipt-invoice-total-count'] = $result['receipt-invoice-count-paid'] + $result['receipt-invoice-count-unPaid'] + $result['receipt-invoice-count-installment'];

        // sale-return-invoice
        $sql = "SELECT COUNT(DISTINCT `id`) FROM `invoices` WHERE `invoice_type`= 'sale-return-invoice' and `is_paid`='paid' ";
        $sql .= $sql_t;
        $result['sale-return-invoice-count-paid'] = $this->mDb->getOne($sql);

        $sql = "SELECT COUNT(DISTINCT `id`) FROM `invoices` WHERE `invoice_type`= 'sale-return-invoice' and `is_paid`='unPaid' ";
        $sql .= $sql_t;
        $result['sale-return-invoice-count-unPaid'] = $this->mDb->getOne($sql);

        $sql = "SELECT COUNT(DISTINCT `id`) FROM `invoices` WHERE `invoice_type`= 'sale-return-invoice'  and `is_paid`='installment' ";
        $sql .= $sql_t;
        $result['sale-return-invoice-count-installment'] = $this->mDb->getOne($sql);

        $sql = "SELECT SUM(`total_quantity`) FROM `invoices` WHERE `invoice_type`= 'sale-return-invoice'   ";
        $sql .= $sql_t;
        $result['sale-return-invoice-total-quantity'] = $this->mDb->getOne($sql);
        $result['sale-return-invoice-total-quantity'] = $result['sale-return-invoice-total-quantity'] ? $result['sale-return-invoice-total-quantity'] : 0;

        $sql = "SELECT SUM(`total_price`) FROM `invoices` WHERE `invoice_type`= 'sale-return-invoice'   ";
        $sql .= $sql_t;
        $result['sale-return-invoice-total-price'] = $this->mDb->getOne($sql);
        $result['sale-return-invoice-total-price'] = $result['sale-return-invoice-total-price'] ? $result['sale-return-invoice-total-price'] : 0;

        $result['sale-return-invoice-total-count'] = $result['sale-return-invoice-count-paid'] + $result['sale-return-invoice-count-unPaid'] + $result['sale-return-invoice-count-installment'];

        // receipt-return-invoice
        $sql = "SELECT COUNT(DISTINCT `id`) FROM `invoices` WHERE `invoice_type`= 'receipt-return-invoice' and `is_paid`='paid'  ";
        $sql .= $sql_t;
        $result['receipt-return-invoice-count-paid'] = $this->mDb->getOne($sql);

        $sql = "SELECT COUNT(DISTINCT `id`) FROM `invoices` WHERE `invoice_type`= 'receipt-return-invoice' and `is_paid`='unPaid'  ";
        $sql .= $sql_t;
        $result['receipt-return-invoice-count-unPaid'] = $this->mDb->getOne($sql);

        $sql = "SELECT COUNT(DISTINCT `id`) FROM `invoices` WHERE `invoice_type`= 'receipt-return-invoice'  and `is_paid`='installment'  ";
        $sql .= $sql_t;
        $result['receipt-return-invoice-count-installment'] = $this->mDb->getOne($sql);

        $sql = "SELECT SUM(`total_quantity`) FROM `invoices` WHERE `invoice_type`= 'receipt-return-invoice'    ";
        $sql .= $sql_t;
        $result['receipt-return-invoice-total-quantity'] = $this->mDb->getOne($sql);
        $result['receipt-return-invoice-total-quantity'] = $result['receipt-return-invoice-total-quantity'] ? $result['receipt-return-invoice-total-quantity'] : 0;

        $sql = "SELECT SUM(`total_price`) FROM `invoices` WHERE `invoice_type`= 'receipt-return-invoice'    ";
        $sql .= $sql_t;
        $result['receipt-return-invoice-total-price'] = $this->mDb->getOne($sql);

        $result['receipt-return-invoice-total-price'] = $result['receipt-return-invoice-total-price'] ? $result['receipt-return-invoice-total-price'] : 0;

        $result['receipt-return-invoice-total-count'] = $result['receipt-return-invoice-count-paid'] + $result['receipt-return-invoice-count-unPaid'] + $result['receipt-return-invoice-count-installment'];
        {
            
        }

        return $result;
    }

    public function getDailyReports(
            $searchDateFrom, $searchDateTo
    ) {
        $today = date("Y-m-d") . " 00:00:00 ";
        $sql_t = $searchDateFrom ? " AND `date_added`   >= '{$searchDateFrom}' " : "";
        $sql_t .= $searchDateTo ? " AND `date_added`  <= '{$searchDateTo}' " : "";
        $sql_t .= !$searchDateFrom && !$searchDateTo ? " AND date_added > '{$today}' " : ' ';
        $result = array();
        $result['invoices-cancel'] = $this->getInvoicesStatstics("AND status ='canceled' " . $sql_t);
        $result['invoices-not-cancel'] = $this->getInvoicesStatstics("AND status !='canceled' " . $sql_t);
        // mortal-invoice 
        $sql = "SELECT COUNT(DISTINCT `id`) FROM `other_invoices` WHERE `invoice_type`= 'mortal-invoice'   ";
        $sql .= $sql_t;
        $result['mortal-invoice-total-count'] = $this->mDb->getOne($sql);

        $sql = "SELECT SUM(`total_quantity`) FROM `other_invoices` WHERE `invoice_type`= 'mortal-invoice'   ";
        $sql .= $sql_t;
        $result['mortal-invoice-total-quantity'] = $this->mDb->getOne($sql);
        $result['mortal-invoice-total-quantity'] = $result['mortal-invoice-total-quantity'] ? $result['mortal-invoice-total-quantity'] : 0;

        //settlement-invoice
        $sql = "SELECT COUNT(DISTINCT `id`) FROM `other_invoices` WHERE `invoice_type`= 'settlement-invoice'   ";
        $sql .= $sql_t;
        $result['settlement-invoice-total-count'] = $this->mDb->getOne($sql);

        $sql = "SELECT SUM(`total_quantity`) FROM `other_invoices` WHERE `invoice_type`= 'settlement-invoice'   ";
        $sql .= $sql_t;
        $result['settlement-invoice-total-quantity'] = $this->mDb->getOne($sql);
        $result['settlement-invoice-total-quantity'] = $result['settlement-invoice-total-quantity'] ? $result['settlement-invoice-total-quantity'] : 0;

        //inventory-invoice
        $sql = "SELECT COUNT(DISTINCT `id`) FROM `other_invoices` WHERE `invoice_type`= 'inventory-invoice'   ";
        $sql .= $sql_t;
        $result['inventory-invoice-total-count'] = $this->mDb->getOne($sql);

        $sql = "SELECT SUM(`total_quantity`) FROM `other_invoices` WHERE `invoice_type`= 'inventory-invoice'   ";
        $sql .= $sql_t;
        $result['inventory-invoice-total-quantity'] = $this->mDb->getOne($sql);
        $result['inventory-invoice-total-quantity'] = $result['inventory-invoice-total-quantity'] ? $result['inventory-invoice-total-quantity'] : 0;

        $sql = "SELECT SUM(`value`) FROM `product_stores` WHERE `for_type`= 'inventory-invoice' and type ='remove'   ";
        $sql .= $sql_t;
        $result['inventory-invoice-total-quantity-remove-new'] = $this->mDb->getOne($sql);

        $result['inventory-invoice-total-quantity-remove-new'] = $result['inventory-invoice-total-quantity-remove-new'] ? $result['inventory-invoice-total-quantity-remove-new'] : 0;

        $sql = "SELECT SUM(`value`) FROM `product_stores` WHERE `for_type`= 'inventory-invoice'  and type ='add'   ";
        $sql .= $sql_t;
        $result['inventory-invoice-total-quantity-add-new'] = $this->mDb->getOne($sql);
        $result['inventory-invoice-total-quantity-add-new'] = $result['inventory-invoice-total-quantity-add-new'] ? $result['inventory-invoice-total-quantity-add-new'] : 0;
        $result['inventory-invoice-total-quantity-new'] = $result['inventory-invoice-total-quantity-add-new'] - $result['inventory-invoice-total-quantity-remove-new'];

        // cashing-voucher
        $sql = "SELECT COUNT(DISTINCT `id`) FROM `vouchers` WHERE `voucher_type`= 'cashing-voucher'   ";
        $sql .= $sql_t;
        $result['cashing-voucher-total-count'] = $this->mDb->getOne($sql);

        $sql = "SELECT SUM(`price`) FROM `vouchers` WHERE `voucher_type`= 'cashing-voucher'    ";
        $sql .= $sql_t;
        $result['cashing-voucher-total-price'] = $this->mDb->getOne($sql);
        $result['cashing-voucher-total-price'] = $result['cashing-voucher-total-price'] ? $result['cashing-voucher-total-price'] : 0;

        //  'get-voucher'
        $sql = "SELECT COUNT(DISTINCT `id`) FROM `vouchers` WHERE `voucher_type`= 'get-voucher'    ";
        $sql .= $sql_t;
        $result['get-voucher-total-count'] = $this->mDb->getOne($sql);

        $sql = "SELECT SUM(`price`) FROM `vouchers` WHERE `voucher_type`= 'get-voucher'    ";
        $sql .= $sql_t;
        $result['get-voucher-total-price'] = $this->mDb->getOne($sql);
        $result['get-voucher-total-price'] = $result['get-voucher-total-price'] ? $result['get-voucher-total-price'] : 0;

        $sql_t2 = $searchDateFrom ? " AND `date_added`   <= '{$searchDateFrom}' " : "";
        $sql_t2 .= !$searchDateFrom ? "  and date_added < '{$today}' " : ' ';

        $sql = "SELECT  sum(value)  FROM `product_stores` where  type ='add'    ";
        $sql .= $sql_t2;
        $addition = $this->mDb->getOne($sql);
        $addition = $addition ? $addition : 0;

        $sql = "SELECT sum(value)   FROM `product_stores` where type ='remove' ";
        $sql .= $sql_t2;
        $remove = $this->mDb->getOne($sql);
        $remove = $remove ? $remove : 0;
        $result['before-filter-store-products-count'] = $addition - $remove;

        $sql = "SELECT  sum(value)  FROM `product_stores` where  type ='add'     ";
        $sql .= $sql_t;
        $addition = $this->mDb->getOne($sql);
        $addition = $addition ? $addition : 0;

        $sql = "SELECT sum(value)   FROM `product_stores` where type ='remove'  ";
        $sql .= $sql_t;
        $remove = $this->mDb->getOne($sql);
        $remove = $remove ? $remove : 0;
        $result['in-filter-store-products-count'] = $addition - $remove;

        $result['before-plus-filter-store-products-count'] = $result['in-filter-store-products-count'] + $result['before-filter-store-products-count'];

        // treasures_balances
        $sql = "SELECT  sum(balance)  FROM `treasures_balances` where  type ='add'    ";
        $sql .= $sql_t2;
        $addition = $this->mDb->getOne($sql);
        $addition = $addition ? $addition : 0;

        $sql = "SELECT sum(balance)   FROM `treasures_balances` where type ='remove'  ";
        $sql .= $sql_t2;
        $remove = $this->mDb->getOne($sql);
        $remove = $remove ? $remove : 0;
        $result['before-filter-treasures-balances'] = $addition - $remove;

        $sql = "SELECT  sum(balance)  FROM `treasures_balances` where  type ='add'     ";
        $sql .= $sql_t;
        $addition = $this->mDb->getOne($sql);
        $addition = $addition ? $addition : 0;

        $sql = "SELECT sum(balance)   FROM `treasures_balances` where type ='remove'  ";
        $sql .= $sql_t;
        $remove = $this->mDb->getOne($sql);
        $remove = $remove ? $remove : 0;
        $result['in-filter-treasures-balances'] = $addition - $remove;

        $result['before-plus-filter-treasures-balances'] = $result['in-filter-treasures-balances'] + $result['before-filter-treasures-balances'];

        return $result;
    }

    public function getHomeStatistics($user_id, $user_type) {
        $result = array();

        // getSearchPullBalanceRequestsCount
        if ($user_type == 'AD' || $user_type == 'M_AD') {
            $sql = "SELECT COUNT(DISTINCT `id`) FROM `users` WHERE `user_level`= '1000'";
            $result['affiliators'] = $this->mDb->getOne($sql);

            $sql = "SELECT COUNT(DISTINCT `id`) FROM `users` WHERE `user_level` = '2000' ";
            $result['merchants'] = $this->mDb->getOne($sql);

            $sql = "SELECT COUNT(DISTINCT `id`) FROM `users` WHERE `user_level` = '3000' ";
            $result['clients'] = $this->mDb->getOne($sql);

            $sql = "SELECT COUNT(DISTINCT `id`) FROM `users` WHERE (`user_level` != '1000' &&  `user_level` != '2000' &&  `user_level` != '3000') ";
            $result['management'] = $this->mDb->getOne($sql);

            $sql = "SELECT COUNT(DISTINCT `id`) FROM `trademarks`";
            $result['trademarks'] = $this->mDb->getOne($sql);

            $sql = "SELECT COUNT(DISTINCT `id`) FROM `units`";
            $result['units'] = $this->mDb->getOne($sql);

            $sql = "SELECT COUNT(DISTINCT `id`) FROM `treasures`";
            $result['treasures'] = $this->mDb->getOne($sql);

            $sql = "SELECT COUNT(DISTINCT `id`) FROM `voucher_clauses`";
            $result['voucher_clauses'] = $this->mDb->getOne($sql);

            $sql = "SELECT COUNT(DISTINCT `id`) FROM `places`";
            $result['places'] = $this->masterDb->getOne($sql);

            $sql = "SELECT COUNT(DISTINCT `id`) FROM `stores`";
            $result['stores'] = $this->mDb->getOne($sql);

            $sql = "SELECT COUNT(DISTINCT `id`) FROM `services`";
            $result['services'] = $this->mDb->getOne($sql);

            $sql = "SELECT COUNT(DISTINCT `id`) FROM `orders` where status ='pending'";
            $result['orders_pending'] = $this->mDb->getOne($sql);

            $sql = "SELECT COUNT(DISTINCT `id`) FROM `balance_withdrawal_requests` where status ='pending'";
            $result['balance_withdrawal_requests_pending'] = $this->mDb->getOne($sql);

            $sql = "SELECT COUNT(DISTINCT `id`) FROM `order_tickets` where status ='pending'";
            $result['order_tickets_pending'] = $this->mDb->getOne($sql);
        } else if ($user_type == 'AF') {
            $sql = "SELECT COUNT(DISTINCT `id`) FROM `orders` where status ='pending' AND user_id= '{$user_id}'";
            $result['orders_pending'] = $this->mDb->getOne($sql);

            $sql = "SELECT COUNT(DISTINCT `id`) FROM `orders` where status ='delivered' AND user_id= '{$user_id}' ";
            $result['orders_delivered'] = $this->mDb->getOne($sql);

            $sql = "SELECT COUNT(DISTINCT `id`) FROM `orders` where status ='canceled'  AND user_id= '{$user_id}'";
            $result['orders_canceled'] = $this->mDb->getOne($sql);
        }

        return $result;
    }

    function getAllFavoritesPageAdmin($data = array()) {
        $sql = "SELECT * FROM favorites_page_admin WHERE admin_id = :admin_id";
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':admin_id', $data['admin_id']);
        $stmt->execute();
        return $stmt->fetchAll(PDO::FETCH_ASSOC);
    }

    function checkFavoritesPageAdmin($data) {
        $sql = "SELECT id FROM favorites_page_admin   ";
        $sql .= " WHERE  admin_id='{$data['admin_id']}' and page_name='{$data['page_name']}'  ";
//        echo $sql . "<hr>";
        return $this->mDb->getOne($sql);
    }

    function getLastSortFavoritesPageAdmin($data) {
        $sql = "SELECT sort FROM `{$this->mPrefix}favorites_page_admin` ";
        $sql .= "WHERE admin_id = '{$data['admin_id']}'  ";
        $sql .= "ORDER BY sort DESC LIMIT 1"; // للحصول على أحدث إدخال فقط
        $lastSort = $this->mDb->getOne($sql);
        return $lastSort + 1; // جمع 1 على القيمة قبل إرجاعها
    }

    function addEditFavoritesPageAdmin($data) {
        $lastId = $this->checkFavoritesPageAdmin($data);
        if (!$lastId) {
            $sql = "INSERT INTO `favorites_page_admin` SET ";
            $sql .= " `admin_id` = '{$data['admin_id']}'";
            $sql .= " ,`page_name` = '{$data['page_name']}'";
            $sql .= " ,`page_url` = '{$data['page_url']}'";
            $sql .= " ,`sort` = '{$this->getLastSortFavoritesPageAdmin($data)}'";
            $sql .= " ,`date_added` = '{$this->dateTime}'";
//            echo $sql . "<hr>";
            return $this->mDb->query($sql);
        } else {
            $sql = " DELETE FROM `{$this->mPrefix}favorites_page_admin` ";
            $sql .= " WHERE `id` = '{$lastId}'  ";
//            echo $sql . "<hr>";
            return $this->mDb->query($sql);
        }
    }

    function deleteFavoritesPageAdmin($admin_id) {
        $sql = " DELETE FROM `{$this->mPrefix}favorites_page_admin` ";
        $sql .= " WHERE `admin_id` = '{$admin_id}'  ";
        return $this->mDb->query($sql);
    }

    function editFavoritesPageAdmin($temp) {
        $del = $this->deleteFavoritesPageAdmin($temp['admin_id']);
        if ($del && count($temp['favorites_list']) > 0) {
            for ($i = 0; $i < count($temp['favorites_list']); $i++) {
                $sql = "INSERT INTO `favorites_page_admin` SET ";
                $sql .= " `admin_id` = '{$temp['favorites_list'][$i]['admin_id']}'";
                $sql .= " ,`page_name` = '{$temp['favorites_list'][$i]['page_name']}'";
                $sql .= " ,`page_url` = '{$temp['favorites_list'][$i]['page_url']}'";
                $sql .= " ,`sort` = '{$temp['favorites_list'][$i]['sort']}'";
                $sql .= " ,`date_added` = '{$this->dateTime}'";
//                echo $sql . "<hr>";
                $res = $this->mDb->query($sql);
            }
            return $res;
        }
        return $del;
    }
}
