<?php

$tagsObj = new Tags();

class Tags {

    public $mDb;
    public $mConfig;
    public $dateTime;
    public $lang_code;

    public function __construct() {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->lang_code = defined('LANGUAGE') ? LANGUAGE : 'ar'; // تحقق من تعريف LANGUAGE، واستخدام 'en' كقيمة افتراضية
    }

    function getTagsByParams(
            $aStart, $aLimit, $sort, $type, $searchName, $parent_id, $service_type, $serviceStatus
    ) {

        // echo "$parent_id";die();
        $sql = "SELECT t.* ,  u.user_name AS 'addedBy'  , tl.label FROM tags t ";
        $sql .= " LEFT JOIN `users` u ON u.id = t.admin_id ";
        $sql .= " LEFT JOIN `tags_langs` tl ON t.id = tl.tag_id AND tl.lang_code = '{$this->lang_code}' ";
        $sql .= " WHERE t.id > 0  and t.is_deleted = '0'  ";
        $sql .= $searchName ? ' AND (tl.label like "%' . $searchName . '%" ) ' : '';
//        $sql .= " AND fs.active = '1' ";

        $sql .= " Group by t.id ORDER BY t.{$sort} {$type} ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        //   echo $sql; die();

        $res = $this->mDb->getAll($sql);
        for ($i = 0; $i < count($res); $i++) {

            $res[$i]['page_name'] = $this->getAllPagesNameOfTagsById($res[$i]['id']);
        }
        return $res;
    }

    function getSearchTagsCount(
            $sort, $type, $searchName, $parent_id, $service_type, $serviceStatus
    ) {


        $sql = "SELECT COUNT(DISTINCT t.id) as 'result_count' FROM tags t ";
        $sql .= " LEFT JOIN `tags_langs` tl ON t.id = tl.tag_id AND tl.lang_code = '{$this->lang_code}' ";
        $sql .= " WHERE t.id > 0 and t.is_deleted = '0'  ";
        $sql .= $searchName ? ' AND (tl.label like "%' . $searchName . '%" ) ' : '';
        $sql .= ($serviceStatus === '0' || $serviceStatus) ? " AND t.active = '{$serviceStatus}' " : ' ';

        // echo $sql; die();

        return $this->mDb->getOne($sql);
    }

    function addEditTag($temp) {

        $temp['active'] = $temp['active'] ? '1' : '0';
        $temp['sort'] = $temp['sort'] ? $temp['sort'] : '0';
        $temp['is_deleted'] = $temp['is_deleted'] == true || $temp['is_deleted'] == '1' ? $temp['is_deleted'] : '0';

        if ($temp['id'] === null || $temp['id'] === '') {
            // add

            $sql = "INSERT INTO `tags` SET ";
            foreach ($this->mDb->getCols('tags', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'lang_parameter') ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$this->dateTime}'";
            //   echo "$sql";die();
            $res = $this->mDb->query($sql);
            if ($res) {
                $id = $this->mDb->getLastInsertId();
                //enter lang_details
                foreach ($temp['lang_Details'] as $k => $v) {
                    $sql = " INSERT INTO `tags_langs` SET  lang_code = '{$v['lang_code']}' , label = '{$v['details']['label']}'  ,tag_id  = '{$id}' ";
                    //   echo "$sql";die();
                    $this->mDb->query($sql);
                }
                $this->addEditOptions($id, $temp['lang_Details']);

                $this->deleteTagsPages($id);
                $this->addTagsPages($temp['tag_pages'], $id);
            }
            return $res;
        } else {
            $sql = "UPDATE `tags` SET ";
            foreach ($this->mDb->getCols('tags', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'id' || $k == 'lang_parameter') ? "" : "`{$k}`='{$v}',";
            }
            $sql = substr($sql, 0, -1);
            $sql .= " WHERE `id` = '{$temp['id']}'";
            $res = $this->mDb->query($sql);
            if ($res) {

                //delete lang_details
                $sql = "DELETE FROM `tags_langs` ";
                $sql .= " WHERE tag_id='{$temp['id']}'  ";
                $this->mDb->query($sql);

                //enter lang_details
                foreach ($temp['lang_Details'] as $k => $v) {
                    $sql = " INSERT INTO `tags_langs` SET  lang_code = '{$v['lang_code']}' , label = '{$v['details']['label']}'  ,tag_id  = '{$temp['id']}' ";
                    // echo "$sql";die();
                    $this->mDb->query($sql);
                    //	$this->addEditOptions($v['lang_code'], $v['details']['options']);
                }
                # code...

                $this->addEditOptions($temp['id'], $temp['lang_Details']);

                $this->deleteTagsPages($temp['id']);
                $this->addTagsPages($temp['tag_pages'], $temp['id']);
            }

            return $res;
        }
    }

    public function deleteTagsPages($tag_id) {
        $sql = "DELETE From `{$this->mPrefix}tags_pages`   ";
        $sql .= "where tag_id ='{$tag_id}'   ";
        $this->mDb->query($sql);
    }

    public function addTagsPages($tags_pages, $tag_id) {
        if (count($tags_pages) > 0) {

            foreach ($tags_pages as $k => $v) {
                if ($v) {
                    $sql = "INSERT INTO `{$this->mPrefix}tags_pages` SET ";
                    $sql .= " tag_id ='{$tag_id}' ,  page_name ='{$v['page_name']}'  ";
                    // echo $sql;
                    $this->mDb->query($sql);
                }
            }
        }
    }

    function getTagOptions($tag_id) {
        $sql = "SELECT * FROM `tags_options`";
        $sql .= " WHERE `tag_id` = '{$tag_id}' and is_deleted = '0' order by sort asc ";
        $res = $this->mDb->getAll($sql);
        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
                $sql = "SELECT lang_code ,label,tag_color , tag_option_id as id FROM `tags_option_langs`";
                $sql .= " WHERE `tag_option_id` = '{$res[$i]['id']}' ";
                // echo $sql;
                $res[$i]['lang_parameter'] = $this->mDb->getAll($sql);
            }
        }
        // echo "<pre>";print_r($res);die();  
        return $res;
    }

    function getTagOptionsType($tag_id) {

        $sql = "SELECT f.id  ,f.type  , fl.label FROM `tags` f  ";

        $sql .= " LEFT JOIN `tags_langs` fl ON f.id = fl.tag_id  AND fl.lang_code = '{$this->lang_code}' ";
        $sql .= " where f.id='{$tag_id}' and f.is_deleted = '0' and f.active = '1' Group By f.id  ORDER BY f.sort ";
//       echo $sql."<hr>";
        $tags = $this->mDb->getRow($sql);

//	p($sql);


        $sql = "SELECT  fo.id as value , fol.label   FROM `tags_options` fo ";
        $sql .= " LEFT JOIN `tags_option_langs` fol ON fo.id = fol.tag_option_id AND fol.lang_code = '{$this->lang_code}' ";
        $sql .= " WHERE fo.tag_id = '{$tags['id']}' and fo.is_deleted = '0' ";
        $sql .= " order by fo.sort asc ";
//          echo $sql."<hr>";
        $tags['options'] = $this->mDb->getAll($sql);

        return $tags;
    }

    function getOneTag($id) {
        $sql = "SELECT * FROM `tags`";
        $sql .= " WHERE `id` = '{$id}' and is_deleted = '0'  ";
        $res = $this->mDb->getRow($sql);
        if ($res) {
            $sql = "SELECT lang_code ,label FROM `tags_langs`";
            $sql .= " WHERE `tag_id` = '{$id}' ";
            $res['lang_parameter'] = $this->mDb->getAll($sql);
            $res['options'] = $this->getTagOptions($id);
            $res['tag_pages'] = $this->getTagsPages($id);
        }
        // echo "<pre>";print_r($res);die();  
        return $res;
    }

    public function getTagsPages($id) {

        $sql = "SELECT page_name  FROM `tags_pages`  ";
        $sql .= " WHERE  tag_id  ='{$id}'     ";
        $res = $this->mDb->getAll($sql);
        //  echo $sql;
        //   die();
        return $res ? $res : array();
    }

    function deleteTag($ids) {

        $sql = "UPDATE tags  set  is_deleted = '1' ";
        $sql .= " WHERE `id` = 0";
        foreach ($ids as $id) {
            $sql .= " || `id` = '{$id}' ";
        }
        // echo "$sql";die();

        return $this->mDb->query($sql);
    }

    public function addEditOptions($parent_id, $tags_options) {



        $options = array();

        for ($language = 0; $language < count($tags_options); $language++) {
            for ($i = 0; $i < count($tags_options[0]['details']['options']); $i++) {



                $options[$i]['tag_id'] = $parent_id;
                if ($tags_options[$language]['details']['options'][$i]['id']) {
                    $options[$i]['id'] = $tags_options[$language]['details']['options'][$i]['id'];
                }
                $options[$i]['is_deleted'] = $tags_options[$language]['details']['options'][$i]['is_deleted'] == true || $tags_options[$language]['details']['options'][$i]['is_deleted'] == '1' ? '1' : '0';
                $options[$i]['sort'] = $tags_options[$language]['details']['options'][$i]['sort'];
//                $options[$i]['tag_color'] = $tags_options[0]['details']['options'][$i]['tag_color'];
                // $options[$i]['id'] = $options[$i]['id']? $options[$i]['id'] : '';

                $options[$i]['data'][$language]['lang_code'] = $tags_options[$language]['lang_code'];
                $options[$i]['data'][$language]['label'] = $tags_options[$language]['details']['options'][$i]['label'];
                $options[$i]['data'][$language]['tag_color'] = $tags_options[0]['details']['options'][$i]['tag_color'];
            }
        }
//      p($options);




        for ($i = 0; $i < count($options); $i++) {
            if ($options[$i]['id']) {
                $sql = "UPDATE `tags_options` SET  `is_deleted` = '{$options[$i]['is_deleted']}' ,`sort` = '{$options[$i]['sort']}'     where id  ='{$options[$i]['id']}'  ";
                $this->mDb->query($sql);
                $new_id2 = $options[$i]['id'];
            } else {


                $sql = "INSERT INTO `tags_options` SET tag_id ='{$parent_id}' ,`is_deleted` = '{$options[$i]['is_deleted']}' ,`sort` = '{$options[$i]['sort']}'  ";
//               echo $sql."<hr>";
                $this->mDb->query($sql);
                $new_id2 = $this->mDb->getLastInsertId();
            }

            $sql = "DELETE FROM `tags_option_langs` ";
            $sql .= " WHERE tag_option_id='{$options[$i]['id']}'  ";
            $this->mDb->query($sql);

            foreach ($options[$i]['data'] as $k => $v) {

//                if (!$row) {
                $sql = " INSERT INTO `tags_option_langs` SET  lang_code = '{$v['lang_code']}' , label = '{$v['label']}' , tag_color = '{$v['tag_color']}'  ,tag_option_id  = '{$new_id2}',date_added='{$this->dateTime}' ";
//                echo "$sql" . "<hr>";
                $this->mDb->query($sql);
//                }
                //	$this->addEditOptions($v['lang_code'], $v['details']['options']);
            }
        }



        // echo "<pre>";print_r($res);die();
    }

//    public function getTagsPages_ids($pageName, $searchTitle = '', $aStart = '', $aLimit = '') {
//
//    
//        $sql = "SELECT f.id  ,f.type  , fl.label FROM `tags` f  ";
//        $sql .= " LEFT JOIN `tags_pages` fss ON f.id = fss.tag_id    ";
//        $sql .= " LEFT JOIN `tags_langs` fl ON f.id = fl.tag_id  AND fl.lang_code = '{$this->lang_code}' ";
//        $sql .= " where fss.`page_name` in  ({$pageName})  and f.is_deleted = '0' and f.active = '1' Group By f.id  ORDER BY f.sort ";
//        $tags = $this->mDb->getAll($sql);
//
//        //p($sql);
//
//        for ($i = 0; $i < count($tags); $i++) {
//            $sql = "SELECT  fo.id , fol.label   FROM `tags_options` fo ";
//            $sql .= " LEFT JOIN `tags_option_langs` fol ON fo.id = fol.tags_option_id AND fol.lang_code = '{$this->lang_code}' ";
//            $sql .= " WHERE fo.tag_id = '{$tags[$i]['id']}' and fo.is_deleted = '0' and fol.label !='' order by fo.sort  asc ";
//
//            //			  echo $sql."<hr>";
//            $tags[$i]['options'] = $this->mDb->getAll($sql);
//        }
//
//        return $tags;
//    }

    public function getTagsPages_ids($page_name, $searchTitle = '', $aStart = '', $aLimit = '') {
        $pageName = explode(',', $page_name);
        $quoted_pageName = array_map(function ($item) {
            return "'" . trim($item) . "'";
        }, $pageName);
        $pageName_list = implode(',', $quoted_pageName);

        $sql = "SELECT f.id , fso.id as value ,fl.label  parent_label, fol.label  FROM `tags` f  ";
        $sql .= " LEFT JOIN `tags_options` fso ON f.id = fso.tag_id    ";
        $sql .= " LEFT JOIN `tags_option_langs` fol ON fso.id = fol.tag_option_id AND fol.lang_code = '{$this->lang_code}' ";
        $sql .= " LEFT JOIN `tags_pages` fss ON f.id = fss.tag_id    ";
        $sql .= " LEFT JOIN `tags_langs` fl ON f.id = fl.tag_id  AND fl.lang_code = '{$this->lang_code}' ";
        $sql .= " where  fss.`page_name` in  ({$pageName_list})  and f.is_deleted = '0' and f.active = '1' and   fso.is_deleted = '0'  ";
        $sql .= $searchTitle ? ' AND (fl.label like "%' . $searchTitle . '%" ||  fol.label like "%' . $searchTitle . '%" ) ' : '';
        $sql .= " Group By fso.id  ORDER BY f.sort ASC, fso.sort ASC";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
//       echo $sql."<hr>";
        $tags = $this->mDb->getAll($sql);

        return $tags;
    }

    /////////////////////////////////Form Shape///////////////////////////////////////

    function getIdsOfParentService($id) {
        $sql = "SELECT parent FROM `services`";
        $sql .= " WHERE `id` in ({$id}) ";
        $res = $this->mDb->getAll($sql);
        if ($res) {
            return fetchArrayValue_from_dataBase($res, 'parent');
        }
    }

    public function getAllPagesNameOfTagsById($tag_id, $limit = '') {

        $sql = "SELECT tp.page_name FROM tags_pages  tp ";
        $sql .= " WHERE tp.`tag_id` = '{$tag_id}'   ";
        $sql .= $limit ? " Limit  1 " : " ";

        // echo  $sql ;die();

        $res = $this->mDb->getAll($sql);
        return fetchArrayValue_from_dataBase($res, 'page_name');
    }

    public function getTagForExcelSheet($product_id = '') {
        if ($product_id) {
            $sql = "SELECT service_id FROM product_services where product_id = '{$product_id}'";
            $product_service_ids = $this->mDb->getAll($sql);
            $product_service_ids_string = fetchArrayValue_from_dataBase($product_service_ids, 'service_id');
            // p($product_service_ids_string);
        }
        $parents_Ids = $this->getIdsOfParentService($product_service_ids_string);
        if ($parents_Ids) {
            $product_service_ids_string .= ',' . $parents_Ids;
            // p($searchServiceId);
        }


        // p($product_id);
        $sql = "SELECT fs.id ,  pfs.value , sl.ser_name , s.active as ser_active  , fs.active , fs.type , fsl.label FROM form_shapes  fs ";
        $sql .= " LEFT JOIN `form_shape_langs` fsl ON fs.id = fsl.form_shape_id  AND  fsl.lang_code = '{$this->lang_code}'  ";
        $sql .= " LEFT JOIN `form_shape_services` fss ON fs.id = fss.form_shape_id ";
        $sql .= " LEFT JOIN `services` s ON s.id = fss.service_id ";
        $sql .= " LEFT JOIN `service_langs` sl ON sl.service_id = fss.service_id  AND  sl.lang_code = '{$this->lang_code}'";
        $sql .= " LEFT JOIN `product_form_shapes` pfs ON fs.id = pfs.form_shape_id ";
        $sql .= " WHERE fs.`is_deleted` = '0'   ";
        $sql .= $product_id ? " AND pfs.product_id ='{$product_id}' AND fss.service_id  in ({$product_service_ids_string})  " : " ";
        $sql .= $parents_Ids ? "  AND fss.service_id  in ({$product_service_ids_string})  " : " ";
        $sql .= " GROUP by fs.id  ORDER BY sl.ser_name  ";
        // if ($product_id) {
//         	echo $sql."<hr>";
        // }
        $res = $this->mDb->getAll($sql);

        $return_array = array();

        for ($i = 0; $i < count($res); $i++) {

            if ($res[$i]['type'] == 'select' || $res[$i]['type'] == 'm_select') {
                $sql = "SELECT fso.id , fsol.label as label_option   FROM form_shape_options  fso ";
                $sql .= $product_id ? " LEFT JOIN `product_form_shapes` pfs ON pfs.value = fso.id " : " ";
                $sql .= " LEFT JOIN `form_shape_option_langs` fsol ON fso.id = fsol.form_shape_option_id AND  fsol.lang_code = '{$this->lang_code}' ";
                $sql .= " where fso.form_shape_id= '{$res[$i]['id']}' AND  fso.is_deleted ='0'    ";
                $sql .= $product_id ? " AND pfs.product_id ='{$product_id}' " : " ";
                $sql .= " GROUP by fso.id   order by fso.sort asc  ";

                $options = $this->mDb->getAll($sql);
                for ($o = 0; $o < count($options); $o++) {
                    $res[$i]['label_option'] = $options[$o]['label_option'];
                    $res[$i]['value'] = $options[$o]['id'];
                    $res[$i]['key'] = $res[$i]['id'] . $res[$i]['ser_name'] . $res[$i]['label_option'] . $res[$i]['value'] . $res[$i]['label'] . $res[$i]['type'];

                    if (!is_numeric(array_search($res[$i]['key'], array_column($return_array, 'key')))) {
                        array_push($return_array, $res[$i]);
                    }
                }
            } else {
                // echo array_search("key", $return_array); if (!is_numeric(array_search("key", $return_array))) {
                array_push($return_array, $res[$i]);
            }
        }
        // p($return_array);
        return $return_array;
    }
}
