<?php

$unitsObj = new units();

class Units {

    public $mDb;
    public $mConfig;
    public $dateTime;
    public $lang_code;

    public function __construct() {
        global $Config;
        $this->mDb = new iplus();
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->lang_code = LANGUAGE;
    }

    function getUnits($aStart, $aLimit, $sort, $type, $searchTitle) {

        $sql = "SELECT t.* ,tl.title, u.user_name AS 'addedBy' FROM units t";
        $sql .= " LEFT JOIN `unit_langs` tl ON t.id = tl.unit_id ";

        $sql .= " LEFT JOIN `users` u ON u.id = t.admin_id ";

        $sql .= " WHERE t.id > 0  AND tl.lang_code ='{$this->lang_code}'  ";

        $sql .= $searchTitle ? ' AND (tl.title like "%' . $searchTitle . '%" ||  t.code like "%' . $searchTitle . '%" ) ' : '';

        $sql .= " ORDER BY t.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

        // echo $sql; die();

        return $this->mDb->getAll($sql);
    }

    function getSearchUnitsCount($sort, $type, $searchTitle) {
        $sql = "SELECT COUNT(DISTINCT t.`id`) as 'result_count' FROM units t ";
        $sql .= " LEFT JOIN `unit_langs` tl ON t.id = tl.unit_id ";

        $sql .= " WHERE t.`id` > 0";

        $sql .= $searchTitle ? ' AND ( tl.title like "%' . $searchTitle . '%" ||  t.code like "%' . $searchTitle . '%" ) ' : '';

        //echo $sql; die();

        return $this->mDb->getOne($sql);
    }

    function getUnitsCount() {
        $sql = "SELECT COUNT(DISTINCT `id`) as 'count' FROM `units`";
        return $this->mDb->getOne($sql);
    }

    function addEditUnit($temp) {
        $temp['active'] = $temp['active'] ? '1' : '0';

        if ($temp['id'] === null || $temp['id'] === '') {
            // add

            $sql = "INSERT INTO `units` SET ";
            foreach ($this->mDb->getCols('units', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'lang_parameter' ) ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$this->dateTime}'";
            // echo "$sql";die();
            $res = $this->mDb->query($sql);
            if ($res) {
                $id = $this->mDb->getLastInsertId();
                //enter lang_details
                foreach ($temp['lang_Details'] as $k => $v) {
                    $sql = " INSERT INTO `unit_langs` SET  lang_code = '{$v['lang_code']}'  , title = '{$v['details']['title']}'  , unit_id='{$id}' ";
                    // echo "$sql";die();
                    $res2 = $this->mDb->query($sql);
                }

                # code...
            }
            return $res;
        } else {

            $sql = "UPDATE `units` SET ";
            foreach ($this->mDb->getCols('units', $temp) as $k => $v) {
                $sql .= ($k == 'lang_Details' || $k == 'id' || $k == 'lang_parameter' ) ? "" : "`{$k}`='{$v}',";
            }
            $sql = substr($sql, 0, -1);
            $sql .= " WHERE `id` = '{$temp['id']}'";
            // echo $sql ;die();
            $res = $this->mDb->query($sql);
            if ($res) {

                //delete lang_details
                $sql = "DELETE FROM `unit_langs` ";
                $sql .= " WHERE unit_id='{$temp['id']}'  ";
                $res2 = $this->mDb->query($sql);

                //enter lang_details
                foreach ($temp['lang_Details'] as $k => $v) {
                    $sql = " INSERT INTO `unit_langs` SET  lang_code = '{$v['lang_code']}' , title = '{$v['details']['title']}'   ,unit_id='{$temp['id']}' ";
                    // echo "$sql";die();
                    $res2 = $this->mDb->query($sql);
                }

                # code...
            }

            return $res;
        }
    }

    function getOneUnit($id) {
        $sql = "SELECT * FROM `units`";
        $sql .= " WHERE `id` = '{$id}' ";
        $res = $this->mDb->getRow($sql);
        if ($res) {
            $sql = "SELECT lang_code ,title FROM `unit_langs`";
            $sql .= " WHERE `unit_id` = '{$id}' ";
            $res['lang_parameter'] = $this->mDb->getAll($sql);
        }
        // echo "<pre>";print_r($res);die();
        return $res;
    }

//    function deleteUnit($ids) {
//        $sql = "DELETE FROM `units` ";
//        
//        $sql .= " WHERE `id` = 0";
//        foreach ($ids as $id) {
//            $sql .= " || `id` = '{$id}' ";
//        }
//
//        return $this->mDb->query($sql);
//    }

    function deleteUnit($ids) {

        $deletedCount = 0;
        $failedUnits = [];
        foreach ($ids as $id) {
            $checkSql = "SELECT COUNT(id) as count_unit FROM `products` WHERE `unit_id` = {$id}";
     
            $result = $this->mDb->getOne($checkSql);
  
            if ($result == 0) {
                $deleteSql = "
                DELETE `units`, `unit_langs`
                FROM `units`
                LEFT JOIN `unit_langs` ON `units`.`id` = `unit_langs`.`unit_id`
                WHERE `units`.`id` = {$id}
            ";
                $this->mDb->query($deleteSql);
                $deletedCount++;
            } else {
                // إضافة الوحدات التي لا يمكن حذفها إلى المصفوفة
                $failedUnits[] = $id;
            }
        }

        // إرجاع النتيجة مع الوحدات التي لم يتم حذفها
        return [
            'success' => true,
            'message' => 'تمت معالجة الوحدات بنجاح.',
            'deleted_count' => $deletedCount,
            'failed_units' => $failedUnits, // الوحدات التي لم يتم حذفها
        ];
    }
}

?>