<?php

$trademarksObj = new Trademarks();

class Trademarks
{
    private $mDb;
    private $mConfig;
    private $dateTime;
    private $lang_code;

    public function __construct()
    {
        global $Config;

        // Initialize database connection (assuming iplus is a database handler class)
        $this->mDb = new iplus();

        // Set configurations and default values
        $this->mConfig = $Config;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->lang_code = defined('LANGUAGE') ? LANGUAGE : 'en'; // Provide a default if LANGUAGE is not defined
    }

    function getTrademarks($aStart, $aLimit, $sort, $type, $searchTitle, $searchCategoryId, $id = '') {

        $sql = "SELECT  t.* ,tl.title,tl.description  FROM trademarks t";
        $sql .= " LEFT JOIN `trademark_langs` tl ON t.id = tl.trademark_id  AND  tl.lang_code = 'ar'  ";
        $sql .= " LEFT JOIN `products` p ON  p.trademark_id    =  t.id ";
        $sql .= " LEFT JOIN `product_services` ps ON ps.product_id = p.id    ";
        $sql .= " WHERE t.id > 0 and t.active = '1'   ";
        $sql .= " AND ps.service_id  in ($searchCategoryId)  ";
        $sql .= $id ? " AND t.id='{$id}' " : '';
        $sql .= $searchTitle ? ' AND (tl.title like "%' . $searchTitle . '%" ||  t.code like "%' . $searchTitle . '%" || t.`alternate_words_array` like "%' . $searchTitle . '%"  ) ' : '';
        $sql .= $sort == 'title' ? " group by t.id  ORDER BY tl.{$sort} {$type} " : "  group by t.id  ORDER BY t.{$sort} {$type} ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
// 	 echo $sql."<hr>";
        //  echo $sql; die();

        return $this->mDb->getAll($sql);
    }

    function getFamousTradeMarks($services) {
        $service_ids = fetchArrayValue_from_dataBase($services, 'id');
        $sql = "SELECT t.* ,tl.title ,count(t.id) as count_t   FROM trademarks t";
        $sql .= " LEFT JOIN `trademark_langs` tl ON t.id = tl.trademark_id  AND  tl.lang_code = 'ar'  ";
        $sql .= " LEFT JOIN `products` p ON  p.trademark_id    =  t.id ";
        $sql .= " LEFT JOIN `product_services` ps ON ps.product_id = p.id    ";

        $sql .= " WHERE t.id > 0 AND  ps.service_id  in ($service_ids) and t.active = '1' ";
        $sql .= " GROUP by t.id order by count_t desc   ";

        // echo $sql; die();

        return $this->mDb->getAll($sql);
    }

    function getAllTrademarks($aStart, $aLimit, $searchTitle) {

        $sql = "SELECT t.id ,tl.title AS name FROM trademarks t";
        $sql .= " LEFT JOIN `trademark_langs` tl ON t.id = tl.trademark_id AND tl.lang_code ='{$this->lang_code}'";
        $sql .= " WHERE t.id > 0    ";
        $sql .= $searchTitle ? ' AND (tl.title like "%' . $searchTitle . '%" ||  t.code like "%' . $searchTitle . '%" ) ' : '';
        $sql .= " AND  t.active ='1' ";
        $sql .= " ORDER BY tl.title ASC ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
//		   echo $sql; die();
        $res = $this->mDb->getAll($sql);
        return $res ? $res : [];
    }

}
