<?php

$userObj = new users();

class users {

    public iplus $mDb;
    public iplusMaster $masterDb;
    public array $mConfig;
    public string $lang_code;
    public string $dateTime;
    public string $mPrefix;
    public $client_info;
    public $set_from;
    public $Affiliator_Info;

    public function __construct() {
        global $Config;

        $this->mDb = new iplus();
        $this->masterDb = new iplusMaster();
        $this->mConfig = $Config;
        $this->mPrefix = $Config['prefix'];
        $this->dateTime = date('Y-m-d H:i:s');
        $this->lang_code = LANGUAGE ?? 'ar';
        if (defined('CLIENT')) {
            $this->client_info = CLIENT;
        } else {
            $this->client_info['id'] = '0';
        }
        $this->set_from = SETFROM;
        if (defined('AFFILIATOR') && isset(AFFILIATOR['id'])) {
            $this->Affiliator_Info = AFFILIATOR;
        }
    }

// public function checkUserLogin($data)
// {
//     $sql = "SELECT `id`, `password` FROM `users` ";
//     $sql .= " WHERE (`mobile` = '{$data}' || `email` = '{$data}')   AND `user_level` = '3000'AND ((`affiliator_id` = " . AFFILIATOR['id'] . " AND `user_level` = '3000') || id =  " . OWNER['id'] . " ) ";
//     //   echo($sql);die();
//     return $this->mDb->getRow($sql);
// }

    function changePasswordInEmail($col, $value, $aPassword) {
        $sql = "UPDATE `{$this->mPrefix}users` SET `password` = '{$aPassword}' ";
        $sql .= "WHERE `{$col}`='{$value}' ";
//        echo $sql."<hr>";
        return $this->mDb->query($sql);
    }

    function getAllStores($aStart, $aLimit, $sort, $type, $searchTitle, $searchAffiliator_id) {

        $sql = "SELECT t.id ,tl.title FROM stores t";
        $sql .= " LEFT JOIN `store_langs` tl ON t.id = tl.store_id AND tl.lang_code ='{$this->lang_code}' ";
        $sql .= $searchAffiliator_id ? " LEFT JOIN `affiliator_stores` ast ON t.id = ast.store_id " : " ";
        $sql .= " WHERE t.id > 0 AND   t.active = '1'   and t.type='local'   ";
        $sql .= $searchAffiliator_id ? " AND  ast.user_id = '{$searchAffiliator_id}' " : " ";
        $sql .= $searchTitle ? ' AND (tl.title like "%' . $searchTitle . '%" ||  t.code like "%' . $searchTitle . '%" ) ' : '';
        $sql .= " ORDER BY t.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

        //   echo $sql; die();

        return $this->mDb->getAll($sql);
    }

    public function getUserLevelByColumns($columns, $columns_plan) {

        $columns = ('ul.' . implode(",ul.", $columns));
        $sql = "SELECT u.dealer_id, $columns FROM `users` u  ";
        $sql .= " LEFT JOIN `user_levels` ul ON ul.id = u.user_level ";
        $sql .= " WHERE u.`id` = " . ADMIN['id'] . " ";
//        echo $sql . "<hr>";
        $res = $this->mDb->getRow($sql);
        if ($columns_plan) {
            $columns_plan = ('mdp.' . implode(",mdp.", $columns_plan));
            $sql1 = "SELECT  $columns_plan FROM `master_dealers_plans` mdp  ";
            $sql1 .= " LEFT JOIN `master_dealers` md ON md.plan_id = mdp.id ";
            $sql1 .= " WHERE md.`id` = '{$res['dealer_id']}'  ";
//            echo $sql1 . "<hr>";
            $res1 = $this->masterDb->getRow($sql1);
            if ($res1) {
                return array_replace($res, $res1);
            } else {
                return $res;
            }
        } else {
            return $res;
        }
    }

    public function getClientsByUserType(
            $aStart, $aLimit, $sort, $type, $searchName, $searchAffiliator_id, $userType = 'client'
    ) {

        $sql = "SELECT u.id, u.affiliator_id, u.user_name , u.last_name ";
        $sql .= " FROM `users` u ";
        $sql .= " WHERE u.id > 0";
        $sql .= " AND u.`user_level` = '3000'";
        $sql .= $searchAffiliator_id ? " AND u.`affiliator_id` = '{$searchAffiliator_id}' " : "";
        $sql .= " AND u.`user_type` = '{$userType}' ";
//        $sql .= $searchName ? ' AND  u.user_name like "%' . $searchNameArray[0] . '%" && u.last_name like "%' . $searchNameArray[1] . '%" ' : '';
//        if (!empty($searchNameArray)) {
//            $nameConditions = [];
//            foreach ($searchNameArray as $namePart) {
//                $nameConditions[] = "(u.user_name LIKE '%{$namePart}%' OR u.last_name LIKE '%{$namePart}%')";
//            }
//            $sql .= ' AND ' . implode(' AND ', $nameConditions);
//        }
        if ($searchName) {
            $searchNameArray = explode(" ", $searchName);
            if (count($searchNameArray) > 1) {
                $conditions = [];
                for ($i = 0; $i < count($searchNameArray) - 1; $i++) {
                    $conditions[] = "(u.user_name LIKE '%{$searchNameArray[$i]}%' OR u.last_name LIKE '%{$searchNameArray[$i]}%')";
                }
                $lastNamePart = $searchNameArray[count($searchNameArray) - 1];
                $conditions[] = "(u.user_name LIKE '%{$lastNamePart}%' OR u.last_name LIKE '%{$lastNamePart}%')";
                $sql .= "AND (" . implode(' AND ', $conditions) . ") ";
            } else {
                $sql .= "AND (u.user_name LIKE '%{$searchName}%' OR u.last_name LIKE '%{$searchName}%') ";
            }
        }
        $sql .= " AND u.`active` = '1' ";
        $sql .= " ORDER BY u.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart},{$aLimit}" : '';
//       echo $sql . "<hr>";
        $res = $this->mDb->getAll($sql);
        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
                $res[$i]['user_name'] = $res[$i]['user_name'] . ' ' . $res[$i]['last_name'];
            }
        }
        return $res;
    }

    function GetPasswordByEmail($email) {
        $sql = "SELECT `id`,`user_name`,`email`  FROM `{$this->mPrefix}users`";
        $sql .= " WHERE `email` = '{$email}' ";
//echo $sql;
        return $this->mDb->getRow($sql);
    }

    public function checkUserLogin($data) {
        $sql = "SELECT `id`, `password` FROM `users` ";
        $sql .= " WHERE (`mobile` = '{$data}' || `email` = '{$data}') AND ((`affiliator_id` = " . AFFILIATOR['id'] . " AND `user_level` = '3000') || (id =  " . AFFILIATOR['id'] . ") || (`affiliator_id` = '0' AND `user_level` != '3000') ) ";
        $sql .= " and is_deleted ='0'";
//       echo $sql . "<hr>";
        return $this->mDb->getRow($sql);
    }

// public function getUserDataById($id)
// {
//     $sql = "SELECT `id`, `password` FROM `users` ";
//     $sql .= " WHERE (`id` = '{$id}' )   AND `user_level` = '3000'AND ((`affiliator_id` = " . AFFILIATOR['id'] . " AND `user_level` = '3000') || id =  " . OWNER['id'] . " ) ";
//     //   echo($sql);die();
//     return $this->mDb->getRow($sql);
// }

    public function getUserDataById($id) {
        $sql = "SELECT `id`, `password` FROM `users` ";
        $sql .= " WHERE (`id` = '{$id}' )     AND ((`affiliator_id` = " . AFFILIATOR['id'] . " AND `user_level` = '3000') || (id =  " . AFFILIATOR['id'] . ") || (`affiliator_id` = '0' AND `user_level` != '3000') ) ";
//   echo($sql);die();
        return $this->mDb->getRow($sql);
    }

// public function getUserDetailsInfo($id)
// {
//     $sql = "SELECT u.user_name , u.active ,u.email,u.country_code,u.mobile,u.avatar,u.brief,u.client_code,u.address,u.authentication_code FROM `users` u";
//     $sql .= " WHERE u.`id` = '$id' ";
//     $sql .= " AND u.`user_level` = '3000'  AND u.`affiliator_id` = " . AFFILIATOR['id'] . " ";
//     $result = $this->mDb->getRow($sql);
//     // echo "<pre>";
//     // print_r($result);
//     // die();
//     return $result;
// }
    public function getUserDetailsInfo($id, $AddresseId = '') {
        $sql = "SELECT u.id,u.user_name,u.last_name,u.drop_shipping,u.drop_shipping_commission ,u.show_page_inventory_product, u.active  , u.user_level ,u.email,u.country_code,u.mobile,u.avatar,u.brief,u.client_code,u.address";
        $sql .= ",u.share_product_links,u.share_product_photos,u.share_product_descriptions ";
        $sql .= ",u.authentication_code ,u.price_type FROM `users` u";
        $sql .= " WHERE u.`id` = '{$id}' ";
        $sql .= " AND ((u.`affiliator_id` = " . AFFILIATOR['id'] . " AND u.`user_level` = '3000') || (u.id =  " . AFFILIATOR['id'] . ") || (u.`affiliator_id` = '0' AND u.`user_level` != '3000') ) ";
        $result = $this->mDb->getRow($sql);
// echo "<pre>";
// print_r($sql);
// die();
        if ($result) {
            $result['client_address'] = $this->getAllAddress('0', '25', 'id', 'DESC', $id, $AddresseId);
        }
        return $result;
    }

    public function getCartIdByUser() {

        $sql = "SELECT c.id   FROM `carts` c ";
        $sql .= " WHERE `c`.user_id = " . AFFILIATOR['id'] . "  ";
        $sql .= " and  `c`.client_id = " . CLIENT['id'] . "  ";
        $sql .= " and (c.type='packing_in_progress' || c.type='editing_in_progress')";
//        echo $sql . "<hr>";
        $res = $this->mDb->getOne($sql);
// echo "<pre>";print_r($sql);die();
        return $res;
    }

    public function insertAuthCode($aId, $authentication_code) {
        $sql = " UPDATE `users` SET `authentication_code` = '{$authentication_code}'";
        $sql .= " WHERE `id` = '{$aId}'";
// echo $sql; die();
        return $this->mDb->query($sql);
    }

    public function editProfile($temp, $user_id) {
        if ($temp['avatar'] == '' and in_array('avatar', $temp, true)) { //remove image if we removed
            $removableImage = $this->selectImageByParams($user_id, 'avatar', 'avatars');
// echo " $sql";die(); 
        }



        $sql = "UPDATE `users` SET ";
        $sql .= $temp['user_name'] ? "   `user_name` = '{$temp['user_name']}' " : "   ";
        $sql .= "  , `last_name` = '{$temp['last_name']}'   ";
        $sql .= $temp['email'] ? "  , `email` = '{$temp['email']}'   " : " ,  `email` = NULL  ";
        $sql .= $temp['brief'] ? " , `brief` = '{$temp['brief']}' " : "   ";
        $sql .= $temp['avatar'] ? " , `avatar` = '{$temp['avatar']}' " : "   ";
        $sql .= $temp['address'] ? " , `address` = '{$temp['address']}' " : "   ";
        $sql .= $temp['mobile'] ? " , `mobile` = '{$temp['mobile']}' " : "   ";
        if ($temp['password'] != '') {
            $temp['password'] = password_hash($temp['password'], PASSWORD_DEFAULT);
            $sql .= " , `password` = '{$temp['password']}' ";
        }

// $sql .= " `date_added` = '{$this->dateTime}' ";
        $sql .= " WHERE `id` = '{$user_id}'AND ((`affiliator_id` = " . AFFILIATOR['id'] . " AND `user_level` = '3000') || (`affiliator_id` = '0' AND `user_level` != '3000')   ) ";
//  echo " $sql";
// die();
        $res = $this->mDb->query($sql);

        if ($res) {
            if ($removableImage) {
                $this->removeFileFormServier($removableImage, 'users');
            }
            return $this->getUserDetailsInfo($user_id);
        } else {
            return false;
        }
    }

    public function editPassword($temp, $user_id) {

        $temp['new_password'] = password_hash($temp['new_password'], PASSWORD_DEFAULT);

        $sql = "UPDATE `users` SET   `password` = '{$temp['new_password']}' ";
// $sql .= " `date_added` = '{$this->dateTime}' ";
        $sql .= " WHERE `id` = '{$user_id}' AND  (`affiliator_id` = " . AFFILIATOR['id'] . " AND `user_level` = '3000')  ";
// echo " $sql";
// die($sql);
        $res = $this->mDb->query($sql);
        if ($res) {
            return $this->getUserDetailsInfo($user_id);
        } else {
            return false;
        }
    }

    public function signUp($temp) {

// p($temp);
// Add
        $temp['password'] = password_hash($temp['password'], PASSWORD_DEFAULT);

        $sql = "INSERT INTO `users` SET ";
        $sql .= "  `user_name` = '{$temp['user_name']}' ";
        $sql .= $temp['last_name'] ? "  ,`last_name` = '{$temp['last_name']}' " : "";
        $sql .= "  ,`country_code` = '{$temp['country_code']}' ";
        $sql .= $temp['email'] ? "  , `email` = '{$temp['email']}'   " : " ,  `email` = NULL  ";
        $sql .= " , `mobile` = '{$temp['mobile']}' ";
        $sql .= " , `password` = '{$temp['password']}' ";
        $sql .= " , `user_level` = '3000' ";
        $sql .= " , `set_from` = '" . SETFROM . "' ";
        $sql .= " , `active` =  '{$temp['active']}' ";
        $sql .= " , `price_type` =  '{$temp['price_type']}' ";
        $sql .= $temp['address'] ? " , `address` =  '{$temp['address']}' " : "";
        $sql .= $temp['country_id'] ? " , `country_id` =  '{$temp['country_id']}' " : "";
        $sql .= $temp['city_id'] ? " , `city_id` =  '{$temp['city_id']}' " : "";
        $sql .= $temp['district_id'] ? " , `district_id` =  '{$temp['district_id']}' " : "";

        $sql .= " , `affiliator_id` = " . AFFILIATOR['id'] . "  ";
        $sql .= ", `date_added` = '{$this->dateTime}' ";
//        echo $sql . "<hr>";

        $this->mDb->query($sql);

        $id = $this->mDb->getLastInsertId();

        if ($id) {
            if ($temp['country_id'] && ($temp['city_id'] || $temp['district_id'])) {
                $temp['client_id'] = $id;
                $temp['is_default'] = '1';
                $this->addClientAddresses($temp);
            }
            $this->insertAuthCode($id, password_hash($id . $this->mConfig['apihash'], PASSWORD_DEFAULT));
            $this->updateClientCode($id);
            if ($temp['user_type'] == 'client') { // بيانات حساب العملاء
                $accountInfo = $this->getAccountIdByType('clients');
            } elseif ($temp['user_type'] == 'delegate') { // بيانات حساب الموردين 
                $accountInfo = $this->getAccountIdByType('suppliers');
            }
            if ($accountInfo) {

                $account_code = $this->addAccount($accountInfo);
                $this->updateAccountIdInUser($account_code, $id);
            }
        }
        return $this->getUserDetailsInfo($id);
    }

    public function addClientAddresses($data) {
        $sql = "INSERT INTO `client_addresses` SET ";
        $sql .= "  `country_id` = '{$data['country_id']}' ";

        $sql .= $data['city_id'] ? " ,`city_id` = '{$data['city_id']}' " : "";
        $sql .= $data['district_id'] ? " ,`district_id` = '{$data['district_id']}' " : "";
        $sql .= " ,`title` = '{$data['address']}' ";
        $sql .= " ,`set_from` = '" . SETFROM . "' ";
        $sql .= $data['is_default'] ? " ,`is_default` = '{$data['is_default']}' " : "";
        $sql .= " ,`client_id` = '{$data['client_id']}'   , `date_added` = '{$this->dateTime}' ; ";
//        echo $sql . "<hr>";
        return $this->mDb->query($sql);
    }

    public function editClientAddresses($data, $id) {
        $sql = " UPDATE  `client_addresses` SET  ";
        $sql .= " `user_name` = '{$data['user_name']}'";
        $sql .= $data['last_name'] ? ", `last_name` = '{$data['last_name']}'" : "";
        $sql .= $data['mobile'] ? ", `mobile` = '{$data['mobile']}'" : "";
        $sql .= $data['mobile_2'] ? ", `mobile_2` = '{$data['mobile_2']}'" : "";
        $sql .= " WHERE `id` = '{$id}'  ";
//         echo $sql."<hr>";
        return $this->mDb->query($sql);
    }

    public function getClientAddressesIdByData($data) {

        $sql = "SELECT  id   FROM `client_addresses`  ";
        $sql .= " WHERE  `country_id` = '{$data['country_id']}'   ";
        $sql .= " and  `city_id` = '{$data['city_id']}' ";
        $sql .= " and  `district_id` = '{$data['district_id']}' ";
        $sql .= " and  client_id = '{$data['client_id']}'  ";

//        echo $sql . "<hr>";
        $res = $this->mDb->getOne($sql);
// echo "<pre>";print_r($sql);die();
        return $res;
    }

    public function updateClientCode($id) {
        $sql = " UPDATE  `users` SET `client_code` = '{$id}' ";
        $sql .= " WHERE `id` = '{$id}'  ";
//         echo $sql."<hr>";
        return $this->mDb->query($sql);
    }

    public function updateAccountIdInUser($account_code, $id) {
        $sql = " UPDATE  `users` SET `account_code` = '{$account_code}' ";
        $sql .= " WHERE `id` = '{$id}'  ";
//         echo $sql."<hr>";
        return $this->mDb->query($sql);
    }

    function addAccount($temp) {

        $sql = "INSERT INTO `accounts` SET ";
        foreach ($this->mDb->getCols('accounts', $temp) as $k => $v) {
            $sql .= ($k == 'lang_Details') ? "" : "`{$k}`='{$v}',";
        }
        $sql .= " `date_added` = '{$this->dateTime}'";
//             echo  $sql ."<hr>";
        $res = $this->mDb->queryreturnlastid($sql);

        return $res ? $temp['code'] : "0";
    }

    public function getAccountIdByType($type) {

        $sql = "SELECT   a.id as parent,a.code,'1' as account_type,'clients' as mode ,(SELECT count(id) FROM `{$this->mPrefix}accounts` WHERE parent = a.id) as code_count  FROM `{$this->mPrefix}accounts_routing_list` arl ";
        $sql .= " LEFT JOIN `accounts` a ON a.code = arl.account_code ";
        $sql .= "WHERE arl.routing_key = '{$type}' ";

        $res = $this->mDb->getRow($sql);
        $res['code'] = $res['code'] . ($res['code_count'] > '0' ? +$res['code_count'] + 1 : '1');
        $res['type'] = $type == 'clients' ? 'debtor' : 'creditor';

        unset($res['code_count']);
//        echo $sql;
        return $res;
    }

// public function getForgateDateByParams($temp)
// {
//     $sql = "SELECT `mobile`,`id`,email FROM `users` WHERE (mobile  = '{$temp['mobile']}'   ) ";
//     $sql .= " AND  `user_level` = '3000'  AND affiliator_id = " . AFFILIATOR['id'] . " ";
//     // echo $sql ;die();
//     return $this->mDb->getRow($sql);
// }

    public function getForgateDateByParams($temp) {
        $sql = "SELECT `mobile` ,active FROM `users` WHERE (  mobile  = '{$temp['mobile']}' )  AND `user_level` = '3000' ";
        $sql .= " AND affiliator_id = " . AFFILIATOR['id'] . "   ";

// echo $sql ;die();
        return $this->mDb->getRow($sql);
    }

    public function insertForgateCode($mobile, $code, $count) {
        $this->deleteReqordForgateCode($mobile);
        $sql = "INSERT INTO `forgate_password_codes` SET ";
        $sql .= "  `count` = '{$count}' ";
        $sql .= " , `code` =  '{$code}' ";
        $sql .= " , `mobile` = '" . $mobile . "'  ";
        $sql .= ", `date_added` = '{$this->dateTime}' ";
//  echo $sql; die();
        return $this->mDb->query($sql);
    }

    public function getReqordForgateCode($mobile, $code = '') {
        $sql = "SELECT f.* , u.id  as user_id  FROM `forgate_password_codes` f  ";
        $sql .= " LEFT JOIN `users` u ON u.mobile = f.mobile  ";
        $sql .= " WHERE ( u.mobile  = " . $mobile . " ) ";
        $sql .= $code ? "  AND  f.`code` =  '{$code}' " : " ";
        return $this->mDb->getRow($sql);
    }

    public function deleteReqordForgateCode($mobile) {
        $sql = "DELETE FROM  `forgate_password_codes` ";
        $sql .= " WHERE (  mobile  = " . $mobile . " ) ";
        $res = $this->mDb->query($sql);
        return $res;
    }

    public function changePassword($id, $aPassword) {
        $sql = "UPDATE `users` SET `password` = '{$aPassword}' ";
        $sql .= "WHERE `id` = '{$id}' ";
        return $this->mDb->query($sql);
    }

// public function cheackByParam($col, $value, $id = '', $col2 = '', $value2 = '')
// {
//     $sql = "SELECT `{$col}` FROM `{$this->mPrefix}users` ";
//     $sql .= "WHERE `{$col}`='{$value}'    ";
//     $sql .= $col2 ? " and   `{$col2}`='{$value2}'  " : "";
//     $sql .= $id ? " and  `id`!='{$id}' " : "";
//     $sql .= " AND `user_level` = '3000' AND affiliator_id = " . AFFILIATOR['id'];
//     $res = $this->mDb->getOne($sql);
//     return $res;
// }

    public function cheackByParam($col, $value, $id = '', $col2 = '', $value2 = '') {
        $sql = "SELECT `{$col}` FROM `{$this->mPrefix}users` ";
        $sql .= "WHERE `{$col}`='{$value}'    ";
        $sql .= "   AND ((`affiliator_id` = " . AFFILIATOR['id'] . " AND `user_level` = '3000' ";
        $sql .= $col2 ? " and   `{$col2}`='{$value2}'  " : "";
        $sql .= $id ? " and  `id`!='{$id}' " : "";
        $sql .= " ) ";
        $sql .= " || (id =  " . AFFILIATOR['id'] . ")";
        $sql .= "|| (`affiliator_id` = '0' AND `user_level` != '3000') ) ";
        $sql .= " and is_deleted ='0'";
//        echo $sql . "<hr>";
        $res = $this->mDb->getOne($sql);

        return $res;
    }

// new kslany

    public function selectImageByParams($id, $col_name, $table) {
        $query = "SELECT `{$col_name}` FROM `{$table}` WHERE `id` = '{$id}'";
        return $this->mDb->getOne($query);
    }

    public function removeFileFormServier($file, $folder) {
        $old_file = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . DEALERUPLOAD . '/' . $folder . '/' . $file;
        $old_file_thumb = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . DEALERUPLOAD . '/' . $folder . '/' . 'thumbs/' . $file;

        if (file_exists($old_file)) {
            @unlink($old_file);
        }
        if (file_exists($old_file_thumb)) {
            @unlink($old_file_thumb);
        }
    }

    public function getSomeSettingsInfo($someSettingsString) { //  string ***,***
        $arraySettingsName = explode(',', $someSettingsString);
        $sql = "SELECT  name , value  FROM `settings` ";
        if (count($arraySettingsName) > 0) {
            $sql .= " where  `name` = '{$arraySettingsName[0]}' ";
            if (count($arraySettingsName) > 1) {
                for ($i = 1; $i < count($arraySettingsName); $i++) {
                    $sql .= " || `name` = '{$arraySettingsName[$i]}' ";
                }
            }
        }

// echo $sql;die();
        $res = $this->mDb->getAll($sql);
        return $res;
    }

    public function getUserDataByAuth($Authentication_code, $level_id = '') {
        $sql = "SELECT * FROM `{$this->mPrefix}users` ";
        $sql .= "WHERE `authentication_code`='{$Authentication_code}' ";
        $sql .= $level_id ? "  and user_level = '{$level_id}' " : " ";
//  echo $sql."<hr>";
        $res = $this->mDb->getRow($sql);
        if ($res) {


            if ($res['user_level'] == '1000') {
                $res['stores'] = $this->getAffiliator_stores($res['id']);
                $res['options'] = $this->getAffiliator_options($res['id']);
                $res['services'] = $this->getAffiliator_services($res['id']);
            }
            if ($res['dealer_id']) {
                $res['subscription_info'] = $this->getSubscriptionPeriod($res['dealer_id']);
                $res['subscription_info']['balance'] = $this->getBalanceSumByDealer($res['dealer_id']);
            }
        }
        return $res;
    }

    public function cheackRelationBetweenClientAndAffiliator() {
        // تحقق من أن AFFILIATOR و CLIENT هما مصفوفات تحتوي على المفتاح 'id'
        if (isset(AFFILIATOR['id']) && isset(CLIENT['id'])) {
            $sql = "SELECT id FROM `{$this->mPrefix}users` ";
            $sql .= "WHERE `affiliator_id`='" . AFFILIATOR['id'] . "' and id = '" . CLIENT['id'] . "' ";
            $res = $this->mDb->getOne($sql);
            return $res;
        } else {
            // التعامل مع الحالة في حال كانت AFFILIATOR أو CLIENT لا تحتوي على 'id'
            return null; // أو أي قيمة تناسب الحالة
        }
    }

    public function addVisitsReports($temp) {
        $sql = "INSERT visits_reports 
                SET   
                    affiliator_id = :affiliator_id,  
                    client_id = :client_id,  
                    country = :country, 
                    request_ip = :request_ip,
                    set_from = :set_from, 
                    date_added = :date_added";
        $stmt = $this->mDb->connect()->prepare($sql);
        $Affiliator_id = AFFILIATOR['id'];
        $client_id = CLIENT['id'] ?? 0;
        $set_from = SETFROM;
        $stmt->bindValue(':affiliator_id', $Affiliator_id, PDO::PARAM_INT);
        $stmt->bindValue(':client_id', $client_id, PDO::PARAM_INT);
        $stmt->bindValue(':country', $temp['country'], PDO::PARAM_STR);
        $stmt->bindValue(':request_ip', $temp['request_ip'], PDO::PARAM_STR);
        $stmt->bindValue(':set_from', $set_from, PDO::PARAM_STR);
        $stmt->bindValue(':date_added', $this->dateTime, PDO::PARAM_STR);
        return $stmt->execute();
    }

// public function updateLastLoged($user_id)
// {
//     $sql = "UPDATE `users` SET `last_login_date` = '{$this->dateTime}'  ";
//     $sql .= "WHERE `id` = '{$user_id}' ";
//     $this->mDb->query($sql);
// }
// public function copyImgToServer($path, $uploadFolder = 0, $thumbsFolder = 0)
// {
//     $newname = (substr(md5(uniqid(rand())), 0, 10)) . '.jpg';
//     if ($uploadFolder) {
//         copy($path, $uploadFolder . $newname);
//     }
//     if ($thumbsFolder) {
//         copy($path, $thumbsFolder . $newname);
//     }
//     return $newname;
// }

    public function getAffiliator_services($user_id) {
        $sql = "SELECT sl.ser_name , sl.service_id as id  FROM `affiliator_services` a_s ";
        $sql .= " LEFT JOIN `service_langs` sl ON a_s.service_id = sl.service_id AND sl.lang_code = '{$this->lang_code}' ";
        $sql .= " WHERE   a_s.user_id  ='{$user_id}'     ";

        $res = $this->mDb->getAll($sql);
//  echo $sql;
//   die();
        return $res ? $res : array();
    }

    public function getAffiliator_stores($user_id) {
        $sql = "SELECT sl.title , sl.store_id as id,a_s.sort  FROM `affiliator_stores` a_s ";
        $sql .= " LEFT JOIN `store_langs` sl ON a_s.store_id = sl.store_id AND sl.lang_code = 'ar' ";
        $sql .= " WHERE   a_s.user_id  ='{$user_id}'     ";
        $sql .= " ORDER BY  a_s.sort ";
        $res = $this->mDb->getAll($sql);
//  echo $sql;
//   die();
        return $res ? $res : array();
    }

    public function getAffiliator_options($user_id) {

        $sql = "SELECT *  FROM `affiliator_options` ";
        $sql .= " WHERE   user_id  ='{$user_id}'     ";
        $res = $this->mDb->getRow($sql);
//  echo $sql;
//   die();
        return $res;
    }

    public function getStoreData($store_id) {
        $sql = "SELECT s.* , sl.title , sl.store_id as id  FROM `stores` s ";
        $sql .= " LEFT JOIN `store_langs` sl ON s.id = sl.store_id AND sl.lang_code = 'ar' ";
        $sql .= " WHERE s.id  ='{$store_id}'     ";
        $res = $this->mDb->getRow($sql);
//  echo $sql;
//   die();
        return $res;
    }

////////////////////////////////////////balances ///////////////////////////////////////////
////////////////////////////////////////balances ///////////////////////////////////////////
////////////////////////////////////////balances ///////////////////////////////////////////
////////////////////////////////////////balances ///////////////////////////////////////////
////////////////////////////////////////balances ///////////////////////////////////////////
////////////////////////////////////////balances ///////////////////////////////////////////


    public function deleteBalanceByParams($transaction, $for_id) {
        $sql = "DELETE FROM  `user_balances` ";
        $sql .= " WHERE    transaction ='{$transaction}'  AND for_id = '{$for_id}'   ";
        $res = $this->mDb->query($sql);
        return $res;
    }

    public function addBalance($balance, $dateTime = '') {
        $dateTime = $dateTime ? $dateTime : $this->dateTime;
        if ($balance['user_id'] and $balance['value'] > 0) {


            if (strpos($balance['transaction'], 'pay')) {
                $balance['transaction_type'] = 'pay';
            } else if (strpos($balance['transaction'], 'dept')) {
                $balance['transaction_type'] = 'dept';
            } else if (strpos($balance['transaction'], 'pending')) {
                $balance['transaction_type'] = 'pending';
            }
            $sql = "INSERT INTO `user_balances` SET ";
            foreach ($this->mDb->getCols('user_balances', $balance) as $k => $v) {
                $sql .= ($k == 'confirm_password' || $k == 'id' || $k == 'balance') ? "" : "`{$k}`='{$v}',";
            }
            $sql .= " `date_added` = '{$dateTime}' ";
// echo $sql  ;die();
            return $this->mDb->query($sql);
        }
    }

    public function get_balanceBySomeData($user_id = '', $before_id = '') {
        $sql = "SELECT sum(value)  FROM `user_balances` ";
        $sql .= " WHERE transaction_type ='pay' ";
        $sql .= $before_id ? " AND `id` <= '{$before_id}' " : " ";
        $sql .= $user_id ? " AND  `user_id`  ='{$user_id}' " : " ";

        $pay = $this->mDb->getOne($sql);
        $pay = $pay ? $pay : 0;

// echo $sql;  

        $sql = "SELECT sum(value)  FROM `user_balances` ";
        $sql .= " WHERE transaction_type ='dept'  ";
        $sql .= $before_id ? " AND `id` <= '{$before_id}' " : " ";
        $sql .= $user_id ? " AND  `user_id`  ='{$user_id}' " : " ";

        $dept = $this->mDb->getOne($sql);
        $dept = $dept ? $dept : 0;
// echo $sql; 
        $res = $pay - $dept;
        return $res;
    }

    public function get_balanceByTransaction_typeAndUser_id($transaction_type = '', $user_id = '') {
        $sql = "SELECT sum(value)  FROM `user_balances` ";
        $sql .= " WHERE id > 0 ";
        $sql .= $user_id ? " AND  `user_id`  ='{$user_id}' " : " ";
        $sql .= $transaction_type ? " AND  `transaction_type`  ='{$transaction_type}' " : " ";
        $data = $this->mDb->getOne($sql);
        $data = $data ? $data : 0;
        return $data;
    }

    public function getUser_balance_types($user_id) {


        $sql = "SELECT user_level  FROM `users` ";
        $sql .= " WHERE   id  ='{$user_id}'   ";
        $user_level = $this->mDb->getOne($sql);

        $sql = "SELECT sum(value)  FROM `user_balances` ";
        $sql .= " WHERE   user_id  ='{$user_id}' and transaction_type ='pay' ";

        $res['pay'] = $this->mDb->getOne($sql);
        $res['pay'] = $res['pay'] ? $res['pay'] : 0;

//   echo $sql; die();

        $sql = "SELECT sum(value)  FROM `user_balances` ";
        $sql .= " WHERE   user_id  ='{$user_id}'  and transaction_type ='dept'  ";

        $res['dept'] = $this->mDb->getOne($sql);
        $res['dept'] = $res['dept'] ? $res['dept'] : 0;

        if ($user_level == '1000') {
// affilator

            $sql = "SELECT sum(value)  FROM `user_balances` ";
            $sql .= " WHERE   user_id  ='{$user_id}'  and transaction ='order_commission_pending'  ";
            $res['order_commission_pending'] = $this->mDb->getOne($sql);
            $res['order_commission_pending'] = $res['order_commission_pending'] ? $res['order_commission_pending'] : 0;
        } else if ($user_level == '2000') {
// merchant
            $sql = "SELECT sum(value)  FROM `user_balances` ";
            $sql .= " WHERE   user_id  ='{$user_id}'  and transaction ='order_merchant_supply_pending'  ";
            $res['order_merchant_supply_pending'] = $this->mDb->getOne($sql);
            $res['order_merchant_supply_pending'] = $res['order_merchant_supply_pending'] ? $res['order_merchant_supply_pending'] : 0;
        }
        $sql = "SELECT sum(value)  FROM `user_balances` ";
        $sql .= " WHERE   user_id  ='{$user_id}'  and transaction ='balance_withdrawal_request_pending'  ";
        $res['balance_withdrawal_request_pending'] = $this->mDb->getOne($sql);
        $res['balance_withdrawal_request_pending'] = $res['balance_withdrawal_request_pending'] ? $res['balance_withdrawal_request_pending'] : 0;

        $res['available_balance'] = $res['pay'] - $res['dept'] - $res['balance_withdrawal_request_pending'];
        return $res;
    }

    public function updateBalance($balance, $new_transaction, $new_transaction_type) {


        $sql = " UPDATE `user_balances` SET `transaction` = '{$new_transaction}' , `transaction_type` = '{$new_transaction_type}'";
        $sql .= " WHERE   `for_id` = '{$balance['for_id']}' 
             AND `transaction` = '{$balance['transaction']}' ";

        $sql .= $balance['user_id'] ? "AND `user_id` = '{$balance['user_id']}' " : ' ';
// echo $sql; die();
        return $this->mDb->query($sql);
    }

////////////////////////////////////////addresses ///////////////////////////////////////////
////////////////////////////////////////addresses ///////////////////////////////////////////
////////////////////////////////////////addresses ///////////////////////////////////////////
////////////////////////////////////////addresses ///////////////////////////////////////////
////////////////////////////////////////addresses ///////////////////////////////////////////
////////////////////////////////////////addresses ///////////////////////////////////////////
////////////////////////////////////////addresses ///////////////////////////////////////////


    public function editAddess($temp) {

        $temp['is_default'] = $temp['is_default'] > 0 ? '1' : '0';
        $temp['district_id'] = $temp['district_id'] ? $temp['district_id'] : '0';

        if ($temp['is_default'] == '1') {
            $sql1 = "UPDATE `users` SET `country_id` = '{$temp['country_id']}' ,`city_id` = '{$temp['city_id']}',`district_id` = '{$temp['district_id']}' ";
            $sql1 .= "WHERE `id`   = " . CLIENT['id'] . " ";
//                echo $sql1."<hr>";
            $this->mDb->query($sql1);
        }


        $sql = "UPDATE `client_addresses` SET ";
        $sql .= "  `is_default` = '{$temp['is_default']}' ";
        $sql .= " , `title` = '{$temp['title']}' ";
        $sql .= " , `country_id` = '{$temp['country_id']}' ";
        $sql .= " , `city_id` = '{$temp['city_id']}' ";
        $sql .= " , `district_id` = '{$temp['district_id']}' ";
        $sql .= " , `user_name` = '{$temp['user_name']}' ";
        $sql .= " , `last_name` = '{$temp['last_name']}' ";
        $sql .= " , `mobile` = '{$temp['mobile']}' ";
        $sql .= " , `mobile_2` = '{$temp['mobile_2']}' ";
// $sql .= " , `set_from` = '" . SETFROM . "' ";
        $sql .= " WHERE `id` = '{$temp['id']}' AND `client_id` = " . CLIENT['id'] . " ";
        $res = $this->mDb->query($sql);
        if ($res) {
            if ($temp['is_default'] > 0) {
                $this->setAddressAsDefault($temp['id']);
            }
            return $res;
        }
    }

// client_id	city_id	country_id	title	is_default	set_from	date_added
    public function addAddess($temp) {




// p($temp);
// Add
        $temp['is_default'] = $temp['is_default'] > 0 ? '1' : '0';
        $temp['district_id'] = $temp['district_id'] ? $temp['district_id'] : '0';

        if ($temp['is_default'] == '1') {
            $sql1 = "UPDATE `users` SET `country_id` = '{$temp['country_id']}' ,`city_id` = '{$temp['city_id']}',`district_id` = '{$temp['district_id']}' ";
            $sql1 .= "WHERE `id` = " . CLIENT['id'] . " ";
//                echo $sql1."<hr>";
            $this->mDb->query($sql1);
        }


        $sql = "INSERT INTO `client_addresses` SET ";
        $sql .= "  `is_default` = '{$temp['is_default']}' ";
        $sql .= " , `title` = '{$temp['title']}' ";
        $sql .= " , `country_id` = '{$temp['country_id']}' ";
        $sql .= " , `city_id` = '{$temp['city_id']}' ";
        $sql .= " , `district_id` = '{$temp['district_id']}' ";
        $sql .= " , `user_name` = '{$temp['user_name']}' ";
        $sql .= " , `last_name` = '{$temp['last_name']}' ";
        $sql .= " , `mobile` = '{$temp['mobile']}' ";
        $sql .= " , `mobile_2` = '{$temp['mobile_2']}' ";
        $sql .= " , `set_from` = '" . SETFROM . "' ";
        $sql .= " , `client_id` = " . CLIENT['id'] . " ";
        $sql .= ", `date_added` = '{$this->dateTime}' ";
        $id = $this->mDb->queryreturnlastid($sql);
        if ($id) {
            if ($temp['is_default'] > 0) {

                $this->setAddressAsDefault($id);
            }
            return $id;
        }
//  echo $sql; die();
    }

    public function setAddressAsDefault($id) {
        $sql = "UPDATE `client_addresses` SET ";
        $sql .= "  `is_default` = '0' ";
// $sql .= " , `set_from` = '" . SETFROM . "' ";
        $sql .= " WHERE   `client_id` = " . CLIENT['id'] . " ";
        $res = $this->mDb->query($sql);
        if ($res) {
            $sql = "UPDATE `client_addresses` SET ";
            $sql .= "  `is_default` = '1' ";
// $sql .= " , `set_from` = '" . SETFROM . "' ";
            $sql .= " WHERE id='{$id}' and  `client_id` = " . CLIENT['id'] . " ";
            return $this->mDb->query($sql);
        }
    }

    public function deleteAddress($id) {
        $sql = "DELETE FROM  `client_addresses` ";
        $sql .= " WHERE id = '{$id}' and  `client_id` = " . CLIENT['id'] . " ";
        $res = $this->mDb->query($sql);
        return $res;
    }

    public function cheackIfDefaultAddress($id) {
        $sql = "SELECT is_default FROM `client_addresses` ";
        $sql .= " WHERE id = '{$id}' and  `client_id` = " . CLIENT['id'] . " ";
        $res = $this->mDb->getOne($sql);
        return $res;
    }

    public function getAddressId($city_id, $title) {

        $sql = "SELECT  c.id  FROM `{$this->mPrefix}client_addresses` c ";
        $sql .= "WHERE c.city_id='{$city_id}' and c.title='{$title}' and c.client_id = '" . CLIENT['id'] . "' ";
        $res = $this->mDb->getOne($sql);

//         echo $sql."<hr>";
        return $res ? $res : '';
    }

    public function getAllShippingMethodsByCityId($city_id) {

//        
        $sql = "SELECT sm.id as shipment_id ,smg.id gov_id ,smg.store_price as shipment_value,sml.name as shipment_company,smg.delivery_time_from,smg.delivery_time_to,smg.branch_number,sm.hour_shipped_orders FROM `shipping_methods_governorate` smg ";
        $sql .= " LEFT JOIN `shipping_methods` sm ON sm.id = smg.p_id    ";
        $sql .= " LEFT JOIN `shipping_methods_langs` sml ON sm.id = sml.p_id  AND sml.lang_code = '{$this->lang_code}'   ";
//        $sql .= " LEFT JOIN `shipping_methods_governorate_langs` smgl ON sm.id = smgl.p_id AND smg.id =smgl.shipping_methods_gov_id  AND smgl.lang_code = '{$this->lang_code}'   ";
        $sql .= " WHERE smg.governorate_id = '{$city_id}' and sm.active='1'  and sm.show_shipping_method_customer='1'";
        $sql .= " GROUP BY  sm.id ";
        $sql .= " ORDER BY sm.default_shipping_method DESC ,sm.sort ASC ";
//      echo $sql . "<hr>";
        $res = $this->mDb->getAll($sql);
        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
                $res[$i]['delivery_price'] = $this->getCustomerPrice($res[$i]['gov_id']);
            }
        }
        return $res;
    }

    public function getPlaceName($id) {

        $sql = "SELECT pla_name FROM place_langs  ";
        $sql .= " WHERE place_id ='{$id}' and lang_code='ar' ";

        $res = $this->masterDb->getOne($sql);
        return $res ? $res : '';
    }

    public function getAllAddress($aStart, $aLimit, $sort, $type, $client_id = CLIENT['id'], $AddresseId = '') {

        $sql = "SELECT  c.*   FROM `{$this->mPrefix}client_addresses` c ";

//        $sql .= " LEFT JOIN `place_langs` pl ON pl.place_id = c.city_id  AND  pl.lang_code = 'ar'   ";
//        $sql .= " LEFT JOIN `place_langs` pl2 ON pl2.place_id = c.country_id  AND  pl2.lang_code = 'ar'   ";


        $sql .= "WHERE c.client_id = '{$client_id}' ";
        $sql .= $AddresseId ? " and c.id = '{$AddresseId}' " : "";

        $sql .= " ORDER BY c.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';

//echo $sql."<hr>";
        $res = $this->mDb->getAll($sql);
        if ($res) {
            for ($i = 0; $i < count($res); $i++) {

                $row = $this->getDelivery_price($res[$i]['city_id']);
                $res[$i]['delivery_price'] = $row['customer_price'] ? $row['customer_price'] : '0';
                $res[$i]['shipment_value'] = $row['store_price'] ? $row['store_price'] : '0';
                $res[$i]['shipment_company'] = $row['name'] ? $row['name'] : '';
                $res[$i]['shipment_id'] = $row['id'];

                $res[$i]['shipping_methods'] = $this->getAllShippingMethodsByCityId($res[$i]['city_id']);

                $res[$i]['country_name'] = $this->getPlaceName($res[$i]['country_id']);
                $res[$i]['city_name'] = $this->getPlaceName($res[$i]['city_id']);
                $res[$i]['district_name'] = $this->getPlaceName($res[$i]['district_id']);
            }
        }


// echo $sql;
        return $res;
    }

    public function allClientShippingAddresses($id = '', $aStart = 0, $aLimit = 0, $sort = "id", $type = "DESC") {

        $sql = "SELECT  c.id , c.city_id ,c.country_id ,c.full_name,c.mobile, c.title  ,c.date_added  ";
        $sql .= " FROM `{$this->mPrefix}client_shipping_addresses` c ";
//        $sql .= " LEFT JOIN `place_langs` pl ON pl.place_id = c.city_id  AND  pl.lang_code = 'ar'   ";
//        $sql .= " LEFT JOIN `place_langs` pl2 ON pl2.place_id = c.country_id  AND  pl2.lang_code = 'ar'   ";
        $sql .= " WHERE c.`affiliator_id`='" . AFFILIATOR['id'] . "' and c.client_id = '" . CLIENT['id'] . "' ";
        $sql .= $id ? " and c.id='{$id}'" : "";
        $sql .= " ORDER BY c.{$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
//        echo $sql."<hr>";
        $res = $this->mDb->getAll($sql);
        if ($res) {
            for ($i = 0; $i < count($res); $i++) {
//                $res[$i]['delivery_price'] = $this->getDelivery_price($res[$i]['city_id']);
                $row = $this->getDelivery_price($res[$i]['city_id']);
                $res[$i]['delivery_price'] = $row['customer_price'] ? $row['customer_price'] : '0';
                $res[$i]['shipment_value'] = $row['store_price'] ? $row['store_price'] : '0';
                $res[$i]['shipment_company'] = $row['name'] ? $row['name'] : '';
                $res[$i]['shipment_id'] = $row['id'];

                $res[$i]['shipping_methods'] = $this->getAllShippingMethodsByCityId($res[$i]['city_id']);

                $res[$i]['city_name'] = $this->getPlaceName($res[$i]['city_id']);
                $res[$i]['country_name'] = $this->getPlaceName($res[$i]['country_id']);
            }
        }
        return $res;
    }

    public function addEditClientShipping($data) {

        if ($data["id"]) {
            $sql = " UPDATE `client_shipping` SET `store_name` = '{$data['store_name']}' , `store_img` = '{$data['store_img']}'";
            $sql .= "WHERE  `id` = '{$data["id"]}' and `affiliator_id`='" . AFFILIATOR['id'] . "' and client_id = '" . CLIENT['id'] . "' ";
//            echo $sql; die();
            $res = $this->mDb->query($sql);
            if ($res && $data["last_store_img"] != $data['store_img']) {
                $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . DEALERUPLOAD . "/client-shipping/" . $data["last_store_img"];
                if (file_exists($old_img)) {
                    @unlink($old_img);
                }
                $old_thu = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . DEALERUPLOAD . "/client-shipping/thumbs/" . $data["last_store_img"];
                if (file_exists($old_thu)) {
                    @unlink($old_thu);
                }
            }
            return $res;
        } else {

            $sql = "INSERT INTO `client_shipping` SET ";
            $sql .= "  `store_name` = '{$data['store_name']}' ";
            $sql .= " , `store_img` = '{$data['store_img']}' ";
            $sql .= " , `set_from` = '" . SETFROM . "' ";
            $sql .= " , `app_version` =  '{$data['app_version']}' ";
            $sql .= " , `affiliator_id` = " . AFFILIATOR['id'] . "  ";
            $sql .= " , `client_id` = " . CLIENT['id'] . "  ";
            $sql .= ", `date_added` = '{$this->dateTime}' ";
//        echo $sql; die();

            return $this->mDb->query($sql);
        }
    }

    public function addClientShippingAddresses($data) {

        $sql = "INSERT INTO `client_shipping_addresses` SET ";
        $sql .= "  `full_name` = '{$data['full_name']}' ";
        $sql .= " , `mobile` = '{$data['mobile']}' ";
        $sql .= " , `country_id` = '{$data['country_id']}' ";
        $sql .= " , `city_id` = '{$data['city_id']}' ";
        $sql .= " , `title` = '{$data['title']}' ";
        $sql .= " , `set_from` = '" . SETFROM . "' ";
        $sql .= " , `app_version` =  '{$data['app_version']}' ";
        $sql .= " , `affiliator_id` = " . AFFILIATOR['id'] . "  ";
        $sql .= " , `client_id` = " . CLIENT['id'] . "  ";
        $sql .= ", `date_added` = '{$this->dateTime}' ";
//        echo $sql; die();

        $id = $this->mDb->queryreturnlastid($sql);

        return $this->allClientShippingAddresses($id);
    }

    public function getClientShipping() {

        $sql = "SELECT id,store_name,store_img,date_added FROM `{$this->mPrefix}client_shipping` ";
        $sql .= "WHERE `affiliator_id`='" . AFFILIATOR['id'] . "' and client_id = '" . CLIENT['id'] . "' ";
        $res = $this->mDb->getRow($sql);
        if ($res) {
            $res['clientAddresses'] = $this->allClientShippingAddresses('', 0, 10);
        }
        return $res;
    }

    public function getCustomerPrice($id) {

        $sql = "SELECT price FROM `{$this->mPrefix}shipping_methods_governorate_customer_price` ";
        $sql .= "WHERE `affiliator_id`='" . AFFILIATOR['id'] . "' and p_id = '{$id}' ";
//        echo $sql . "<hr>";
        $res = $this->mDb->getOne($sql);

        return ($res === false || $res === null) ? "0" : $res;
    }

    public function getDelivery_price($id) {
//        $sql = "SELECT delivery_price FROM `places` ";
//        $sql .= " WHERE id = '{$id}'  ";
//        $res = $this->mDb->getOne($sql);
//        
//        
//        

        $sql = " SELECT sm.id,sm.default_shipping_method, smg.id gov_id , smg.store_price, sml.name FROM `shipping_methods_governorate` smg ";
        $sql .= " LEFT JOIN `shipping_methods` sm ON sm.id = smg.p_id  ";
        $sql .= " LEFT JOIN `shipping_methods_langs` sml ON sm.id = sml.p_id  AND sml.lang_code = '{$this->lang_code}'  ";
        $sql .= " WHERE smg.governorate_id = '{$id}' AND (sm.default_shipping_method = '1' and sm.active='1' ";
        $sql .= " OR ( sm.default_shipping_method = '0'  AND NOT EXISTS ( ";
        $sql .= " SELECT 1  FROM `shipping_methods_governorate` smg_inner ";
        $sql .= " LEFT JOIN `shipping_methods` sm_inner ON sm_inner.id = smg_inner.p_id  ";
        $sql .= " WHERE smg_inner.governorate_id = '{$id}' AND sm_inner.default_shipping_method = '1' ";
        $sql .= " ))) LIMIT 1 ";

//        $sql = "SELECT sm.id,smg.customer_price,smg.store_price,sml.name FROM `shipping_methods_governorate` smg ";
//        $sql .= " LEFT JOIN `shipping_methods` sm ON sm.id = smg.p_id    ";
//        $sql .= " LEFT JOIN `shipping_methods_langs` sml ON sm.id = sml.p_id  AND sml.lang_code = '{$this->lang_code}'   ";
//        $sql .= " WHERE smg.governorate_id = '{$id}'  and (sm.default_shipping_method='1' || sm.default_shipping_method='0') ";
//        echo $sql . "<hr>";
        $res = $this->mDb->getRow($sql);
        if ($res) {
            $res['customer_price'] = $this->getCustomerPrice($res['gov_id']);
        }

        return $res;
    }

    public function updateCouponUsed($mode_id, $Req) {
        $sql = " UPDATE `coupons_used` SET `mode` = 'invoice' , `mode_id` = '{$mode_id}'";
        $sql .= " WHERE   `mode` = 'cart' AND `mode_id` = '{$Req['cart_id']}' ";

        $sql .= $balance['user_id'] ? "AND `user_id` = '{$balance['user_id']}' " : ' ';
// echo $sql; die();
        return $this->mDb->query($sql);
    }

    public function getBalanceAll($temp) {
        $sql = "SELECT b.*  ";
        $sql .= " FROM `{$this->mPrefix}balance` b ";
//        $sql .= " LEFT JOIN `invoices` i ON i.id = b.invoice_id ";
        $sql .= " WHERE b.id>0  AND b.client_id = " . CLIENT['id'] . " and b.affiliator_id = " . AFFILIATOR['id'] . " ";
        $sql .= $temp['id'] ? "  AND b.id='{$temp['id']}' " : "";
        $sql .= " ORDER BY b.`id` DESC ";
        $sql .= $temp['aLimit'] ? "LIMIT {$temp['aStart']}, {$temp['aLimit']}" : '';
        return $this->mDb->getAll($sql);
    }

    public function getBalanceSum() {
        if (CLIENT['id']) {
            $sql = "SELECT value,type FROM `{$this->mPrefix}balance` ";
            $sql .= "WHERE client_id = " . CLIENT['id'] . " and affiliator_id = " . AFFILIATOR['id'] . " ";
//            echo $sql . "<hr>";
            $res = $this->mDb->getAll($sql);
            foreach ($res as $key => $value) {
                if ($value['type'] == 'add') {
                    $add[] = $value['value'];
                } else if ($value['type'] == 'get') {
                    $get[] = $value['value'];
                } else if ($value['type'] == 'get_balance') {
                    $get_balance[] = $value['value'];
                } else if ($value['type'] == 'hanging') {
                    $hanging[] = $value['value'];
                }
            }

            $data['hanging'] = array_sum($hanging);
            $data['total_price'] = (array_sum($add) - array_sum($get) - array_sum($get_balance));

// $data['save_insure'] = number_format($data['save_insure'], 2, '.', '');
// $data['save_cobon'] = number_format($data['save_cobon'], 2, '.', '');
            $data['hanging'] = number_format($data['hanging'], 2, '.', '');
            $data['total_price'] = number_format($data['total_price'], 2, '.', '');
        }

        return $data;
    }

    public function deleteAccount() {

        $sql = " UPDATE `users` SET `is_deleted` = '1'";
        $sql .= "WHERE id= '" . CLIENT['id'] . "' ";

        return $this->mDb->query($sql);
    }

    public function deleteSubscriptionItemsByInvoice($data) {

        $sql2 = "DELETE FROM `master_subscription` ";
        $sql2 .= " WHERE `dealer_id` = '{$data['dealer_id']}' and  transaction_id ='{$data['transaction_id']}'  and  count_invoice_type ='{$data['count_invoice_type']}'";

        return $this->masterDb->query($sql2);
    }

    public function addSubscriptions($temp) {

        $sql = "INSERT INTO `master_subscription` SET ";
        foreach ($this->masterDb->getCols('master_subscription', $temp) as $k => $v) {

            $sql .= ( $k == 'date_added' || $k == 'id') ? "" : "`{$k}`='{$v}',";
        }

        $sql .= " `date_added` = '{$this->dateTime}' ";
//            echo $sql . "<hr>";

        return $this->masterDb->queryreturnlastid($sql);
    }

    public function getSubscriptionPeriod($dealer_id) {

        $sql = " SELECT  md.subscription_type,md.commission_rate,md.commission_value,md.minimum_commission,md.maximum_commission,";
        $sql .= " MIN(CASE WHEN md.subscription_type = 'period' AND ms.subscription_date_to >= NOW() THEN ms.subscription_date_from END) as subscription_date_from,";
        $sql .= " MAX(CASE WHEN md.subscription_type = 'period' AND ms.subscription_date_to >= NOW() THEN ms.subscription_date_to END) as subscription_date_to";
        $sql .= " FROM master_dealers md ";
        $sql .= " LEFT JOIN  master_subscription ms ON md.id = ms.dealer_id ";
        $sql .= " WHERE  md.id = '{$dealer_id}'";
        $sql .= " GROUP BY  md.subscription_type;";
//        $sql = "SELECT (SELECT md.subscription_type FROM `{$this->mPrefix}master_dealers` md  WHERE md.id =ms.dealer_id ) as subscription_type ,ms.`subscription_date_from`,MAX(ms.`subscription_date_to`) as subscription_date_to FROM `{$this->mPrefix}master_subscription` ms  ";
//        $sql .= " WHERE ms.dealer_id ='{$dealer_id}' and ms.subscription_date_to >=NOW() ";
//        echo $sql."<hr>";
        return $this->masterDb->getRow($sql);
    }

    public function getBalanceSumByDealer($dealer_id, $id = '') {

        $sql = "SELECT amount,transaction_type FROM `{$this->mPrefix}master_subscription` ";
        $sql .= "WHERE dealer_id ='{$dealer_id}' and transaction_type IN('add_balance','commission_discount','get_balance') ";
        $sql .= $id ? " and id <= '{$id}' " : "";
//            echo $sql . "<hr>";
        $res = $this->masterDb->getAll($sql);
        if ($res) {
            foreach ($res as $key => $value) {
                if ($value['transaction_type'] === 'add_balance') {
                    $add_balance[] = $value['amount'];
                } else if ($value['transaction_type'] === 'commission_discount') {
                    $commission_discount[] = $value['amount'];
                } else if ($value['transaction_type'] === 'get_balance') {
                    $get_balance[] = $value['amount'];
                }
            }

            $balance = array_sum($add_balance ?? []) - array_sum($commission_discount ?? []) - array_sum($get_balance ?? []);
            return $balance;
        } else {
            return $res;
        }
    }

//$qqq = " select `p`.`id` AS `product_id`,`ps`.`store_id` AS `store_id`,`ps`.`name` AS `name`,`sl`.`title` AS `store_title`
//,(coalesce((select sum(`psa`.`value`) from `product_stores` `psa`
//LEFT JOIN `stores` s ON s.id = psa.store_id  
//where ((`psa`.`product_id` = `p`.`id`) and (`psa`.`store_id` = `ps`.`store_id`) and (`psa`.`type` = 'add') and (`psa`.`is_deleted` = '0') and (s.show_store_amounts='1'))),0)
//- coalesce((select sum(`psr`.`value`) from `product_stores` `psr`
//LEFT JOIN `stores` s ON s.id = psr.store_id
//where ((`psr`.`product_id` = `p`.`id`) and (`psr`.`store_id` = `ps`.`store_id`) and (`psr`.`type` = 'remove') and (`psr`.`is_deleted` = '0')and (s.show_store_amounts='1'))),0)) AS `store_amounts` 
//from ((`products` `p` 
//left join `product_stores` `ps` on(((`ps`.`product_id` = `p`.`id`) and (`ps`.`is_deleted` = '0'))))
//left join `store_langs` `sl` on(((`sl`.`store_id` = `ps`.`store_id`) and (`sl`.`lang_code` = 'ar'))))
//group by `p`.`id`,`ps`.`store_id`";


    public function checkAndAddUser($data) {
        $data['mobile'] = trim($data['mobile']);
        $sql = "SELECT id FROM `users` ";
        $sql .= " WHERE (`mobile` = '{$data['mobile']}' || `email` = '{$data['mobile']}') AND ((`affiliator_id` = " . AFFILIATOR['id'] . " AND `user_level` = '3000') ) ";
        $sql .= " and is_deleted ='0'";
//       echo $sql . "<hr>";
        $res = $this->mDb->getRow($sql);
        if (!$res['id']) {
            $data['active'] = AFFILIATOR['options']['show_price'] != '1' ? '0' : '1';
            $data['price_type'] = AFFILIATOR['price_type'];
            $data['user_type'] = 'client';
            $data['user_name'] = trim($data['user_name']);
            $data['password'] = $data['mobile'];

            $res = $this->signUp($data);
        } else {

            if ($data['country_id'] && ($data['city_id'] || $data['district_id'])) {
                $data['client_id'] = $res['id'];
//                $temp['is_default'] = '1';
                $AddresseId = $this->getClientAddressesIdByData($data);
                if (!$AddresseId) {
                    $this->addClientAddresses($data);
                } else {
                    $this->editClientAddresses($data, $AddresseId);
                }
            }

            $res = $this->getUserDetailsInfo($res['id'], $AddresseId);
        }

        return $res;
    }

    public function getAllAffiliators($aStart, $aLimit, $sort, $type, $searchName) {
        $sql = "SELECT DISTINCT u.id,  u.user_name, u.price_type ";
        $sql .= " FROM `users` u ";
        $sql .= " WHERE u.id > 0";
        $sql .= " AND u.`user_level` = '1000'";
        $sql .= $searchName ? ' AND u.user_name like "%' . $searchName . '%"' : '';
        $sql .= " AND u.`active` = '1' ";
        $sql .= " GROUP BY u.`id`";
        $sql .= " ORDER BY {$sort} {$type}";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        $res = $this->mDb->getAll($sql);
        return $res;
    }
}
