<?php

$notifyObj = new notifications();

class notifications {

    private $mDb;
    private $userObj;
    private $mConfig;
    private $lang;
    private $dateTime;
    private $pushNotify;
    private $lang_code;
    private $mPrefix;

    public function __construct() {
        global $Config;

        // تهيئة الكائنات
        $this->mDb = new iplus();
        $this->userObj = new Users();
        $this->mConfig = $Config;
        $this->pushNotify = new PushMessage();

        // تعيين القيم
        $this->lang_code = LANGUAGE;
        $this->dateTime = date('Y-m-d H:i:s');
        $this->mPrefix = $Config['prefix'];
    }

    function sendNewNotification($temp) {
        // echo $temp; die();
        //    echo "<pre>";print_r($temp); die();

        if ($temp['send_user_id'] != $temp['receive_user_id']) {
            $sql = "INSERT INTO `{$this->mPrefix}notification` SET ";
            foreach ($this->mDb->getCols('notification', $temp) as $k => $v) {
                $sql .= ($k == 'message' || $k == 'order_title' || $k == 'order_id' || $k == 'avatar' || $k == 'user_name' || $k == 'to') ? ' ' : "{$k}='{$v}',";
            }
            $sql .= "date_added='{$this->dateTime}'";
//            echo $sql . "<hr>";

            $res = $this->mDb->query($sql);
            if ($res) {

                $id = $this->mDb->getLastInsertId();

                $res2 = $this->getUserDevicesToken($temp['receive_user_id']);

                $unReadMessage = $this->getUnReadNotificationNum($temp['receive_user_id']);
                // echo "<pre>";print_r($res2); die();
                if ($res2) {
                    foreach ($res2 as $value) {
                        $arr['data']['notification_id'] = $id;
                        $arr['data']['notification_type'] = $temp['page_type'];
                        $arr['data']['url'] = $temp['url'];
                        $arr['data']['msgcnt'] = $unReadMessage;
                        $arr['data']['notifiy_message'] = $this->makeNotificationMessage($value['lang_code'], $temp);
                        $arr['device_token_id'] = $value['device_token_id'];
                        $arr['platform_type'] = $value['type'];
                        // print_r($arr); die();
                        $pushed = $this->pushNotify->sendMessage($arr);
                        //echo $pushed;die();
                    }
                }
            }
            return $res;
        }
    }

    function sendNotificationType($req) {

        if ($req['notificationType'] == 'invoice_status') {
            $addNotSend['url'] = $req['invoice_id'];
            $addNotSend['page_type'] = $req['notificationType'];
            $addNotSend['receive_user_id'] = $req['client_id'];

            $addNotSend['page_status'] = $req['page_status'];
            $addNotSend['count_invoice_type'] = $req['count_invoice_type'];

            $this->sendNewNotification($addNotSend);
        }
    }

    function getSenderUserName($aUserId) {
        $sql = "SELECT user_name FROM `{$this->mPrefix}users`";
        $sql .= "WHERE `id`='{$aUserId}' ";
        //echo $sql;die();
        return $this->mDb->getOne($sql);
    }

    function getUserDevicesToken($aUserId) {
        $sql = "SELECT  dt.`id` as deviceID, dt.`type`, dt.`device_token_id` , d.lang_code, ao.notification_file_json FROM `{$this->mPrefix}devices` d";
        $sql .= " LEFT JOIN `{$this->mPrefix}device_token` dt ON (dt.id = d.device_token_id) ";
        $sql .= " LEFT JOIN `{$this->mPrefix}affiliator_options` ao ON (ao.user_id = d.affiliator_id ) ";
        $sql .= "WHERE d.`user_id`='{$aUserId}' ";
        $sql .= "AND d.`login`='1' ";
        // echo $sql;die();
        return $this->mDb->getAll($sql);
    }

    function updateNotifyStatus($aId) {

        $sql = "UPDATE `{$this->mPrefix}notification` SET ";
        $sql .= "`status`= '1' ";
        $sql .= "WHERE `id`='{$aId}' and receive_user_id = '" . CLIENT['id'] . "' ";
        //echo $sql;die();
        return $this->mDb->query($sql);
    }

    function getUnReadNotificationNum($aUserId) {
        $sql = " SELECT count(id)  FROM `{$this->mPrefix}notification`";
        $sql .= " WHERE `receive_user_id` = '{$aUserId}'";
        $sql .= " AND `status` = '0'";
        //echo $sql; die();
        return $this->mDb->getOne($sql);
    }

    public function getNotificationsList($aUserId, $aStart = 0, $aLimit = 0) {

        $sql = " SELECT 
                    n.url , 
                    n.date_added , 
                    n.status , 
                    n.id,n.page_status  , 
                    n.page_type 
                FROM `notification` n
                WHERE n.receive_user_id = :user_id
                ORDER BY n.date_added DESC ";
        $sql .= $aLimit ? " LIMIT {$aStart}, {$aLimit}" : '';
        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':user_id', $aUserId, PDO::PARAM_INT);
        $stmt->execute();
        $res = $stmt->fetchAll(PDO::FETCH_ASSOC);
        if (count($res) > 0) {
            foreach ($res as &$notification) {
                $notification['image'] = null;
                $notification['title'] = null;
                $notification['content'] = null;
                if ($notification['page_type'] == 'admin_notification') {
                    $admin_notification = $this->getNotificationAdmin_notificationContent($notification['url']);
                    //$notification['admin_notification_content'] = trim( strip_tags(str_replace(array("&nbsp;", "&nbsp;"), " ", $admin_notification['admin_notification_content'] )));
                    $notification['admin_notification_content'] = frist_trim_text($admin_notification['admin_notification_content'], 125, true);
                    $notification['admin_notification_title'] = $admin_notification['admin_notification_title'];
                    $notification['title'] = $notification['admin_notification_title'];
                    $notification['content'] = $notification['admin_notification_content'];
                    $notification['image'] = '';
                    // unset($notification['order_title']) ;
                } else if ($notification['page_type'] == 'productAvailable') {
                    $product = $this->getProductnameById($notification['url']);
                    $notification['title'] = $this->lang_code == 'ar' ? 'انتهى وقت الانتظار .. متوفر الان!' : 'The waiting time is over.. Available now!';
                    $notification['content'] = $product['name'];
                    $notification['image'] = $product['image'];
                } else if ($notification['page_type'] == 'invoice_status') {
                    global $invoicesObj;
                    $notification['count_invoice_type'] = $invoicesObj->getInvoiceCountInvoiceType($notification['url']);
                    $notification['title'] = $this->lang_code == 'ar' ? 'تحديث حالة الطلب ' : 'Update order status';

                    if ($notification['page_status'] == 'pending') {
                        $notification['content'] = $this->lang_code == 'ar' ? 'تم استلام طلبك رقم (' . $notification['count_invoice_type'] . ') بنجاح!.. تابع تحديث حالة الطلب' : 'Your request No. (' . $notification['count_invoice_type'] . ') has been successfully received! .. Continue to update the status of the order';
                    } else if ($notification['page_status'] == 'waiting_confirm') {
                        $notification['content'] = $this->lang_code == 'ar' ? 'جاري التحقق من طلبك رقم (' . $notification['count_invoice_type'] . ')' : 'Verifying your request No. (' . $notification['count_invoice_type'] . ')';
                    } else if ($notification['page_status'] == 'confirmed') {
                        $notification['content'] = $this->lang_code == 'ar' ? 'تم تأكيد طلبك رقم (' . $notification['count_invoice_type'] . ')' : 'Your order number has been confirmed (' . $notification['count_invoice_type'] . ')';
                    } else if ($notification['page_status'] == 'client_not_responce') {
                        $notification['content'] = $this->lang_code == 'ar' ? 'حاول فريق خدمة العملاء التواصل معكم .. يرجى التواصل معنا فى اقرب وقت' : 'The customer service team tried to contact you. Please contact us as soon as possible';
                    } else if ($notification['page_status'] == 'delivery_failed') {
                        $notification['content'] = $this->lang_code == 'ar' ? 'مندوب التوصيل حاول الاتصال بكم هاتفيا .. نرجوا الرد على المندوب' : 'The delivery representative tried to contact you by phone. Please respond to the representative';
                    } else if ($notification['page_status'] == 'under_prepare') {
                        $notification['content'] = $this->lang_code == 'ar' ? 'أخبار جيدة! ... جارى تجهيز و تغليف طلبك رقم (' . $notification['count_invoice_type'] . ')' : 'good news! ... Your request No. (' . $notification['count_invoice_type'] . ') is being processed.';
                    } else if ($notification['page_status'] == 'prepared') {
                        $notification['content'] = $this->lang_code == 'ar' ? 'أخبار جيدة! ... تم تجهيز و تغليف طلبك رقم (' . $notification['count_invoice_type'] . ')' : 'good news! ... Your request No. (' . $notification['count_invoice_type'] . ') It has been prepared.';
                    } else if ($notification['page_status'] == 'ready_to_delivered') {
                        $notification['content'] = $this->lang_code == 'ar' ? 'أخبار جيدة! ... طلبك رقم (' . $notification['count_invoice_type'] . ') جاهز للشحن , ستقوم شركة الشحن قريبا باستلام طلبك وتوصيله اليك' : 'good news! ... Your order No. (' . $notification['count_invoice_type'] . ') is ready for shipment';
                    } else if ($notification['page_status'] == 'in_delivered') {
                        $notification['content'] = $this->lang_code == 'ar' ? 'أخبار جيدة! ... طلبك رقم (' . $notification['count_invoice_type'] . ') قيد التوصيل' : 'good news! ... Your order No. (' . $notification['count_invoice_type'] . ') is in progress';
                    } else if ($notification['page_status'] == 'delivered') {
                        $notification['content'] = $this->lang_code == 'ar' ? 'شكرا لاستلامك الطلب رقم (' . $notification['count_invoice_type'] . ') نسعد بخدمتكم!' : 'Thank you for receiving order No. (' . $notification['count_invoice_type'] . ') We are happy to serve you!';
                    } else if ($notification['page_status'] == 'canceled') {
                        $notification['content'] = $this->lang_code == 'ar' ? 'نأسف لذلك!.. تم الغاء طلبكم رقم (' . $notification['count_invoice_type'] . ')' : "We're sorry!.. Your order No. (" . $notification['count_invoice_type'] . ") has been cancelled.";
                    } else if ($notification['page_status'] == 'booked_up') {
                        $notification['content'] = $this->lang_code == 'ar' ? 'طلبك رقم (' . $notification['count_invoice_type'] . ') محجوز الان! .. لن يتم شحن الطلب حتى تقوم بتأكيد الشحن' : "Your order number (" . $notification['count_invoice_type'] . ") is now reserved! .. Not shipped until you confirm shipment ";
                    }

                    $notification['image'] = '';
                }
            }
        }
        return $res;
    }

    function getNotificationAdmin_notificationContent($admin_notification_id) {
        $sql = " SELECT  nl.notification as admin_notification_content , nl.title as admin_notification_title  FROM `{$this->mPrefix}admin_notification_langs` nl   ";
        $sql .= " WHERE nl.admin_notification_id = '{$admin_notification_id}'  AND nl.lang_code = '{$this->lang_code}' ";
        //  echo "$sql ";die();
        $res = $this->mDb->getRow($sql);

        return $res;
    }

    function getNotificationDetails($id, $user_id) {

        $sql = " SELECT  n.id , nl.notification as admin_notification_content , nl.title as admin_notification_title FROM `notification` n ";

        $sql .= " LEFT JOIN `users` u ON u.`id` = n.`receive_user_id`";
        $sql .= " LEFT JOIN `admin_notification_langs` nl ON nl.`admin_notification_id` = n.`url`";

        $sql .= " WHERE n.`id` = '{$id}' AND  n.`receive_user_id` = '{$user_id}'   AND nl.lang_code = '{$this->lang_code}'  ";
        // echo "$sql";die();
        return $this->mDb->getRow($sql);
    }

    // function  sendNotificationByType($req){
    //        // echo $sql; die();
    //         if ($req['page_type'] == 'addBooking') {
    //                 $addNotSend['send_user_id'] = $req['from'];
    //                 $addNotSend['url']       = $req['order_id'];
    //                 $addNotSend['page_type'] = $req['notificationType'];
    //                 $addNotSend['receive_user_id'] = $req['to'];
    //                  $this->sendNewNotification($addNotSend);
    //          }
    //  }

    public function makeNotificationMessage($lang_code, $temp) {

        if ($temp['page_type'] == 'admin_notification') {
            $message = $lang_code == 'ar' ? $temp['arTitle'] : $temp['enTitle'];
        } else if ($temp['page_type'] == 'invoice_status') {
            if ($temp['page_status'] == 'pending') {
                $message = $lang_code == 'ar' ? 'تم استلام طلبك رقم (' . $temp['count_invoice_type'] . ') بنجاح!.. تابع تحديث حالة الطلب' : 'Your request No. (' . $temp['count_invoice_type'] . ') has been successfully received! .. Continue to update the status of the order';
            } else if ($temp['page_status'] == 'waiting_confirm') {
                $message = $lang_code == 'ar' ? 'جاري التحقق من طلبك رقم (' . $temp['count_invoice_type'] . ')' : 'Verifying your request No. (' . $temp['count_invoice_type'] . ')';
            } else if ($temp['page_status'] == 'confirmed') {
                $message = $lang_code == 'ar' ? 'تم تأكيد طلبك رقم (' . $temp['count_invoice_type'] . ')' : 'Your order number has been confirmed (' . $temp['count_invoice_type'] . ')';
            } else if ($temp['page_status'] == 'client_not_responce') {
                $message = $lang_code == 'ar' ? 'قام مندوبنا بمحاولة التواصل معكم هاتفيا .. نرجو الرد على مندوبنا' : 'Our representative has tried to contact you by phone.. Please reply to our representative';
            } else if ($temp['page_status'] == 'under_prepare') {
                $message = $lang_code == 'ar' ? 'أخبار جيدة! ... جارى تجهيز و تغليف طلبك رقم (' . $temp['count_invoice_type'] . ')' : 'good news! ... Your request No. (' . $temp['count_invoice_type'] . ') is being processed.';
            } else if ($temp['page_status'] == 'ready_to_delivered') {
                $message = $lang_code == 'ar' ? 'أخبار جيدة! ... طلبك رقم (' . $temp['count_invoice_type'] . ') جاهز للشحن , ستقوم شركة الشحن باستلام طلبك قريبا و توصيله اليك' : 'good news! ... Your order No. (' . $temp['count_invoice_type'] . ') is ready for shipment';
            } else if ($temp['page_status'] == 'in_delivered') {
                $message = $lang_code == 'ar' ? 'أخبار جيدة! ... طلبك رقم (' . $temp['count_invoice_type'] . ') قيد التوصيل' : 'good news! ... Your order No. (' . $temp['count_invoice_type'] . ') is in progress';
            } else if ($temp['page_status'] == 'delivered') {
                $message = $lang_code == 'ar' ? 'شكرا لاستلامك الطلب رقم (' . $temp['count_invoice_type'] . ') نسعد بخدمتكم!' : 'Thank you for receiving order No. (' . $temp['count_invoice_type'] . ') We are happy to serve you!';
            } else if ($temp['page_status'] == 'canceled') {
                $message = $lang_code == 'ar' ? 'نأسف لذلك!.. تم الغاء طلبكم رقم (' . $temp['count_invoice_type'] . ')' : "We're sorry!.. Your order No. (" . $temp['count_invoice_type'] . ") has been cancelled.";
            }
        }
        return $message;
    }

//    function makeNotificationMessage($lang_code, $temp) {
//
//        $sender_name = $this->getSenderUserName($temp['send_user_id']);
//        if ($temp['page_type'] == 'addOrder') {
//            $message = $lang_code == 'ar' ? 'قام  ' . $sender_name . ' باضافة طلب جديد   : ' . $temp['cat_name'] : $sender_name . ' add new order : ';
//        } elseif ($temp['page_type'] == 'acceptOrder') {
//            $message = $lang_code == 'ar' ? 'قام  ' . $sender_name . 'بقبول طلبك  : ' . $temp['cat_name'] : $sender_name . ' add new offer on your order   ';
//        } elseif ($temp['page_type'] == 'completeOrder') {
//            $message = $lang_code == 'ar' ? 'قام  ' . $sender_name . 'بانهاء الطلب  : ' . $temp['cat_name'] : $sender_name . ' add new offer on your order   ';
//        }
//
//        return $message;
//    }
    //  aditional functrion 


    function getPlaceIdByBookingId($booking_id) {
        $sql = " SELECT    pl_booking_id FROM `{$this->mPrefix}bookings`  where id ='{$booking_id}'  ";
        return $this->mDb->getOne($sql);
    }

    public function deleteNotificationById($notification_id) {
        $sql = " DELETE FROM `{$this->mPrefix}notification` ";
        $sql .= " WHERE `id` = '{$notification_id}' and receive_user_id = '" . CLIENT['id'] . "' ";
        $res = $this->mDb->query($sql);
        return $res;
    }

    public function getProductnameById($product_id) {
        $sql = "SELECT  name  FROM product_langs    ";
        $sql .= " WHERE product_id  ='{$product_id}' AND   lang_code = '{$this->lang_code}' ";

        $res = $this->mDb->getRow($sql);
        if ($res) {
            $res['images'] = $this->getProductimgs($product_id);
            $res['image'] = $res['images'][0]['name'];
        }
        return $res;
    }

    public function getProductimgs($id, $aLimit = '') {
        $sql = "SELECT name ,type,date_added   FROM product_medias  ";
        $sql .= " WHERE `product_id` = '{$id}'   ";
        $sql .= $aLimit ? " LIMIT  0, {$aLimit} " : '';

        return $this->mDb->getAll($sql);
    }
}
